<?php
/***************************************************************************
 *                               groupcp.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: groupcp.php,v 1.58.2.18 2003/06/10 17:18:13 acydburn Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);


//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_GROUPCP);
init_userprefs($userdata);
//
// End session management
//

$script_name = preg_replace('/^\/?(.*?)\/?$/', "\\1", trim($board_config['script_path']));
$script_name = ( $script_name != '' ) ? $script_name . '/groupcp.'.$phpEx : 'groupcp.'.$phpEx;
$server_name = trim($board_config['server_name']);
$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';

$server_url = $server_protocol . $server_name . $server_port . $script_name;
$group_id = $xml->getTagAttribute('group_id');
$wndId = $xml->getTagAttribute('wndId');

//this varaible might be used to create paging
//$start = ( isset($HTTP_GET_VARS['start']) ) ? intval($HTTP_GET_VARS['start']) : 0;
$start = 0;

//
// Default var values
//
$is_moderator = FALSE;
if ( $group_id )
{
	//
	// Did the group moderator get here through an email?
	// If so, check to see if they are logged in.
	//

	//
	// For security, get the ID of the group moderator.
	//
	switch(SQL_LAYER)
	{
		case 'postgresql':
			$sql = "SELECT g.group_moderator, g.group_type, aa.auth_mod
				FROM " . GROUPS_TABLE . " g, " . AUTH_ACCESS_TABLE . " aa
				WHERE g.group_id = $group_id
					AND aa.group_id = g.group_id
					UNION (
						SELECT g.group_moderator, g.group_type, NULL
						FROM " . GROUPS_TABLE . " g
						WHERE g.group_id = $group_id
							AND NOT EXISTS (
							SELECT aa.group_id
							FROM " . AUTH_ACCESS_TABLE . " aa
							WHERE aa.group_id = g.group_id
						)
					)";
			break;

		case 'oracle':
			$sql = "SELECT g.group_moderator, g.group_type, aa.auth_mod
				FROM " . GROUPS_TABLE . " g, " . AUTH_ACCESS_TABLE . " aa
				WHERE g.group_id = $group_id
					AND aa.group_id = g.group_id(+)";
			break;

		default:
			$sql = "SELECT g.group_moderator, g.group_type, aa.auth_mod
				FROM ( " . GROUPS_TABLE . " g
				LEFT JOIN " . AUTH_ACCESS_TABLE . " aa ON aa.group_id = g.group_id )
				WHERE g.group_id = $group_id";
			break;
	}
	if ( !($result = $db->sql_query($sql)) )
	{
        alert("error", 'Could not select moderator information', "iconError");
	}

	if ( $group_info = $db->sql_fetchrow($result) )
	{
		$group_moderator = $group_info['group_moderator'];

		if ( $group_moderator == $userdata['user_id'] || $userdata['user_level'] == ADMIN )
		{
			$is_moderator = TRUE;
		}

	}
	else
	{
        alert("info", htmlentities($lang['No_groups_exist']), "iconInfo");
	}

	//
	// Get group details
	//
	$sql = "SELECT *
		FROM " . GROUPS_TABLE . "
		WHERE group_id = $group_id
			AND group_single_user = 0";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Error getting group information', '', __LINE__, __FILE__, $sql);
	}

	if ( !($group_info = $db->sql_fetchrow($result)) )
	{
		 alert("info", htmlentities($lang['Group_not_exist']), "iconInfo");
	}

	//
	// Get moderator details for this group
	//
	$sql = "SELECT username, user_id, user_viewemail, user_posts, user_regdate, user_from, user_website, user_email, user_icq, user_aim, user_yim, user_msnm
		FROM " . USERS_TABLE . "
		WHERE user_id = " . $group_info['group_moderator'];
	if ( !($result = $db->sql_query($sql)) )
	{
        alert("error", 'Error getting user list for group', "iconError");
	}

	$group_moderator = $db->sql_fetchrow($result);

	//
	// Get user information for this group
	//
	$sql = "SELECT u.username, u.user_id, u.user_viewemail, u.user_posts, u.user_regdate, u.user_from, u.user_website, u.user_email, u.user_icq, u.user_aim, u.user_yim, u.user_msnm, ug.user_pending
		FROM " . USERS_TABLE . " u, " . USER_GROUP_TABLE . " ug
		WHERE ug.group_id = $group_id
			AND u.user_id = ug.user_id
			AND ug.user_pending = 0
			AND ug.user_id <> " . $group_moderator['user_id'] . "
		ORDER BY u.username";
	if ( !($result = $db->sql_query($sql)) )
	{
		alert("error", 'Error getting user list for group', "iconError");
	}

	$group_members = $db->sql_fetchrowset($result);
	$members_count = count($group_members);
	$db->sql_freeresult($result);

	$sql = "SELECT u.username, u.user_id, u.user_viewemail, u.user_posts, u.user_regdate, u.user_from, u.user_website, u.user_email, u.user_icq, u.user_aim, u.user_yim, u.user_msnm
		FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug, " . USERS_TABLE . " u
		WHERE ug.group_id = $group_id
			AND g.group_id = ug.group_id
			AND ug.user_pending = 1
			AND u.user_id = ug.user_id
		ORDER BY u.username";
	if ( !($result = $db->sql_query($sql)) )
	{
        alert("error", 'Error getting user pending information', "iconError");
	}

	$modgroup_pending_list = $db->sql_fetchrowset($result);
	$modgroup_pending_count = count($modgroup_pending_list);
	$db->sql_freeresult($result);

	$is_group_member = 0;
	if ( $members_count )
	{
		for($i = 0; $i < $members_count; $i++)
		{
			if ( $group_members[$i]['user_id'] == $userdata['user_id'] && $userdata['session_logged_in'] )
			{
				$is_group_member = TRUE;
			}
		}
	}

	$is_group_pending_member = 0;
	if ( $modgroup_pending_count )
	{
		for($i = 0; $i < $modgroup_pending_count; $i++)
		{
			if ( $modgroup_pending_list[$i]['user_id'] == $userdata['user_id'] && $userdata['session_logged_in'] )
			{
				$is_group_pending_member = TRUE;
			}
		}
	}

	if ( $userdata['user_level'] == ADMIN )
	{
		$is_moderator = TRUE;
	}

	if ( $userdata['user_id'] == $group_info['group_moderator'] )
	{
		$is_moderator = TRUE;

		$group_details =  $lang['Are_group_moderator'];

		$s_hidden_fields = '<input type="hidden" name="' . POST_GROUPS_URL . '" value="' . $group_id . '" />';
	}
	else if ( $is_group_member || $is_group_pending_member )
	{
		$template->assign_block_vars('switch_unsubscribe_group_input', array());

		$group_details =  ( $is_group_pending_member ) ? $lang['Pending_this_group'] : $lang['Member_this_group'];

		$s_hidden_fields = '<input type="hidden" name="' . POST_GROUPS_URL . '" value="' . $group_id . '" />';
	}
	else if ( $userdata['user_id'] == ANONYMOUS )
	{
		$group_details =  $lang['Login_to_join'];
		$s_hidden_fields = '';
	}
	else
	{
		if ( $group_info['group_type'] == GROUP_OPEN )
		{
			$template->assign_block_vars('switch_subscribe_group_input', array());

			$group_details =  $lang['This_open_group'];
			$s_hidden_fields = '<input type="hidden" name="' . POST_GROUPS_URL . '" value="' . $group_id . '" />';
		}
		else if ( $group_info['group_type'] == GROUP_CLOSED )
		{
			$group_details =  $lang['This_closed_group'];
			$s_hidden_fields = '';
		}
		else if ( $group_info['group_type'] == GROUP_HIDDEN )
		{
			$group_details =  $lang['This_hidden_group'];
			$s_hidden_fields = '';
		}
	}

//	$page_title = $lang['Group_Control_Panel'];
//	include('page_header.'.$phpEx);

	//
	// Add the moderator
	//
	$username = $group_moderator['username'];
	$user_id = $group_moderator['user_id'];

//	($group_moderator, $board_config['default_dateformat'], $is_moderator, $from, $posts, $joined, $poster_avatar, $profile_img, $profile, $search_img, $search, $pm_img, $pm, $email_img, $email, $www_img, $www, $icq_status_img, $icq_img, $icq, $aim_img, $aim, $msn_img, $msn, $yim_img, $yim);

	$s_hidden_fields .= '';
// !!!
    $xml = new XML('bbxml');
	$section = new XMLBranch('section');
	$section->setTagAttribute('action', 'groupi');
	$section->setTagAttribute('wndId', $wndId);

	$group = new XMLBranch('group');
	$group->setTagAttribute('MOD_USERNAME', $username);
    $group->setTagAttribute('user_id', $user_id);
    $group->setTagAttribute('GROUP_DETAILS', $group_details);
    $group->setTagAttribute('GROUP_DESC', $group_info['group_description']);
    $group->setTagAttribute('group_id', $group_id);
    if($is_moderator)
	{
      $group->setTagAttribute('is_mod', '1');
    }
    if($is_group_member == TRUE || $is_group_pending_member == TRUE) //change if we need different business logic
      $group->setTagAttribute('is_member', '1');
    else
      $group->setTagAttribute('is_member', '0');
     $section->addXMLBranch($group);
	//
	// Dump out the remaining users
	//
	for($i = 0; $i < $members_count; $i++)//for($i = $start; $i < min($board_config['topics_per_page'] + $start, $members_count); $i++)
	{
		$username = $group_members[$i]['username'];
		$user_id = $group_members[$i]['user_id'];

//		($group_members[$i], $board_config['default_dateformat'], $is_moderator, $from, $posts, $joined, $poster_avatar, $profile_img, $profile, $search_img, $search, $pm_img, $pm, $email_img, $email, $www_img, $www, $icq_status_img, $icq_img, $icq, $aim_img, $aim, $msn_img, $msn, $yim_img, $yim);

		if ( $group_info['group_type'] != GROUP_HIDDEN || $is_group_member || $is_moderator )
		{
			$row_color = ( !($i % 2) ) ? $theme['td_color1'] : $theme['td_color2'];
			$row_class = ( !($i % 2) ) ? $theme['td_class1'] : $theme['td_class2'];

        	$user = new XMLBranch('user');
        	$user->setTagAttribute('username', $username);
	        $user->setTagAttribute('user_id', $user_id);
	        $section->addXMLBranch($user);

		}
	}


	//
	// We've displayed the members who belong to the group, now we
	// do that pending memebers...
	//
	if ( $is_moderator )
	{
		//
		// Users pending in ONLY THIS GROUP (which is moderated by this user)
		//
		if ( $modgroup_pending_count )
		{
			for($i = 0; $i < $modgroup_pending_count; $i++)
			{
	            $username = $modgroup_pending_list[$i]['username'];
	            $user_id = $modgroup_pending_list[$i]['user_id'];

	            //generate_user_info($modgroup_pending_list[$i], $board_config['default_dateformat'], $is_moderator, $from, $posts, $joined, $poster_avatar, $profile_img, $profile, $search_img, $search, $pm_img, $pm, $email_img, $email, $www_img, $www, $icq_status_img, $icq_img, $icq, $aim_img, $aim, $msn_img, $msn, $yim_img, $yim);

	            $user = new XMLBranch('user');
	            $user->setTagAttribute('username', $username);
	            $user->setTagAttribute('user_id', $user_id);
	            $section->addXMLBranch($user);
			}


		}
	}

	$xml->addXMLBranch($section);
	//include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

	echo  $xml->getXMLString();

}
else
{
	//
	// Show the main groupcp.php screen where the user can select a group.
	//
	// Select all group that the user is a member of or where the user has
	// a pending membership.
	//
    $groups = array();
	if ( $userdata['session_logged_in'] )
	{
		$sql = "SELECT g.group_id, g.group_name, g.group_type, ug.user_pending
			FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug
			WHERE ug.user_id = " . $userdata['user_id'] . "
				AND ug.group_id = g.group_id
				AND g.group_single_user <> " . TRUE . "
			ORDER BY g.group_name, ug.user_id";
		if ( !($result = $db->sql_query($sql)) )
		{
            alert("error", 'Error getting group information', "iconError");
		}

		if ( $row = $db->sql_fetchrow($result) )
		{
			$in_group = array();

			do
			{
				$in_group[] = $row['group_id'];
				if ( $row['user_pending'] )
				{
		          $groups[] = array('member'=>'pending', 'group_id'=>$row['group_id'], 'group_name'=>$row['group_name'], 'ms'=>'p');
				}
				else
				{
		          $groups[] = array('member'=>'yes', 'group_id'=>$row['group_id'], 'group_name'=>$row['group_name'], 'ms'=>'m');
				}
			}
			while( $row = $db->sql_fetchrow($result) );

		}
	}

	//
	// Select all other groups i.e. groups that this user is not a member of
	//
	$ignore_group_sql =	( count($in_group) ) ? "AND group_id NOT IN (" . implode(', ', $in_group) . ")" : '';
	$sql = "SELECT group_id, group_name, group_type
		FROM " . GROUPS_TABLE . " g
		WHERE group_single_user <> " . TRUE . "
			$ignore_group_sql
		ORDER BY g.group_name";
	if ( !($result = $db->sql_query($sql)) )
	{
        alert("error", 'Error getting group information', "iconError");
	}


	while( $row = $db->sql_fetchrow($result) )
	{
		if  ( $row['group_type'] != GROUP_HIDDEN || $userdata['user_level'] == ADMIN )
		{
	      $groups[] = array('member'=>'no', 'group_id'=>$row['group_id'], 'group_name'=>$row['group_name'], 'ms'=>'n');
		}
	}

	if ( count($groups) > 0)//if ( $s_group_list_opt != '' || $s_pending_groups_opt != '' || $s_member_groups_opt != '' )
	{
		//
		// Load and process templates
		//

    $xml = new XML('bbxml');
    $section = new XMLBranch('section');
    $section->setTagAttribute('action', 'groups');
    $section->setTagAttribute('wndId', $wndId);
    //add groups to xml

    for($j = 0; $j < count($groups); $j++)
    {
      $group = new XMLBranch('group');
      $group->setTagAttribute('group_id', $groups[$j]['group_id']);
      $group->setTagAttribute('group_name', $groups[$j]['group_name']);
      $group->setTagAttribute('ms', $groups[$j]['ms']);
      $group->setTagAttribute('member', $groups[$j]['member']);
      $section->addXMLBranch($group);
    }

    $xml->addXMLBranch($section);

    echo  $xml->getXMLString();

	}
	else
	{
        alert("info", htmlentities($lang['No_groups_exist']), "iconInfo");
	}
}
?>