<?php
/***************************************************************************
 *                                index.php
 *                            -------------------
 *   begin                : Saturday, Feb 13, 2001
 *   copyright            : (C) 2001 The phpBB Group
 *   email                : support@phpbb.com
 *
 *   $Id: index.php,v 1.99.2.1 2002/12/19 17:17:40 psotfx Exp $
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

define('IN_PHPBB', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

//tolog("userdata", $userdata);
//
// End session management
//

// Check if there are the groups in the
// the forum

	$sql = "SELECT *FROM " . GROUPS_TABLE . " g
			WHERE  g.group_single_user <> " . TRUE ;

 	if( !($result = $db->sql_query($sql)) )
	{
	    $xml = new XML('bbxml');
    	$section = new XMLBranch('section');
	    $section->setTagAttribute('action', 'error');
	    $section->setTagAttribute('message', 'Could not query groups table');
	    $xml->addXMLBranch($section);
	    echo  $xml->getXMLString();
	    exit;

	}

    $groupsNumber = $db->sql_numrows($result);
    $displayGroups = 0;
    if($groupsNumber > 0)
    	$displayGroups = 1;


//

//
// Start page proper
//
$sql = "SELECT c.cat_id, c.cat_title, c.cat_order
  FROM " . CATEGORIES_TABLE . " c
  ORDER BY c.cat_order";
if( !($result = $db->sql_query($sql)) )
{
    $xml = new XML('bbxml');
    $section = new XMLBranch('section');
    $section->setTagAttribute('action', 'error');
    $section->setTagAttribute('message', 'Could not query categories list');
    $xml->addXMLBranch($section);
    echo  $xml->getXMLString();
    exit;

}

while( $category_rows[] = $db->sql_fetchrow($result) );

if( ( $total_categories = count($category_rows) ) )
{
  //
  // Define appropriate SQL
  //
  switch(SQL_LAYER)
  {
    case 'postgresql':
      $sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
        FROM " . FORUMS_TABLE . " f, " . POSTS_TABLE . " p, " . USERS_TABLE . " u
        WHERE p.post_id = f.forum_last_post_id
          AND u.user_id = p.poster_id
          UNION (
            SELECT f.*, NULL, NULL, NULL, NULL
            FROM " . FORUMS_TABLE . " f
            WHERE NOT EXISTS (
              SELECT p.post_time
              FROM " . POSTS_TABLE . " p
              WHERE p.post_id = f.forum_last_post_id
            )
          )
          ORDER BY cat_id, forum_order";
      break;

    case 'oracle':
      $sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
        FROM " . FORUMS_TABLE . " f, " . POSTS_TABLE . " p, " . USERS_TABLE . " u
        WHERE p.post_id = f.forum_last_post_id(+)
          AND u.user_id = p.poster_id(+)
        ORDER BY f.cat_id, f.forum_order";
      break;

    default:
      $sql = "SELECT f.*, p.post_time, p.post_username, u.username, u.user_id
        FROM (( " . FORUMS_TABLE . " f
        LEFT JOIN " . POSTS_TABLE . " p ON p.post_id = f.forum_last_post_id )
        LEFT JOIN " . USERS_TABLE . " u ON u.user_id = p.poster_id )
        ORDER BY f.cat_id, f.forum_order";
      break;
  }
  if ( !($result = $db->sql_query($sql)) )
  {
    $xml = new XML('bbxml');
    $section = new XMLBranch('section');
    $section->setTagAttribute('action', 'error');
    $section->setTagAttribute('message', 'Could not query forums information');
    $xml->addXMLBranch($section);
    echo  $xml->getXMLString();
    exit;

  }

  $forum_data = array();
  while( $row = $db->sql_fetchrow($result) )
  {
    $forum_data[] = $row;
  }

  if ( !($total_forums = count($forum_data)) )
  {
    $xml = new XML('bbxml');
    $section = new XMLBranch('section');
    $section->setTagAttribute('action', 'message');
    $section->setTagAttribute('message', $lang['No_forums']);
    $xml->addXMLBranch($section);
    echo  $xml->getXMLString();
    exit;
  }

  //
  // Find which forums are visible for this user
  //
  $is_auth_ary = array();
  $is_auth_ary = auth(AUTH_VIEW, AUTH_LIST_ALL, $userdata, $forum_data);

  //
  // Start output of page
  //
  define('SHOW_ONLINE', true);
  $page_title = $lang['Index'];
 // include($phpbb_root_path . 'includes/page_header.'.$phpEx);


  //
  // create the xml that contains the data
  //

	$xml = new XML('bbxml');
	$section = new XMLBranch('section');
	$section->setTagAttribute('action', 'catfor');

  for($i = 0; $i < $total_categories; $i++)
  {
    $cat_id = $category_rows[$i]['cat_id'];

    //
    // Should we display this category/forum set?
    //
    $display_forums = false;

    for($j = 0; $j < $total_forums; $j++)
    {
      if ( $is_auth_ary[$forum_data[$j]['forum_id']]['auth_view'] && $forum_data[$j]['cat_id'] == $cat_id )
      {
        $display_forums = true;
      }
    }

    //
    // Yes, we should, so first dump out the category
    // title, then, if appropriate the forum list
    //
    if ( $display_forums )
    {
    	$category = new XMLBranch('category');
    	$category->setTagAttribute('CAT_ID', $category_rows[$i]['cat_id']);
  	    $category->setTagAttribute('CAT_DESC', htmlentities($category_rows[$i]['cat_title']));


        for($j = 0; $j < $total_forums; $j++)
        {
          if ( $forum_data[$j]['cat_id'] == $cat_id )
          {
            $forum_id = $forum_data[$j]['forum_id'];
            if ( $is_auth_ary[$forum_id]['auth_view'] )
            {
              $posts = $forum_data[$j]['forum_posts'];
              $topics = $forum_data[$j]['forum_topics'];
              $forum = new XMLBranch('forum');
              $forum->setTagAttribute('FORUM_NAME', htmlentities($forum_data[$j]['forum_name']));
	   	      $forum->setTagAttribute('FORUM_DESC', htmlentities($forum_data[$j]['forum_desc']));
		      $forum->setTagAttribute('POSTS', $forum_data[$j]['forum_posts']);
    		  $forum->setTagAttribute('TOPICS', $forum_data[$j]['forum_topics']);
              $forum->setTagAttribute('FORUM_ID', $forum_data[$j]['forum_id']);
              $category->addXMLBranch($forum);

            }
          }
        }

      $section->addXMLBranch($category);
    }

  } // for ... categories

}// if ... total_categories
else
{
    $xml = new XML('bbxml');
    $section = new XMLBranch('section');
    $section->setTagAttribute('action', 'message');
    $section->setTagAttribute('message', htmlentities($lang['No_forums']));
    $xml->addXMLBranch($section);
    echo  $xml->getXMLString();
    exit;
}

$section->setTagAttribute('groups', $displayGroups);
$xml->addXMLBranch($section);

//output the categories and forums to flash

echo  $xml->getXMLString();
?>