<?php
define('IN_PHPBB', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include('bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_post.'.$phpEx);

//
// Check and set various parameters
//
function fbb_submit($mode, &$post_data, &$message, &$meta, &$forum_id, &$topic_id, &$post_id, &$poll_id, &$topic_type, &$bbcode_on, &$html_on, &$smilies_on, &$attach_sig, &$bbcode_uid, &$post_username, &$post_subject, &$post_message, &$poll_title, &$poll_options, &$poll_length)
{
	global $board_config, $lang, $db, $phpbb_root_path, $phpEx;
	global $userdata, $user_ip;

	include($phpbb_root_path . 'includes/functions_search.'.$phpEx);

	$current_time = time();

	if ($mode == 'newtopic' || $mode == 'reply' || $mode == 'editpost')
	{
		//
		// Flood control
		//
		$where_sql = ($userdata['user_id'] == ANONYMOUS) ? "poster_ip = '$user_ip'" : 'poster_id = ' . $userdata['user_id'];
		$sql = "SELECT MAX(post_time) AS last_post_time
			FROM " . POSTS_TABLE . "
			WHERE $where_sql";
		if($result = $db->sql_query($sql)
			&& $row = $db->sql_fetchrow($result)
			&& intval($row['last_post_time']) > 0 && ($current_time - intval($row['last_post_time'])) < intval($board_config['flood_interval']))
        alert("error", $lang['Flood_Error'], "iconError");
	}
	if($mode == 'editpost') remove_search_post($post_id);
	if($mode == 'newtopic' || ($mode == 'editpost' && $post_data['first_post']))
	{
		$topic_vote = (!empty($poll_title) && count($poll_options) >= 2) ? 1 : 0;
		$sql  = ($mode != "editpost") ? "INSERT INTO " . TOPICS_TABLE . " (topic_title, topic_poster, topic_time, forum_id, topic_status, topic_type, topic_vote) VALUES ('$post_subject', " . $userdata['user_id'] . ", $current_time, $forum_id, " . TOPIC_UNLOCKED . ", $topic_type, $topic_vote)" : "UPDATE " . TOPICS_TABLE . " SET topic_title = '$post_subject', topic_type = $topic_type " . (($post_data['edit_vote'] || !empty($poll_title)) ? ", topic_vote = " . $topic_vote : "") . " WHERE topic_id = $topic_id";
		if(!$db->sql_query($sql))
			alert('error', 'Error in posting<br/>' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');
		if($mode == 'newtopic') $topic_id = $db->sql_nextid();
	}

	$edited_sql = ($mode == 'editpost' && !$post_data['last_post'] && $post_data['poster_post']) ? ", post_edit_time = $current_time, post_edit_count = post_edit_count + 1 " : "";
	$sql = ($mode != "editpost") ? "INSERT INTO " . POSTS_TABLE . " (topic_id, forum_id, poster_id, post_username, post_time, poster_ip, enable_bbcode, enable_html, enable_smilies, enable_sig) VALUES ($topic_id, $forum_id, " . $userdata['user_id'] . ", '$post_username', $current_time, '$user_ip', $bbcode_on, $html_on, $smilies_on, $attach_sig)" : "UPDATE " . POSTS_TABLE . " SET post_username = '$post_username', enable_bbcode = $bbcode_on, enable_html = $html_on, enable_smilies = $smilies_on, enable_sig = $attach_sig" . $edited_sql . " WHERE post_id = $post_id";
	if(!$db->sql_query($sql, BEGIN_TRANSACTION))
		alert('error', 'Error in posting<br>' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');

	if($mode != 'editpost')
		$post_id = $db->sql_nextid();

	$sql = ($mode != 'editpost') ? "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, post_subject, bbcode_uid, post_text) VALUES ($post_id, '$post_subject', '$bbcode_uid', '$post_message')" : "UPDATE " . POSTS_TEXT_TABLE . " SET post_text = '$post_message',  bbcode_uid = '$bbcode_uid', post_subject = '$post_subject' WHERE post_id = $post_id";
	if(!$db->sql_query($sql))
		alert('error', 'Error in posting<br>' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');

	add_search_words('single', $post_id, stripslashes($post_message), stripslashes($post_subject));

	//
	// Add poll
	//
	if (($mode == 'newtopic' || ($mode == 'editpost' && $post_data['edit_poll'])) && !empty($poll_title) && count($poll_options) >= 2)
	{
		$sql = (!$post_data['has_poll']) ? "INSERT INTO " . VOTE_DESC_TABLE . " (topic_id, vote_text, vote_start, vote_length) VALUES ($topic_id, '$poll_title', $current_time, " . ($poll_length * 86400) . ")" : "UPDATE " . VOTE_DESC_TABLE . " SET vote_text = '$poll_title', vote_length = " . ($poll_length * 86400) . " WHERE topic_id = $topic_id";
		if (!$db->sql_query($sql))
		  alert('error', 'Error in posting<br>' . __LINE__ . '.' . __FILE__ . ': ' . $sql);

		$delete_option_sql = '';
		$old_poll_result = array();
		if($mode == 'editpost' && $post_data['has_poll'])
		{
			$sql = "SELECT vote_option_id, vote_result
				FROM " . VOTE_RESULTS_TABLE . "
				WHERE vote_id = $poll_id
				ORDER BY vote_option_id ASC";
			if (!($result = $db->sql_query($sql)))
				alert('error', 'Could not obtain vote data results for this topic ' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');

			while ($row = $db->sql_fetchrow($result))
			{
				$old_poll_result[$row['vote_option_id']] = $row['vote_result'];
				if (!isset($poll_options[$row['vote_option_id']]))
					$delete_option_sql .= ($delete_option_sql != '') ? ', ' . $row['vote_option_id'] : $row['vote_option_id'];
			}
		}
		else $poll_id = $db->sql_nextid();

		@reset($poll_options);

		$poll_option_id = 1;
		while (list($option_id, $option_text) = each($poll_options))
		{
			if (!empty($option_text))
			{
				$option_text = str_replace("\'", "''", htmlspecialchars($option_text));
				$poll_result = ($mode == "editpost" && isset($old_poll_result[$option_id])) ? $old_poll_result[$option_id] : 0;

				$sql = ($mode != "editpost" || !isset($old_poll_result[$option_id])) ? "INSERT INTO " . VOTE_RESULTS_TABLE . " (vote_id, vote_option_id, vote_option_text, vote_result) VALUES ($poll_id, $poll_option_id, '$option_text', $poll_result)" : "UPDATE " . VOTE_RESULTS_TABLE . " SET vote_option_text = '$option_text', vote_result = $poll_result WHERE vote_option_id = $option_id AND vote_id = $poll_id";
				if (!$db->sql_query($sql))
					alert('error', 'Error in posting ' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');
				$poll_option_id++;
			}
		}

		if ($delete_option_sql != '')
		{
			$sql = "DELETE FROM " . VOTE_RESULTS_TABLE . "
				WHERE vote_option_id IN ($delete_option_sql)
					AND vote_id = $poll_id";
			if (!$db->sql_query($sql))
				alert('error', 'Error deleting pruned poll options ' . __LINE__ . '.' . __FILE__ . ': ' . $sql, 'iconError');
		}
	}

	$meta = '<meta http-equiv="refresh" content="3;url=' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">';
	$message = $lang['Stored'] . '<br /><br />' . sprintf($lang['Click_view_message'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=" . $post_id) . '#' . $post_id . '">', '</a>') . '<br /><br />' . sprintf($lang['Click_return_forum'], '<a href="' . append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=$forum_id") . '">', '</a>');

	return false;
}

$mode = $xml->getTagAttribute('mode');
$topic_id = $xml->getTagAttribute('topic');
$forum_id = $xml->getTagAttribute('forum');
$post_id = $xml->getTagAttribute('post_id');
$submit = $xml->getTagAttribute('post');
$username = unhtmlentities($xml->getTagAttribute('username'));

$wndId = $xml->getTagAttribute('wndId');

$subject = unhtmlentities($xml->getTagAttribute('subject'));
$message = unhtmlentities($xml->getTagContent('bbxml/message'));

$refresh = $preview || $poll_add || $poll_edit || $poll_delete;

//
// Set topic type
//
$topic_type =  POST_NORMAL;


//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_POSTING);
init_userprefs($userdata);
//
// End session management
//

//
// Was cancel pressed? If so then redirect to the appropriate
// page, no point in continuing with any further checks
//

//
// What auth type do we need to check?
//
$is_auth = array();
switch($mode)
{
	case 'newtopic':
		if ( $topic_type == POST_ANNOUNCE )
		{
			$is_auth_type = 'auth_announce';
		}
		else if ( $topic_type == POST_STICKY )
		{
			$is_auth_type = 'auth_sticky';
		}
		else
		{
			$is_auth_type = 'auth_post';
		}
		break;
	case 'reply':
	case 'quote':
		$is_auth_type = 'auth_reply';
		break;
	case 'editpost':
		$is_auth_type = 'auth_edit';
		break;
	case 'delete':
	case 'poll_delete':
		$is_auth_type = 'auth_delete';
		break;
	case 'vote':
		$is_auth_type = 'auth_vote';
		break;
	case 'topicreview':
		$is_auth_type = 'auth_read';
		break;
	default:
		message_die(GENERAL_MESSAGE, $lang['No_post_mode']);
		break;
}

//
// Here we do various lookups to find topic_id, forum_id, post_id etc.
// Doing it here prevents spoofing (eg. faking forum_id, topic_id or post_id
//
$error_msg = '';
$post_data = array();
switch($mode)
{
	case 'newtopic':
		if(empty($forum_id))
			alert('error', $lang['Forum_not_exist'], 'iconError');
		$sql = "SELECT *
			FROM " . FORUMS_TABLE . "
			WHERE forum_id = $forum_id";
		break;

	case 'reply':
	case 'vote':
		if ( empty( $topic_id) )
			alert('error', $lang['No_topic_id'], 'iconError');
		$sql = "SELECT f.*, t.topic_status, t.topic_title
			FROM " . FORUMS_TABLE . " f, " . TOPICS_TABLE . " t
			WHERE t.topic_id = $topic_id
				AND f.forum_id = t.forum_id";
		break;

	case 'quote':
	case 'editpost':
	case 'delete':
	case 'poll_delete':
		if ( empty($post_id) )
			alert('error', $lang['No_post_id'], 'iconError');

		$select_sql = ( !$submit ) ? ", t.topic_title, p.enable_bbcode, p.enable_html, p.enable_smilies, p.enable_sig, p.post_username, pt.post_subject, pt.post_text, pt.bbcode_uid, u.username, u.user_id, u.user_sig" : '';
		$from_sql = ( !$submit ) ? ", " . POSTS_TEXT_TABLE . " pt, " . USERS_TABLE . " u" : '';
		$where_sql = ( !$submit ) ? "AND pt.post_id = p.post_id AND u.user_id = p.poster_id" : '';

		$sql = "SELECT f.*, t.topic_id, t.topic_status, t.topic_type, t.topic_first_post_id, t.topic_last_post_id, t.topic_vote, p.post_id, p.poster_id" . $select_sql . "
			FROM " . POSTS_TABLE . " p, " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f" . $from_sql . "
			WHERE p.post_id = $post_id
				AND t.topic_id = p.topic_id
				AND f.forum_id = p.forum_id
				$where_sql";
		break;

	default:
		alert('error', $lang['No_valid_mode'], 'iconError');
}

if($result = $db->sql_query($sql))
{
	$post_info = $db->sql_fetchrow($result);

	$forum_id = $post_info['forum_id'];
	$forum_name = $post_info['forum_name'];

	$is_auth = auth(AUTH_ALL, $forum_id, $userdata, $post_info);

	if($post_info['forum_status'] == FORUM_LOCKED && !$is_auth['auth_mod'])
	{
	   alert('error', $lang['Forum_locked'], 'iconError');
	}
	else if ( $mode != 'newtopic' && $post_info['topic_status'] == TOPIC_LOCKED && !$is_auth['auth_mod'])
	{
	   alert('error', $lang['Topic_locked'], 'iconError');
	}

	if ( $mode == 'editpost' || $mode == 'delete' || $mode == 'poll_delete' )
	{
		$topic_id = $post_info['topic_id'];

		$post_data['poster_post'] = ( $post_info['poster_id'] == $userdata['user_id'] ) ? true : false;
		$post_data['first_post'] = ( $post_info['topic_first_post_id'] == $post_id ) ? true : false;
		$post_data['last_post'] = ( $post_info['topic_last_post_id'] == $post_id ) ? true : false;
		$post_data['last_topic'] = ( $post_info['forum_last_post_id'] == $post_id ) ? true : false;
		$post_data['has_poll'] = ( $post_info['topic_vote'] ) ? true : false;
		$post_data['topic_type'] = $post_info['topic_type'];
		$post_data['poster_id'] = $post_info['poster_id'];

		if ( $post_data['first_post'] && $post_data['has_poll'] )
		{
			$sql = "SELECT *
				FROM " . VOTE_DESC_TABLE . " vd, " . VOTE_RESULTS_TABLE . " vr
				WHERE vd.topic_id = $topic_id
					AND vr.vote_id = vd.vote_id
				ORDER BY vr.vote_option_id";
			if(!($result = $db->sql_query($sql)))
				alert('error', 'Could not obtain vote data for this topic ' . __LINE__ . '.' . __FILE__ . ': ' . $sql);

			$poll_options = array();
			$poll_results_sum = 0;
			if($row = $db->sql_fetchrow($result))
			{
				$poll_title = $row['vote_text'];
				$poll_id = $row['vote_id'];
				$poll_length = $row['vote_length'] / 86400;

				do
				{
					$poll_options[$row['vote_option_id']] = $row['vote_option_text'];
					$poll_results_sum += $row['vote_result'];
				}
				while($row = $db->sql_fetchrow($result));
			}

			$post_data['edit_poll'] = ( ( !$poll_results_sum || $is_auth['auth_mod'] ) && $post_data['first_post'] ) ? true : 0;
		}
		else
		{
			$post_data['edit_poll'] = ($post_data['first_post'] && $is_auth['auth_pollcreate']) ? true : false;
		}

		//
		// Can this user edit/delete the post/poll?
		//
		if($post_info['poster_id'] != $userdata['user_id'] && !$is_auth['auth_mod'])
		{
			$message = ( $delete || $mode == 'delete' ) ? $lang['Delete_own_posts'] : $lang['Edit_own_posts'];
			$message .= '<br /><br />' . sprintf($lang['Click_return_topic'], '<a href="' . append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=$topic_id") . '">', '</a>');

			alert('error', $message, 'iconError');
		}
		else if(!$post_data['last_post'] && !$is_auth['auth_mod'] && ( $mode == 'delete' || $delete ))
		{
			alert('error', $lang['Cannot_delete_replied'], 'iconError');
		}
		else if(!$post_data['edit_poll'] && !$is_auth['auth_mod'] && ( $mode == 'poll_delete' || $poll_delete ))
		{
			alert('error', $lang['Cannot_delete_poll'], 'iconError');
		}
	}
	else
	{
		if($mode == 'quote')
			$topic_id = $post_info['topic_id'];

		$post_data['first_post'] = ( $mode == 'newtopic' ) ? true : 0;
		$post_data['last_post'] = false;
		$post_data['has_poll'] = false;
		$post_data['edit_poll'] = false;
	}
}
else
{
	alert('error', $lang['No_such_post'], 'iconError');
}

//
// The user is not authed, if they're not logged in then redirect
// them, else show them an error message
//
if ( !$is_auth[$is_auth_type] )
{
  $xml = new XML('bbxml');
  alert("error", htmlentities(sprintf($lang['Sorry_' . $is_auth_type], $is_auth[$is_auth_type . "_type"])), "iconError");
}

//
// Set toggles for various options
//
if ( !$board_config['allow_html'] )
	$html_on = 0;
else
	$html_on = ( $submit || $refresh ) ? ( ( !empty($HTTP_POST_VARS['disable_html']) ) ? 0 : TRUE ) : ( ( $userdata['user_id'] == ANONYMOUS ) ? $board_config['allow_html'] : $userdata['user_allowhtml'] );

if ( !$board_config['allow_bbcode'] )
	$bbcode_on = 0;
else
	$bbcode_on = ( $submit || $refresh ) ? ( ( !empty($HTTP_POST_VARS['disable_bbcode']) ) ? 0 : TRUE ) : ( ( $userdata['user_id'] == ANONYMOUS ) ? $board_config['allow_bbcode'] : $userdata['user_allowbbcode'] );

if ( !$board_config['allow_smilies'] )
	$smilies_on = 0;
else
	$smilies_on = ( $submit || $refresh ) ? ( ( !empty($HTTP_POST_VARS['disable_smilies']) ) ? 0 : TRUE ) : ( ( $userdata['user_id'] == ANONYMOUS ) ? $board_config['allow_smilies'] : $userdata['user_allowsmile'] );

if ( ($submit || $refresh) && $is_auth['auth_read'])
	$notify_user = ( !empty($HTTP_POST_VARS['notify']) ) ? TRUE : 0;
else
{
	if($mode != 'newtopic' && $userdata['session_logged_in'] && $is_auth['auth_read'])
	{
		$sql = "SELECT topic_id
			FROM " . TOPICS_WATCH_TABLE . "
			WHERE topic_id = $topic_id
				AND user_id = " . $userdata['user_id'];
		if ( !($result = $db->sql_query($sql)) )
			alert('error', 'Could not obtain topic watch information<br/>' . __LINE__ . '<br/>' . __FILE__ . '<br/>' . $sql, 'iconError');
		$notify_user = ( $db->sql_fetchrow($result) ) ? TRUE : $userdata['user_notify'];
	}
	else
	{
		$notify_user = ( $userdata['session_logged_in'] && $is_auth['auth_read'] ) ? $userdata['user_notify'] : 0;
	}
}
$attach_sig = ( $submit || $refresh ) ? ( ( !empty($HTTP_POST_VARS['attach_sig']) ) ? TRUE : 0 ) : ( ( $userdata['user_id'] == ANONYMOUS ) ? 0 : $userdata['user_attachsig'] );


if($submit || $confirm)
{ //!!! this is the code that we are mostly be using
	//
	// Submit post/vote (newtopic, edit, reply, etc.)
	//
	$return_message = '';
	$return_meta = '';

	switch ($mode)
	{
		case 'editpost':
		case 'newtopic':
		case 'reply':
			$poll_title =  '';
			$poll_options =  '';
			$poll_length = '';
			$bbcode_uid = '';

			prepare_post(
			  $mode,
			  $post_data,
			  $bbcode_on,
			  $html_on,
			  $smilies_on,
			  $error_msg,
			  $username,
			  $bbcode_uid,
			  $subject,
			  $message,
			  $poll_title,
			  $poll_options,
			  $poll_length
			);
			if($error_msg != '')
				alert('error', htmlentities($error_msg), 'iconError');

			$topic_type = ($topic_type != $post_data['topic_type']
			  && !$is_auth['auth_sticky']
			  && !$is_auth['auth_announce'])
			  ? $post_data['topic_type']
			  : $topic_type;

			fbb_submit(
			  $mode,
			  $post_data,
			  $return_message,
			  $return_meta,
			  $forum_id,
			  $topic_id,
			  $post_id,
			  $poll_id,
			  $topic_type,
			  $bbcode_on,
			  $html_on,
			  $smilies_on,
			  $attach_sig,
			  $bbcode_uid,
			  str_replace("\'", "''", $username),
			  str_replace("\'", "''", $subject),
			  str_replace("\'", "''", $message),
			  str_replace("\'", "''", $poll_title),
			  $poll_options,
			  $poll_length
			);
			
			break;

		case 'delete':
		case 'poll_delete':
			delete_post($mode, $post_data, $return_message, $return_meta, $forum_id, $topic_id, $post_id, $poll_id);
			break;
	}

	if ( $mode != 'editpost' )
	{
		$user_id = ( $mode == 'reply' || $mode == 'newtopic' ) ? $userdata['user_id'] : $post_data['poster_id'];
		update_post_stats($mode, $post_data, $forum_id, $topic_id, $post_id, $user_id);
	}

	if ($error_msg == '' && $mode != 'poll_delete')
	{
		user_notification($mode, $post_data, $post_info['topic_title'], $forum_id, $topic_id, $post_id, $notify_user);
	}

	if ( $mode == 'newtopic' || $mode == 'reply' )
	{
		$tracking_topics = ( !empty($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_t']) : array();
		$tracking_forums = ( !empty($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) ) ? unserialize($HTTP_COOKIE_VARS[$board_config['cookie_name'] . '_f']) : array();

		if ( count($tracking_topics) + count($tracking_forums) == 100 && empty($tracking_topics[$topic_id]) )
		{
			asort($tracking_topics);
			unset($tracking_topics[key($tracking_topics)]);
		}

		$tracking_topics[$topic_id] = time();

		setcookie($board_config['cookie_name'] . '_t', serialize($tracking_topics), 0, $board_config['cookie_path'], $board_config['cookie_domain'], $board_config['cookie_secure']);
	}
	$template->assign_vars(array(
		'META' => $return_meta)
	);
  $xml = new XML('bbxml');
  $section = new XMLBranch('section');
  $section->setTagAttribute('action', 'post');
  $section->setTagAttribute('wndId', $wndId);
  $section->setTagAttribute('message', 'the message is sent');
  $section->setTagAttribute('forum', $forum_id);
  $section->setTagAttribute('topic', $topic_id);
  if($mode == 'editpost') $mode = 'reply';
  $section->setTagAttribute('mode', $mode);
  $xml->addXMLBranch($section);
  echo $xml->getXMLString();
  $db->sql_close();
  exit;
}

//
// User default entry point
//
if ( $mode == 'newtopic' )
{
	$user_sig = ( $userdata['user_sig'] != '' ) ? $userdata['user_sig'] : '';

	$username = ($userdata['session_logged_in']) ? $userdata['username'] : '';
	$poll_title = '';
	$poll_length = '';
	$subject = '';
	$message = '';
}
else if ( $mode == 'reply' )
{
	$user_sig = ( $userdata['user_sig'] != '' ) ? $userdata['user_sig'] : '';

	$username = ( $userdata['session_logged_in'] ) ? $userdata['username'] : '';
	$subject = '';
	$message = '';
}
else if ( $mode == 'quote' || $mode == 'editpost' )
{
	$subject = ($post_data['first_post']) ? $post_info['topic_title'] : $post_info['post_subject'];
	$message = $post_info['post_text'];

	if ( $mode == 'editpost' )
	{
		$attach_sig = ( $post_info['enable_sig'] && $post_info['user_sig'] != '' ) ? TRUE : 0;
		$user_sig = $post_info['user_sig'];

		$html_on = ( $post_info['enable_html'] ) ? true : false;
		$bbcode_on = ( $post_info['enable_bbcode'] ) ? true : false;
		$smilies_on = ( $post_info['enable_smilies'] ) ? true : false;
	}
	else
	{
		$attach_sig = ( $userdata['user_attachsig'] ) ? TRUE : 0;
		$user_sig = $userdata['user_sig'];
	}

	if ( $post_info['bbcode_uid'] != '' )
	{
		$message = preg_replace('/\:(([a-z0-9]:)?)' . $post_info['bbcode_uid'] . '/s', '', $message);
	}

	$message = str_replace('<', '&lt;', $message);
	$message = str_replace('>', '&gt;', $message);
	$message = str_replace('<br />', "\n", $message);

  // we will use it for topic/post title
  $subjectCopy =  $subject;
	if ( $mode == 'quote' )
	{
		$orig_word = array();
		$replacement_word = array();
		obtain_word_list($orig_word, $replace_word);

		$msg_date =  create_date($board_config['default_dateformat'], $postrow['post_time'], $board_config['board_timezone']);

		// Use trim to get rid of spaces placed there by MS-SQL 2000
		$quote_username = ( trim($post_info['post_username']) != '' ) ? $post_info['post_username'] : $post_info['username'];
		$message = '[quote="' . $quote_username . '"]' . $message . '[/quote]';

		if ( !empty($orig_word) )
		{
			$subject = ( !empty($subject) ) ? preg_replace($orig_word, $replace_word, $subject) : '';
			$message = ( !empty($message) ) ? preg_replace($orig_word, $replace_word, $message) : '';
		}

		if ( !preg_match('/^Re:/', $subject) && strlen($subject) > 0 )
			$subject = 'Re: ' . $subject;
	}
	else
	{
		$username = ( $post_info['user_id'] == ANONYMOUS && !empty($post_info['post_username']) ) ? $post_info['post_username'] : '';
	}
}


//
// Signature toggle selection
//
if( $user_sig != '' )
{
	$template->assign_block_vars('switch_signature_checkbox', array());
}

//
// HTML toggle selection
//
if ( $board_config['allow_html'] )
{
	$html_status = $lang['HTML_is_ON'];
	$template->assign_block_vars('switch_html_checkbox', array());
}
else
{
	$html_status = $lang['HTML_is_OFF'];
}

//
// BBCode toggle selection
//
if ( $board_config['allow_bbcode'] )
{
	$bbcode_status = $lang['BBCode_is_ON'];
	$template->assign_block_vars('switch_bbcode_checkbox', array());
}
else
{
	$bbcode_status = $lang['BBCode_is_OFF'];
}

//
// Smilies toggle selection
//
if ( $board_config['allow_smilies'] )
{
	$smilies_status = $lang['Smilies_are_ON'];
	$template->assign_block_vars('switch_smilies_checkbox', array());
}
else
{
	$smilies_status = $lang['Smilies_are_OFF'];
}

if( !$userdata['session_logged_in'] || ( $mode == 'editpost' && $post_info['poster_id'] == ANONYMOUS ) )
{
	$template->assign_block_vars('switch_username_select', array());
}

//
// Notify checkbox - only show if user is logged in
//
if($userdata['session_logged_in'] && $is_auth['auth_read']
    && $mode != 'editpost' || ( $mode == 'editpost' && $post_info['poster_id'] != ANONYMOUS ))
{
	$template->assign_block_vars('switch_notify_checkbox', array());
}

//
// Delete selection
//
if ( $mode == 'editpost' && ( ( $is_auth['auth_delete'] && $post_data['last_post'] && ( !$post_data['has_poll'] || $post_data['edit_poll'] ) ) || $is_auth['auth_mod'] ) )
{
	$template->assign_block_vars('switch_delete_checkbox', array());
}

//
// Topic type selection
//
$topic_type_toggle = '';
if ( $mode == 'newtopic' || ( $mode == 'editpost' && $post_data['first_post'] ) )
{
	$template->assign_block_vars('switch_type_toggle', array());

	if( $is_auth['auth_sticky'] )
	{
		$topic_type_toggle .= '<input type="radio" name="topictype" value="' . POST_STICKY . '"';
		if ( $post_data['topic_type'] == POST_STICKY || $topic_type == POST_STICKY )
		{
			$topic_type_toggle .= ' checked="checked"';
		}
		$topic_type_toggle .= ' /> ' . $lang['Post_Sticky'] . '&nbsp;&nbsp;';
	}

	if( $is_auth['auth_announce'] )
	{
		$topic_type_toggle .= '<input type="radio" name="topictype" value="' . POST_ANNOUNCE . '"';
		if ( $post_data['topic_type'] == POST_ANNOUNCE || $topic_type == POST_ANNOUNCE )
		{
			$topic_type_toggle .= ' checked="checked"';
		}
		$topic_type_toggle .= ' /> ' . $lang['Post_Announcement'] . '&nbsp;&nbsp;';
	}

	if ( $topic_type_toggle != '' )
	{
		$topic_type_toggle = $lang['Post_topic_as'] . ': <input type="radio" name="topictype" value="' . POST_NORMAL .'"' . ( ( $post_data['topic_type'] == POST_NORMAL || $topic_type == POST_NORMAL ) ? ' checked="checked"' : '' ) . ' /> ' . $lang['Post_Normal'] . '&nbsp;&nbsp;' . $topic_type_toggle;
	}
}

$hidden_form_fields = '<input type="hidden" name="mode" value="' . $mode . '" />';

switch( $mode )
{
	case 'newtopic':
		$page_title = $lang['Post_a_new_topic'];
		$hidden_form_fields .= '<input type="hidden" name="' . POST_FORUM_URL . '" value="' . $forum_id . '" />';
		break;

	case 'reply':
		$page_title = $lang['Post_a_reply'];
		$hidden_form_fields .= '<input type="hidden" name="' . POST_TOPIC_URL . '" value="' . $topic_id . '" />';
		break;

	case 'editpost':
		$page_title = $lang['Edit_Post'];
		$hidden_form_fields .= '<input type="hidden" name="' . POST_POST_URL . '" value="' . $post_id . '" />';
		break;
}

// Generate smilies listing for page output
//generate_smilies('inline', PAGE_POSTING);


$xml = new XML('bbxml');
$section = new XMLBranch('section');
$section->setTagAttribute('action', 'post');
$section->setTagAttribute('wndId', $wndId);
$section->setTagAttribute('mode', $mode);

$mes = new XMLBranch('message');
$post_name = new XMLBranch('post_name');
$subj = new XMLBranch('subj');
$mes->setTagAttribute('topic', $topic_id);
$mes->setTagAttribute('forum', $forum_id);
$mes->setTagAttribute('post', $post_id);
//$message->setTagContent("<![CDATA[".$data['MESSAGE']."]]>");
$mes->setTagContent(htmlentities($message));
//$post_name->setTagContent("<![CDATA[" . $subjectCopy . "]]>");
$post_name->setTagContent(htmlentities($subjectCopy) );
//$subj->setTagContent("<![CDATA[" . $data['SUBJECT'] . "]]>");
$subj->setTagContent(htmlentities($subject));
$section->addXMLBranch($mes);
$section->addXMLBranch($post_name);
$section->addXMLBranch($subj);

$xml->addXMLBranch($section);
echo  $xml->getXMLString();
$db->sql_close();
?>