<?php
define('IN_PHPBB', true);
$phpbb_root_path = '../';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.' . $phpEx);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_PROFILE);
init_userprefs($userdata);
$user_id = $xml->getTagAttribute('user_id');
$profiledata = get_userdata(intval($user_id));

$sql = "SELECT * FROM " . RANKS_TABLE . " ORDER BY rank_special, rank_min";
if(!($result = $db->sql_query($sql)))
	message_die(GENERAL_ERROR, 'Could not obtain ranks information', '', __LINE__, __FILE__, $sql);

while($row = $db->sql_fetchrow($result))
	$ranksrow[] = $row;
$db->sql_freeresult($result);

//
// Calculate the number of days this user has been a member ($memberdays)
// Then calculate their posts per day
//
$regdate = $profiledata['user_regdate'];
$memberdays = max(1, round((time() - $regdate) / 86400));
$posts_per_day = $profiledata['user_posts'] / $memberdays;

// Get the users percentage of total posts
if($profiledata['user_posts'] != 0)
{
	$total_posts = get_db_stat('postcount');
	$percentage = ($total_posts) ? min(100, ($profiledata['user_posts'] / $total_posts) * 100) : 0;
}
else $percentage = 0;

// avatar
$avatar_img = '';
if($profiledata['user_avatar_type'] && $profiledata['user_allowavatar'])
{
	switch($profiledata['user_avatar_type'])
	{
		case USER_AVATAR_UPLOAD:
			$avatar_img = ( $board_config['allow_avatar_upload'] ) ? $board_config['avatar_path'] . '/' . $profiledata['user_avatar'] : '';
			break;
		case USER_AVATAR_REMOTE:
			$avatar_img = ( $board_config['allow_avatar_remote'] ) ? $profiledata['user_avatar'] : '';
			break;
		case USER_AVATAR_GALLERY:
			$avatar_img = ( $board_config['allow_avatar_local'] ) ? $board_config['avatar_gallery_path'] . '/' . $profiledata['user_avatar'] : '';
			break;
	}
}

// rank
$poster_rank = '';
if($profiledata['user_rank'])
{
	for($i = 0; $i < count($ranksrow); $i++)
		if($profiledata['user_rank'] == $ranksrow[$i]['rank_id'] && $ranksrow[$i]['rank_special'])
			$poster_rank = $ranksrow[$i]['rank_title'];
}
else
{
	for($i = 0; $i < count($ranksrow); $i++)
		if($profiledata['user_posts'] >= $ranksrow[$i]['rank_min'] && !$ranksrow[$i]['rank_special'])
			$poster_rank = $ranksrow[$i]['rank_title'];
}
// private message
$pm = append_sid("privmsg.$phpEx?mode=post&amp;" . POST_USERS_URL . "=" . $profiledata['user_id']);
// email
if(!empty($profiledata['user_viewemail']) || $userdata['user_level'] == ADMIN)
	$email = $profiledata['user_email'];
else $email = '';
// www site
$site = $profiledata['user_website'];
// icq
if(!empty($profiledata['user_icq']))
{
	$icq_status_img = '<a href="http://wwp.icq.com/' . $profiledata['user_icq'] . '#pager"><img src="http://web.icq.com/whitepages/online?icq=' . $profiledata['user_icq'] . '&img=5" width="18" height="18" border="0" /></a>';
	$icq =  "http://wwp.icq.com/scripts/search.dll?to=" . $profiledata['user_icq'];
}
else
{
	$icq_status_img = '';
	$icq = '';
}
// aim
$aim = $profiledata['user_aim'] ? "aim:goim?screenname=" . $profiledata['user_aim'] . "&amp;message=Hello+Are+you+there?" : '';
// msn
$msn = $profiledata['user_msnm'] ? $profiledata['user_msnm'] : '';
// yahoo
$yim = $profiledata['user_yim'] ? "http://edit.yahoo.com/config/send_webmesg?.target=" . $profiledata['user_yim'] . "&amp;.src=pg" . $lang['YIM'] : '';
// search
$search = append_sid("search.$phpEx?search_author=" . urlencode($profiledata['username']) . "&amp;showresults=posts");

// generate xml
$xml = new XML('bbxml');
$section = new XMLBranch('section');
$section->setTagAttribute('action', 'uinfo');
$user = new XMLBranch('user');
$user->setTagAttribute('username', $profiledata['username']);
$user->setTagAttribute('user_id', $user_id);
$user->setTagAttribute('location', $profiledata['user_from'] ? $profiledata['user_from'] : '');
$user->setTagAttribute('occupation', $profiledata['user_occ'] ? $profiledata['user_occ'] : '');
$user->setTagAttribute('interests', $profiledata['user_interests'] ? $profiledata['user_interests'] : '');
$user->setTagAttribute('joined', create_date($lang['DATE_FORMAT'], $profiledata['user_regdate'], $board_config['board_timezone']));
$user->setTagAttribute('poster_rank', $poster_rank);
$user->setTagAttribute('posts', $profiledata['user_posts']);
$user->setTagAttribute('site', $site);
$user->setTagAttribute('email', $email);

$section->addXMLBranch($user);
$xml->addXMLBranch($section);
echo $xml->getXMLString();
?>