﻿class FlashBB
{
	static public function main():Void
	{
		Stage.align = "TL"; // top-left align
		Stage.scaleMode = "noScale"; // allows to resize movie on player resize instead of movie scaling
		
		// themes manager
		_global.themesManager = classes.ThemesManager.getInstance();
		_global.themesManager.setHolder(_root.createEmptyMovieClip("mcLook", 1));
		// test layer
		var m_testLayer:MovieClip = _root.createEmptyMovieClip("m_testLayer", 2);
		m_testLayer.createTextField("fldCellThread", 1, 0, 0, 1, 1);
		var fldCellThread:TextField = m_testLayer["fldCellThread"];
		fldCellThread.html = true;
		fldCellThread.multiline = true;
		fldCellThread.wordWrap = true;
		fldCellThread.autoSize = "left";
		fldCellThread._visible = false;
		_global.testLayer = m_testLayer;
		
		// layer for comboboxes lists and other object with the same behaviour
		_global.popup = _root.createEmptyMovieClip("m_mcPopup", 4);
		// tooltip layer
		pseudo.ToolTip.create(_root, "m_toolTip", 5);
		// cursor manager
		pseudo.CursorManager.getInstance().setCursorsHolder(_root.createEmptyMovieClip("m_cursorsHolder", 6));
		
		loadXML();
	} // function main

	static private function onLoadConfigProgress(xmlDoc:pseudo.XMLDocument):Void
	{
		_root.mcBack.setPos(xmlDoc.getBytesLoaded() * 100 / xmlDoc.getBytesTotal(), 1);
	}

	static private function onLoadConfig(bSuccess:Boolean, xmlDoc:pseudo.XMLDocument):Void
	{
		_global.xmlConfig.removeListener("onLoad", _root);
		if(_root.mcBack) _global.xmlConfig.removeListener("onLoadProgress", _root);
		if(bSuccess)
		{
			if(_root.mcBack) _root.mcBack.setPos(100, 1);
			var sndMng:pseudo.SoundManager = pseudo.SoundManager.getInstance();
			var arrXMLSounds:Array = xmlDoc.getNodes("sounds.sound");
			for(var i:Number = 0; i < arrXMLSounds.length; i++)
				sndMng.addSound(arrXMLSounds[i].getAttr("name"), arrXMLSounds[i].getAttr("path"));
			sndMng.loadSounds();
	
			// languages
			var lng:String = _global.xmlConfig.getAttr("lng");
			var path:String = _global.xmlConfig.getAttr("path", "languages");
	
			_global.lng = new pseudo.XMLDocument();
			_global.lng.addListener("onLoad", _root, onLoadLng);
			if(_root.mcBack) _global.lng.addListener("onLoadProgress", _root, onLoadLngProgress);
			_global.lng.load(path + _global.xmlConfig.getAttr(lng, "languages"));
		}
		else 
		{
			if(_global.isPhp)
			{
				loadXML(false);
			}
			else
			_root.trace("can't load config file");
		}
	}

	static private function onLoadLngProgress(xmlDoc:pseudo.XMLDocument):Void
	{
		_root.mcBack.setPos(xmlDoc.getBytesLoaded() * 100 / xmlDoc.getBytesTotal(), 2);
	}

	static private function onLoadLng(bSuccess:Boolean, xmlDoc:pseudo.XMLDocument):Void
	{
		if(bSuccess)
		{
			_global.lng.removeListener("onLoad", _root);
			if(_root.mcBack)
			{
				_global.lng.removeListener("onLoadProgress", _root);
				_root.mcBack.setPos(100, 2);
			}
			_global.themesManager.setLooks(_global.xmlConfig.getNode("config.looks"));
			_global.themesManager.addListener("onLoad", _root, onLoadLook);
			_global.themesManager.addListener("onLoadError", _root, onLoadLookError);
			if(_root.mcBack) _global.themesManager.addListener("onLoadProgress", _root, onLoadLookProgress);
			if(_global.xmlConfig.getNode("config.theme"))
				_global.themesManager.loadLook(_global.xmlConfig.getAttr("lookId", "config.theme"),
																			 _global.xmlConfig.getAttr("id", "config.theme"));
			else	
				_global.themesManager.loadLook();
		}
		else _root.trace("can't load language");
	}

	static private function onLoadLookProgress(look:Object, bytesLoaded:Number, bytesTotal:Number):Void
	{
		_root.mcBack.setPos(bytesLoaded * 100 / bytesTotal, 3);
	}

	static private function onLoadLookError(errorCode:String):Void
	{
		_root.trace("Look wasn't loaded: " + errorCode);
	}

	static private function onLoadLook(look:Object):Void
	{
		_global.themesManager.removeListener("onLoad", _root);
		_global.themesManager.removeListener("onLoadError", _root);
		if(_root.mcBack)
		{
			_global.themesManager.removeListener("onLoadProgress", _root);
			_root.mcBack.setPos(100, 3);
			_root.intId = setInterval(FlashBB.initMain, 1, look);
		}
		else initMain(look);
		var resizeListener:Object = new Object();
		resizeListener.onResize = function():Void
		{
			_global.main.setSize(Stage.width, Stage.height);
			_global.main.update();
			_global.main.draw();
		}
		Stage.addListener(resizeListener);
	}

	static private function initMain(look:Object):Void
	{
		clearInterval(_root.intId);
		delete _root.intId;
	
		// main
		var main:classes.Main = classes.Main.create(_root, "main", 3);
		_global.main = main;
	
		//initialize model once
		classes.ctrl.ActionStore.getInstance().initModel();
		classes.ThemesManager.getInstance().setLook(look);
		main.setSize(Stage.width, Stage.height);
		main.update();
		main.draw();
		if(_root.mcBack) _root.mcBack.remove();
	}

	static private function loadXML()
	{
		// load config file
		var xmlConfig:pseudo.XMLDocument = new pseudo.XMLDocument();
		xmlConfig.addListener("onLoad", _root, onLoadConfig);
		if(_root.mcBack) xmlConfig.addListener("onLoadProgress", _root, onLoadConfigProgress);
	
		xmlConfig.load(_root.configPath ? _root.configPath : "config.xml");
		_global.xmlConfig = xmlConfig;
	}
}