﻿class classes.BBWindowManager extends pseudo.WindowManager
{
	private var m_list:pseudo.List;
	private var m_arrData:Array;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.BBWindowManager
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.BBWindowManager(pOwner[strName]);
		return pOwner[strName];
	}

	public function BBWindowManager(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.BBWindowManager;

		m_arrData = new Array();
	}

	public function setList(list:pseudo.List):Void
	{
		list.setListData(m_arrData);
		list.addListener("changed", this, onListChanged);
		m_list = list;
	}

	public function addWindow(strTitle:String, pClass:Function, strName:String, bMyPos:Boolean):pseudo.BaseWindow
	{
		var wnd:pseudo.BaseWindow = super.addWindow(strTitle, pClass, strName, bMyPos);
		m_arrData.push({id:wnd.getId(), text:strTitle});
		m_list.setSelCell(m_arrData.length - 1);
		m_list.setUpdated(false);
		return wnd;
	}

	public function updateListTitle(wnd:pseudo.BaseWindow, text:String):Void
	{
		var wndId:Number = wnd.getId();
		for(var i:Number = 0; i < m_arrData.length; i++)
			if(m_arrData[i].id == wndId)
			{
				m_arrData[i].text = text;
				break;
			}
		m_list.setUpdated(false);
	}

	public function update():Void
	{
		super.update();
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			if(!m_arrWindows[i].isMaximized())
				moveWindow(m_arrWindows[i]._x, m_arrWindows[i]._y, m_arrWindows[i]);
		m_list.update();
	}

	public function draw():Void
	{
		super.draw();
		m_list.draw();
	}

	public function closeWindow(wnd:pseudo.BaseWindow, bSkip:Boolean):Void
	{
		var nId:Number = wnd.getId();
		super.closeWindow(wnd, true);
		if(!bSkip)
		{
			for(var i:Number = 0; i < m_arrData.length; i++)
				if(m_arrData[i].id == nId)
				{ // remove data about closed window
					m_arrData.splice(i, 1);
					break;
				}
			m_list.setUpdated(false);
			// xxx
			//m_list.update();
			if(m_arrWindows[0]._visible)
			{
				for(var i:Number = 0; i < m_arrData.length; i++)
					if(m_arrData[i].id == m_arrWindows[0].getId())
					{
						m_list.setSelCell(i);
						break;
					}
			}
			else m_list.setSelCell(-1);
			m_list.update();
			m_list.draw();
			// xxx
		}
	}

	public function closeAllWindows():Void
	{
		super.closeAllWindows();
		m_arrData.splice(0);
		m_list.setUpdated(false);
		m_list.update();
		m_list.draw();
	}

	public function minimizeWindow(wnd:pseudo.BaseWindow, bSkip:Boolean):Void
	{
		super.minimizeWindow(wnd, true);
		if(!bSkip)
		{
			moveWindow(wnd._x, wnd._y, wnd);
			classes.Global.playAniFrame(classes.Global.getRect(m_mask), classes.Global.getRect(wnd));
		}
	}

	public function moveWindow(x:Number, y:Number, wnd:pseudo.BaseWindow, bSnap:Boolean, bSkip:Boolean):Void
	{
		if(!wnd.isMaximized())
		{
			if(!bSkip)
			{
				x = Math.min(
					m_mask._x + m_nMaskW,
					Math.max(m_mask._x, x + wnd.getW() - 3) - wnd.getW() + 6
				) - 3;
				y = Math.min(
					m_mask._y + m_nMaskH,
					Math.max(m_mask._y, y + wnd.getTitleBar().getH() - 3) - wnd.getTitleBar().getH() + 6
				) - 3;
				if(bSnap)
				{
					if(Math.abs(x - m_mask._x) < 7) x = m_mask._x;
					else if(Math.abs(x + wnd.getW() - m_mask._x - m_nMaskW) < 7) x = m_mask._x + m_nMaskW - wnd.getW();
					if(Math.abs(y - m_mask._y) < 7) y = m_mask._y;
					else if(Math.abs(y + wnd.getH() - m_mask._y - m_nMaskH) < 7) y = m_mask._y + m_nMaskH - wnd.getH();
				}
			}
			super.moveWindow(x, y, wnd, true);
		}
	}

	public function hideWindow(wnd:pseudo.BaseWindow):Void
	{
		var bAnimate = wnd._visible;
		super.hideWindow(wnd);
		if(bAnimate)
			classes.Global.playAniFrame(classes.Global.getRect(wnd), classes.Global.getRect(m_list, true));
		var newTopWnd:pseudo.BaseWindow = null;
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			if(m_arrWindows[i]._visible)
			{
				sendToTop(m_arrWindows[i]);
				return;
			}
		m_list.setSelCell(-1);
		m_list.update();
		m_list.draw();
	}

	public function maximizeWindow(wnd:pseudo.BaseWindow):Void
	{
		classes.Global.playAniFrame(classes.Global.getRect(wnd), classes.Global.getRect(m_mask));
		super.maximizeWindow(wnd);
	}

	public function showWindow(wnd:pseudo.BaseWindow):Void
	{
		if(!wnd._visible)
			classes.Global.playAniFrame(classes.Global.getRect(m_list, true), classes.Global.getRect(wnd));
		super.showWindow(wnd);
	}

	public function sendToTop(wnd:pseudo.BaseWindow):Void
	{
		super.sendToTop(wnd);
		var nId:Number = wnd.getId();
		for(var i:Number = 0; i < m_arrData.length; i++)
			if(m_arrData[i].id == nId)
			{
				m_list.setSelCell(i);
				m_list.setUpdated(false);
				// xxx
				m_list.update();
				m_list.draw();
				// xxx
				break;
			}
	}

	//
	// PRIVATE METHODS
	//
	private function getWndFromId(nId:Number):pseudo.BaseWindow
	{
		for(var i:Number = 0; i < m_arrData.length; i++)
			if(m_arrWindows[i].getId() == nId) return m_arrWindows[i];
		return null;
	}

	private function onListChanged():Void
	{
		var wnd:pseudo.BaseWindow = getWndFromId(m_list.getSelData().id);
		showWindow(wnd);
		sendToTop(wnd);
		update();
		draw();
	}

	private function getWndW(wnd:pseudo.BaseWindow, nW:Number):Number
	{
		var nWndW:Number = super.getWndW(wnd, nW);
		if(Math.abs(wnd._x + nWndW - m_mask._x - m_mask._width) < 7)
			nWndW = m_mask._x + m_mask._width - wnd._x;
		return nWndW;
	}

	private function getWndH(wnd:pseudo.BaseWindow, nH:Number):Number
	{
		var nWndH:Number = super.getWndH(wnd, nH);
		if(Math.abs(wnd._y + nWndH - m_mask._y - m_mask._height) < 7)
			nWndH = m_mask._y + m_mask._height - wnd._y;
		return nWndH;
	}
}