﻿class classes.CellThread extends pseudo.BaseMovie
{
	private var m_txtUser:TextField;
	private var m_txtInfo:TextField;
	private var m_txtMessage:TextField;
	private var m_image:MovieClip;
	static private var data:Object = new Object({className:"CellThread", type:"cellThread"});

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.CellThread
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.CellThread(pOwner[strName]);
		return pOwner[strName];
	}

	static public function getCellW(nW:Number, look:Object):Number
	{
		return nW;
	}

	static public function getCellH(h:Number, w:Number, look:Object, cellData:Object):Number
	{
		var fldTest:TextField = _global.testLayer["fldCellThread"];
		var offW:Number = look.getMargin("left", data) + look.getMargin("right", data);
		var offH:Number = look.getMargin("top", data) + look.getMargin("bottom", data);
		fldTest._width = getCellW(w, look) - offW;
		var msgData:Object = {type:data.type, mode:"message"};
		fldTest.htmlText = look.getTextDecoration("open", data)
			+ pseudo.Global.fixHtmlSpace(cellData.message)
			+ look.getTextDecoration("close", data);

		var cellH:Number = 50 + fldTest.textHeight + 4 + offH;
		return Math.max(80, cellH);
	}

	public function CellThread(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.CellThread;

		pThis.createTextField("m_txtUser", 1, 0, 0, 0, 0);
		m_txtUser = pThis["m_txtUser"];
		m_txtUser.html = true;
		m_txtUser.selectable = false;
		m_txtUser.multiline = true;

		pThis.createTextField("m_txtInfo", 2, 0, 0, 0, 0);
		m_txtInfo = pThis["m_txtInfo"];
		m_txtInfo.html = true;
		m_txtInfo.selectable = false;
		m_txtInfo.multiline = true;

		pThis.createTextField("m_txtMessage", 3, 0, 0, 0, 0);
		m_txtMessage = pThis["m_txtMessage"];
		m_txtMessage.html = true;
		m_txtMessage.selectable = true;
		m_txtMessage.multiline = true;
		m_txtMessage.wordWrap = true;

		m_data.className = "CellThread";
		m_data.type = "cellThread";
	}

	public function setLook(look:Object):Void
	{
		super.setLook(look);
	}

	public function setData(data:Object, bRecreate:Boolean):Void
	{
		if(data.mode != m_data.mode) m_bDrawn = false;
		super.setData(data);
		if(!m_bUpdated)
		{
			m_txtUser.htmlText = (m_data.name
					? m_look.getTextDecoration("open", {type:m_data.type, mode:"name"}) + m_data.name +
						m_look.getTextDecoration("close", {type:m_data.type, mode:"name"})
					: ""
				) + "<br>" +
				(m_data.role
					? m_look.getTextDecoration("open", {type:m_data.type, mode:"role"}) + m_data.role +
						m_look.getTextDecoration("close", {type:m_data.type, mode:"role"})
					: ""
				);
			m_txtInfo.htmlText = m_look.getTextDecoration("open", {type:m_data.type, mode:"joined"}) +
				(m_data.joined ? _global.lng.getAttr("threadJoined") + ": " + m_data.joined + "<br>" : "") +
				m_look.getTextDecoration("close", {type:m_data.type, mode:"joined"}) +
				m_look.getTextDecoration("open", {type:m_data.type, mode:"loc"}) +
				(m_data.loc ? _global.lng.getAttr("threadLocation") + ": " + m_data.loc + "<br>" : "") +
				m_look.getTextDecoration("close", {type:m_data.type, mode:"loc"}) +
				m_look.getTextDecoration("open", {type:m_data.type, mode:"posts"}) +
				(m_data.posts ? _global.lng.getAttr("threadPosts") + ": " + m_data.posts : "") +
				m_look.getTextDecoration("close", {type:m_data.type, mode:"posts"});

			if(m_data.message)
				m_txtMessage.htmlText = m_look.getTextDecoration("open", {type:m_data.type, mode:"message"}) +
					pseudo.Global.fixHtmlSpace(m_data.message) + m_look.getTextDecoration("close", {type:m_data.type, mode:"message"});
		}
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_nH = getCellH(m_nH, m_nW, m_look, m_data);
			m_nW = getCellW(m_nW);
			var nW:Number = m_nW - m_look.getMargin("left", m_data) - m_look.getMargin("right", m_data);
			var nH:Number = m_nH - m_look.getMargin("top", m_data) - m_look.getMargin("bottom", m_data);
			// size
			m_txtMessage._width = nW;
			m_txtMessage._height = nH - 50;
			var nUserW:Number = m_txtUser.textWidth + 4;
			var nInfoW:Number = m_txtInfo.textWidth + 4;
			var nSub:Number = -Math.round(Math.min(0, nW - nUserW - nInfoW) / 2);
			m_txtUser._width = nUserW - nSub;
			m_txtInfo._width = nInfoW - nSub;
			m_txtUser._height = m_txtInfo._height = 50;
			// pos
			m_txtMessage._x = m_txtUser._x = m_look.getMargin("left", m_data);
			m_txtUser._y = m_txtInfo._y = m_look.getMargin("top", m_data);
			m_txtInfo._x = m_nW - m_look.getMargin("right", m_data) - m_txtInfo._width;
			m_txtMessage._y = m_look.getMargin("top", m_data) + 50;
			super.update();
		}
	}
}