﻿class classes.ForumPane extends classes.BaseContent
{
	private var m_btnNewTopic:pseudo.PushButton;
	private var m_lblForumInfo:pseudo.Label;
	private var m_listTopics:pseudo.List;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.ForumPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.ForumPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function ForumPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.ForumPane;

		m_btnNewTopic = pseudo.PushButton.create(pThis, "m_btnNewTopic", 1);
		m_btnNewTopic.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnNewTopic.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("postNewTopic"));
		m_btnNewTopic.setName("btnNewTopic");

		m_lblForumInfo = pseudo.Label.create(pThis, "m_lblForumInfo", 2);
		m_lblForumInfo.setData({type:"label", mode:"out"});
		m_lblForumInfo.setVAlign("top");
		m_lblForumInfo.setWordWrap(true);
		m_lblForumInfo._x = 2;
		m_lblForumInfo._y = 0;
		m_lblForumInfo.setName("lblForumInfo");

		m_listTopics = pseudo.List.create(pThis, "m_listTopics", 3);
		m_listTopics.setCellClass(classes.CellText);
		m_listTopics.setData({border:5});
		m_listTopics.setName("listTopics");

		m_arrItems.push(m_btnNewTopic, m_lblForumInfo, m_listTopics);
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		switch(mode)
		{
			case "noData":
				m_listTopics.setListData(new Array());
				break;
			case "hasData":
				break;
		}
	}

	public function setInfoText(strInfo:String):Void
	{
		m_lblForumInfo.setText(strInfo);
		m_btnNewTopic._visible = m_lblForumInfo._visible = m_listTopics._visible = true;
		m_bUpdated = false;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_btnNewTopic.setW(Math.max(70, m_btnNewTopic.getMinW() + 10));
			m_btnNewTopic._x = m_nW - m_btnNewTopic.getW() - 5;
			m_btnNewTopic._y = m_nH - m_btnNewTopic.getH() - 5;
			m_lblForumInfo._visible = m_lblForumInfo.getText().length > 0;
			m_lblForumInfo.setW(m_nW - 4);
			if(m_lblForumInfo._visible)
			{
				m_lblForumInfo.update();
				m_lblForumInfo.setH(Math.min(Math.round(m_nH / 2), m_lblForumInfo.getTextH() + 4));
				m_listTopics._y = m_lblForumInfo._y + m_lblForumInfo.getH();
				m_listTopics.setData({border:5});
			}
			else
			{
				m_listTopics._y = 0;
				m_listTopics.setData({border:4});
			}
			m_listTopics.setSize(m_nW, m_btnNewTopic._y - m_listTopics._y - 5);
		}
		super.update();
	}
}