﻿class classes.GroupsPane extends classes.BaseContent
{
	private var m_cmbGroup:pseudo.ComboBox;
	private var m_lblDesc:TextField;
	private var m_lblDescVal:TextField;
	private var m_lblMembership:TextField;
	private var m_lblMembershipVal:TextField;
	private var m_btnMembership:pseudo.PushButton;
	private var m_listUsers:pseudo.List;
	private var m_btnClose:pseudo.PushButton;
	private var m_btnModerator:pseudo.PushButton;
	private var m_strDesc:String;
	private var m_strMembership:String;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.GroupsPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.GroupsPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function GroupsPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.GroupsPane;

		m_cmbGroup = pseudo.ComboBox.create(pThis, "m_cmbGroup", 1);
		m_cmbGroup.setName("cmbGroup");
		m_cmbGroup.setEdit(false);
		m_cmbGroup.addListener("changed", pThis, onSelectGroup);

		m_lblDesc = pseudo.Global.createLabel(pThis, "m_lblDesc", 2);
		m_lblDescVal = pseudo.Global.createLabel(pThis, "m_lblDescVal", 3);
		m_lblDescVal.wordWrap = true;
		m_lblMembership = pseudo.Global.createLabel(pThis, "m_lblMembership", 4);
		m_lblMembershipVal = pseudo.Global.createLabel(pThis, "m_lblMembershipVal", 5);
		m_lblMembershipVal.wordWrap = true;

		m_btnMembership = pseudo.PushButton.create(pThis, "m_btnMembership", 6);
		m_btnMembership.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnMembership.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("unsubscribe"));
		m_btnMembership.addListener("mouseRelease", pThis, onChangeMembership);
		m_btnMembership.setName("btnMembership");

		m_listUsers = pseudo.List.create(pThis, "m_list", 7);
		m_listUsers.setData({border:5});
		m_listUsers.setName("list");
		m_listUsers.setCellClass(classes.CellText);
		m_listUsers.addListener("changed", pThis, onWatchMemberInfo);

		m_btnModerator = pseudo.PushButton.create(pThis, "m_btnModerator", 8);
		m_btnModerator.setH(20);
		lbl = pseudo.Label(m_btnModerator.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("moderator"));
		m_btnModerator.addListener("mouseRelease", pThis, onModerator);
		m_btnModerator.setName("btnModerator");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 9);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		lbl = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");

		m_strDesc = m_strMembership = "";

		m_btnMembership._visible = false;
		m_arrItems.push(m_cmbGroup, m_btnMembership, m_listUsers, m_btnModerator, m_btnClose);
	}

	public function setValue(val:Object):Void
	{
		switch(val.dataType)
		{
			case "group":
				m_listUsers.setListData(val.members);
				m_strMembership = val.membershipText;
				m_strDesc = val.desc;
				var lbl:pseudo.Label = pseudo.Label(m_btnMembership.getItem("layerUser"));
				lbl.setText(_global.lng.getAttr((val.membership == "member") ? "unsubscribe" : "subscribe"));
				m_btnMembership.setUpdated(false);
				m_btnMembership._visible = val.membership != "moderator" && val.membership != "guest";
				m_bUpdated = false;
				break;
			case "groups":
				m_cmbGroup.setListData(val.groups);
				m_cmbGroup.setSelId(0);
				m_bUpdated = false;
				onSelectGroup();
				break;
		}
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		var bVis:Boolean = false;
		switch(mode)
		{
			case "noData":
				m_btnMembership._visible = false;
				if(!m_cmbGroup.getListData().length) m_cmbGroup._visible = false;
				break;
			case "hasData":
				m_cmbGroup._visible = bVis = true;
				break;
		}
		m_lblDesc._visible = m_lblDescVal._visible = m_lblMembership._visible
			= m_lblMembershipVal._visible = m_listUsers._visible
			= m_btnModerator._visible = bVis;
	}

	public function getMinW():Number
	{
		return m_btnModerator.getW() + m_btnClose.getW() + 15;
	}

	public function getMinH():Number
	{
		return 170;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_cmbGroup._y = 5;
			m_cmbGroup._x = 5;
			m_cmbGroup.setSize(m_nW - 10, 20);

			var strBeg:String = m_look.getTextDecoration("open", {type:"label"});
			var strEnd:String = m_look.getTextDecoration("close", {type:"label"});
			m_lblDesc.htmlText = strBeg + _global.lng.getAttr("groupDescr") + ":" + strEnd;
			m_lblMembership.htmlText = strBeg + _global.lng.getAttr("groupMembership") +":" + strEnd;

			var nW:Number = pseudo.Global.max(m_lblDesc.textWidth, m_lblMembership.textWidth) + 4;
			m_lblDesc._x = 5 + nW - m_lblDesc._width;
			m_lblDescVal._x = m_lblDesc._x + m_lblDesc._width;
			m_lblDescVal._width = Math.max(120, m_nW - 5 - m_lblDescVal._x);
			m_lblDescVal.htmlText = strBeg + m_strDesc + strEnd;
			m_btnMembership.setW(Math.max(70, m_btnMembership.getMinW() + 10));
			m_lblMembership._x = 5 + nW - m_lblMembership._width;
			m_lblMembershipVal._x =  m_btnMembership._x = m_lblMembership._x + m_lblMembership._width;
			m_lblMembershipVal._width = Math.max(120, m_nW - 5 - m_lblMembershipVal._x);
			m_lblMembershipVal.htmlText = strBeg + m_strMembership + strEnd;

			m_lblDesc._y = m_lblDescVal._y = m_cmbGroup._y + m_cmbGroup.getH() + 2;
			m_lblMembership._y = m_lblMembershipVal._y = m_lblDescVal._y + Math.max(m_lblDescVal._height, m_lblDesc._height) + 2;
			m_btnMembership._y = m_lblMembershipVal._y + Math.max(m_lblMembershipVal._height, m_lblMembership._height) + 2;

			var obj:Object = m_look.getParams({type:"resizeBtn"});

			m_btnModerator._x = 5;
			m_btnModerator._y = m_nH - m_btnModerator.getH() - obj.offY;
			m_btnModerator.setW(Math.max(70, m_btnModerator.getMinW() + 10));
			m_btnClose._x = m_nW - m_btnClose.getW() - obj.offX;
			m_btnClose._y = m_nH - m_btnClose.getH() - obj.offY;

			var nY:Number = m_btnMembership._visible
				? m_btnMembership._y + m_btnMembership.getH()
				: m_lblMembership._y + Math.max(m_lblMembership._height, m_lblMembershipVal._height) + 2;
			m_listUsers._y = 5 + nY;
			var nListH:Number = Math.max(0, m_btnClose._y - nY - 10);
			m_listUsers.setSize(m_nW, nListH);
			m_listUsers._visible = m_mode == "hasData" && nListH > m_look.getMargin("top", m_listUsers.getData()) + m_look.getMargin("bottom", m_listUsers.getData());
			m_listUsers.setData({border:m_listUsers.getListData().length ? 5 : 4});
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//

	private function onModerator():Void
	{
		fireEvent("watchModeratorInfo", m_cmbGroup.getSelData());
	}

	private function onWatchMemberInfo():Void
	{
		fireEvent("watchMemberInfo", m_listUsers.getSelData());
		m_listUsers.setSelCell(-1);
	}

	private function onChangeMembership():Void
	{
		fireEvent("changeMembership", m_cmbGroup.getSelData());
	}

	private function onSelectGroup():Void
	{
		fireEvent("selectGroup", m_cmbGroup.getSelData());
	}
}