﻿class classes.LeftPane extends pseudo.BaseMovie
{
	private var m_arrPanes:Array;
	private var m_arrResize:Array;
	private var m_nMsPos:Number;
	private var m_mouseOff:Number;
	private var m_scale:pseudo.ScaleArray;
	private var m_layerResize:MovieClip;
	private var m_nResizeId:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.LeftPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.LeftPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function LeftPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.LeftPane;

		m_arrPanes = new Array();
		m_arrResize = new Array();
		addCurtain(pThis, classes.CatForumPane, 1, "paneCatForum", _global.lng.getAttr("catforum"));
		addCurtain(pThis, classes.ForumPane, 2, "paneForum");
		addCurtain(pThis, classes.OpenedWindowsPane, 3, "paneOpenedTopics", _global.lng.getAttr("openedWindows"));

		for(var i:Number = 0; i < 2; i++)
		{
			var resize:pseudo.ResizeLine = pseudo.ResizeLine.create(pThis, "resize" + i, 4 + i);
			resize.setAlign("top");
			resize.addListener("startResize", pThis, onStartResize, i);
			resize.addListener("finishResize", pThis, onFinishResize, i);
			resize._alpha = 0;
			m_arrResize.push(resize);
			m_arrItems.push(resize);
		}
		m_scale = new pseudo.ScaleArray(3);
	}

	public function addCurtain(pThis:MovieClip, pContent:Function, depth:Number, id:String, text:String):Void
	{
		var curtain:pseudo.Curtain = pseudo.Curtain.create(pThis, "curtain" + depth, depth);
		var pane:pseudo.Pane = pseudo.Pane(curtain.setPane(pseudo.Pane));
		curtain.setAlign("bottom");
		curtain.setName(id);
		curtain._x = 4;
		pane.setContent(pContent);
		curtain.addListener("showHide", pThis, onShowHide, m_arrPanes.length);
		curtain.setResize(classes.ResizeTitle);
		var btnResize:pseudo.ToggleButton =
			pseudo.ToggleButton(curtain.getItem("layerResize"));
		var lbl:pseudo.Label = pseudo.Label(btnResize.addItem(pseudo.Label));
		lbl.setData({type:"resizeTitle"});
		lbl.setText(text ? text : "");
		m_arrPanes.push(curtain);
		m_arrItems.push(curtain);
	}

	public function getMinW():Number
	{
		return 100;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var w:Number = m_nW - 8;
			for(var i:Number = 0; i < m_arrPanes.length; i++)
				m_arrPanes[i].setW(w);
			var nH:Number = getScaleH();
			var curY:Number = 4;
			for(var i:Number = 0; i < m_arrPanes.length - 1; i++)
			{
				var curtain:pseudo.Curtain = m_arrPanes[i];
				if(!curtain.isHidden()) curtain.setH(Math.round(nH * m_scale.getK(i)));
				curtain._y = curY;
				curY = curtain._y + curtain.getH();
				m_arrResize[i]._x = 4;
				m_arrResize[i]._y = curY;
				m_arrResize[i].setSize(w, 4);
				curY += 4;
			}
			var curtain:pseudo.Curtain = m_arrPanes[m_arrPanes.length - 1];
			if(!curtain.isHidden()) curtain.setH(m_nH - curY - 4);
			curtain._y = curY;
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//

	private function getScaleH():Number
	{
		var nFixH:Number = 0;
		for(var i:Number = 0; i < m_arrPanes.length; i++)
			if(m_arrPanes[i].isHidden()) nFixH += m_arrPanes[i].getH();
		return m_nH - nFixH - 16;
	}

	private function onShowHide(nId:Number):Void
	{
		m_bUpdated = false;
		m_scale.setVisible(nId, !m_arrPanes[nId].isHidden());
		for(var i:Number = 0; i < 2; i++)
			m_arrResize[i]._visible = m_scale.canResize(i);
		update();
		draw();
	}

	private function onStartResize(nId:Number):Void
	{
		if(!m_layerResize) createEmptyMovieClip("m_layerResize", getNextHighestDepth());
		onMouseMove = onResize;
		m_nMsPos = _ymouse;
		m_nResizeId = nId;
		m_mouseOff = _ymouse - m_arrPanes[nId]._y - m_arrPanes[nId].getH();
		onResize();
	}

	private function onFinishResize(nId:Number):Void
	{
		if(m_layerResize) m_layerResize.removeMovieClip();
		delete onMouseMove;
		m_scale.scale(nId, (_ymouse - m_nMsPos) / getScaleH(), true);
		m_bUpdated = false;
		update();
		draw();
	}

	private function onResize():Void
	{
		if(m_layerResize)
		{
			var x:Number = m_arrPanes[m_nResizeId]._x;
			var w:Number = m_arrPanes[m_nResizeId].getW();
			var h:Number = getScaleH();
			var y:Number = 0;
			var arr:Array = m_scale.scale(m_nResizeId, (_ymouse - m_nMsPos) / h);
			for(var i:Number = 0; i <= m_nResizeId; i++)
			{
				y += 4 + (m_arrPanes[i].isHidden()
					? m_arrPanes[i].getH()
					: Math.round(h * arr[i].k));
			}
			m_layerResize.clear();
			m_look.drawResizeLine(m_layerResize, x, y, w, 4);
			// delete block
			for(var i:Number = 0; i < arr.length; i++) delete arr[i];
			delete arr;
		}
	}
}