﻿class classes.LoginPane extends pseudo.BaseMovie
{
	private var m_btnSubmit:pseudo.PushButton;
	private var m_lblUser:pseudo.Label;
	private var m_editUser:pseudo.Edit;
	private var m_lblPass:pseudo.Label;
	private var m_editPass:pseudo.Edit;
	private var m_btnNewUser:pseudo.PushButton;
	private var m_btnForgot:pseudo.PushButton;
	private var m_btnAuto:pseudo.ToggleButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.LoginPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.LoginPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function LoginPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.LoginPane;

		m_lblUser = pseudo.Label.create(pThis, "m_lblUser", 1);
		m_lblUser.setAlign("right");
		m_lblUser.setText(_global.lng.getAttr("userName") + ":");
		m_lblUser.setName("lblUser");
		m_lblUser.setAutoSize(true);

		m_editUser = pseudo.Edit.create(pThis, "m_editUser", 2);
		m_editUser.setMultiline(false);
		m_editUser.setName("editUser");

		m_lblPass = pseudo.Label.create(pThis, "m_lblPass", 3);
		m_lblPass.setAlign("right");
		m_lblPass.setText(_global.lng.getAttr("password") + ":");
		m_lblPass.setName("lblPass");
		m_lblPass.setAutoSize(true);

		m_editPass = pseudo.Edit.create(pThis, "m_editPass", 4);
		m_editPass.setMultiline(false);
		m_editPass.setName("editPass");

		m_editPass.setUsePassword(true);

		m_btnSubmit = pseudo.PushButton.create(pThis, "m_btnSubmit", 5);
		m_btnSubmit.setData({type:"btnSubmit", sound:"btnRelease"});
		m_btnSubmit.setName("btnSubmit");
		m_btnSubmit.setH(20);
		var lblSubmit:pseudo.Label = pseudo.Label(m_btnSubmit.addItem(pseudo.Label));
		lblSubmit.setAlign("center");
		lblSubmit.setText(_global.lng.getAttr("submit"));

		m_btnNewUser = pseudo.PushButton.create(pThis, "m_btnNewUser", 6);
		m_btnNewUser.setName("btnNewUser");
		m_btnNewUser.getData().type = "iconButton";
		var layer:pseudo.BaseMovie = m_btnNewUser.addItem(pseudo.BaseMovie);
		layer.setData({type:"iconLayer", icon:"newUser", drawBg:true});
		layer.addListener("update", layer, function(){ this.setDrawn(false); });

		m_btnForgot = pseudo.PushButton.create(pThis, "m_btnForgot", 7);
		m_btnForgot.setName("btnForgot");
		m_btnForgot.getData().type = "iconButton";
		layer = m_btnForgot.addItem(pseudo.BaseMovie);
		layer.setData({type:"iconLayer", icon:"forgotPass", drawBg:true});
		layer.addListener("update", layer, function(){ this.setDrawn(false); });

		m_btnAuto = pseudo.ToggleButton.create(pThis, "m_btnAuto", 8);
		m_btnAuto.setName("btnAuto");
		m_btnAuto.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnAuto.addItem(pseudo.Label));
		lbl.setText(_global.lng.getAttr("autoLogon"));
		m_btnAuto.setData({type:"checkbox", sound:"btnRelease"});

		m_arrItems.push(m_btnSubmit, m_lblUser, m_editUser, m_lblPass,
			m_editPass, m_btnNewUser, m_btnForgot, m_btnAuto);
	}

	public function setLook(look:Object):Void
	{
		super.setLook(look);
		pseudo.Label(m_btnAuto.getItem("layerUser")).setAlign(m_look.getParams({type:"checkbox"}).align);
	}

	public function getMinH():Number
	{
		update();
		return m_nH;
	}

	public function getPrefW():Number
	{
		return 300;
	}

	public function getPrefH():Number
	{
		return 150;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_lblUser.update();
			m_lblPass.update();
			var w:Number = 3 + Math.max(m_lblUser.getW(), m_lblPass.getW());
			m_lblUser._x = w - m_lblUser.getW();
			m_lblPass._x = w - m_lblPass.getW();
			m_editUser._x = m_editPass._x = w;
			var size:Number = m_lblUser.getH();
			m_btnNewUser.setSize(size, size);
			m_btnForgot.setSize(size, size);
			var editUserW:Number = Math.max(10, m_nW - m_editUser._x - 5 - (m_btnNewUser._visible ? m_btnNewUser.getW() + 2 : 0));
			var editPassW:Number = Math.max(10, m_nW - m_editPass._x - 5 - (m_btnForgot._visible ? m_btnForgot.getW() + 2 : 0));
			m_editUser.setSize(editUserW, m_lblUser.getH());
			m_editPass.setSize(editPassW, m_lblPass.getH());
			m_btnNewUser._x = m_editUser._x + m_editUser.getW() + 2;
			m_btnForgot._x = m_editPass._x + m_editPass.getW() + 2;
			var y:Number = 8;
			var h:Number = pseudo.Global.max(m_lblUser.getH(), m_editUser.getH(), m_btnNewUser.getH());
			m_lblUser._y = y + Math.round((h - m_lblUser.getH()) / 2);
			m_editUser._y = y + Math.round((h - m_editUser.getH()) / 2);
			m_btnNewUser._y = y + Math.round((h - m_btnNewUser.getH()) / 2);
			y += h + 5;
			h = pseudo.Global.max(m_lblPass.getH(), m_editPass.getH(), m_btnForgot.getH());
			m_lblPass._y = y + Math.round((h - m_lblPass.getH()) / 2);
			m_editPass._y = y + Math.round((h - m_editPass.getH()) / 2);
			m_btnForgot._y = y + Math.round((h - m_btnForgot.getH()) / 2);
			y += h + 5;
			m_btnSubmit.setW(Math.max(70, m_btnSubmit.getMinW() + 10));
			if(m_btnAuto._visible)
			{
				m_btnAuto._y = y;
				m_btnAuto.setW(Math.max(70, m_btnAuto.getMinW()));
				m_btnAuto._x = m_nW - m_btnAuto.getW() - 5;
				if(m_btnAuto.getW() + m_btnSubmit.getW() + 17 > m_nW)
				{
					m_btnSubmit._y = m_btnAuto._y + m_btnAuto.getH() + 5;
					m_btnAuto._x = m_nW - m_btnAuto.getW() - 5;
					m_btnSubmit._x = m_nW - m_btnSubmit.getW() - 5;
				}
				else
				{
					m_btnSubmit._y = y;
					m_btnSubmit._x = m_btnAuto._x - m_btnSubmit.getW() - 7;
				}
			}
			else
			{
				m_btnSubmit._y = y;
				m_btnSubmit._x = m_nW - m_btnSubmit.getW() - 5;
			}
			m_nH = m_btnSubmit._y + m_btnSubmit.getH() + 8;
		}
		super.update();
	}
}