﻿class classes.Main extends pseudo.BaseMovie
{
	private var m_mngWin:classes.BBWindowManager;
	private var m_mngAlert:pseudo.WindowManager;
	private var m_paneTop:pseudo.Curtain;
	private var m_paneLeft:pseudo.Curtain;
	private var m_paneRight:pseudo.Curtain;
	private var m_layerResize:MovieClip;
	private var m_nMouseOff:Number; // mouse offset from pane border
	private var m_resizePane:pseudo.Curtain;
	private var m_resizeX:Number;
	private var m_resizeY:Number;
	private var m_resizeW:Number;
	private var m_resizeH:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.Main
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.Main(pOwner[strName]);
		return pOwner[strName];
	}

	public function Main(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.Main;

		m_paneTop = pseudo.Curtain.create(pThis, "m_paneTop", 2);
		var resize:pseudo.BaseMovie = m_paneTop.setResize(pseudo.ResizeHideLine);
		resize.addListener("startResize", pThis, onStartResizePane, m_paneTop);
		resize.addListener("finishResize", pThis, onFinishResizePane);
		m_paneTop.addListener("showHide", pThis, onShowHide);
		m_paneTop.setAlign("top");
		var pane:pseudo.Pane = pseudo.Pane(m_paneTop.setPane(pseudo.Pane));
		pane.setData({type:"topPane", border:0});
		pane.setContent(classes.TopPane);
		m_paneTop.setName("paneTop");
		var size:Number = parseInt(_global.xmlConfig.getAttr("paneTopH"));
		m_paneTop.setH(size ? size : 40);

		m_paneLeft = pseudo.Curtain.create(pThis, "m_paneLeft", 3);
		resize = m_paneLeft.setResize(pseudo.ResizeHideLine);
		resize.addListener("startResize", pThis, onStartResizePane, m_paneLeft);
		resize.addListener("finishResize", pThis, onFinishResizePane);
		m_paneLeft.addListener("showHide", pThis, onShowHide);
		m_paneLeft.setData({border:0});
		m_paneLeft.setAlign("left");
		pseudo.Pane(m_paneLeft.setPane(pseudo.Pane)).setContent(classes.LeftPane);
		m_paneLeft.setName("paneLeft");
		size = parseInt(_global.xmlConfig.getAttr("paneLeftW"));
		m_paneLeft.setW(size ? size : 214);

		m_paneRight = pseudo.Curtain.create(pThis, "m_paneRight", 4);
		resize = m_paneRight.setResize(pseudo.ResizeHideLine);
		resize.addListener("startResize", pThis, onStartResizePane, m_paneRight);
		resize.addListener("finishResize", pThis, onFinishResizePane);
		m_paneRight.addListener("showHide", pThis, onShowHide);
		m_paneRight.setData({border:0});
		m_paneRight.setAlign("right");
		pseudo.Pane(m_paneRight.setPane(pseudo.Pane)).setContent(classes.RightPane);
		m_paneRight.setName("paneRight");
		size = parseInt(_global.xmlConfig.getAttr("paneRightW"));
		m_paneRight.setW(size ? size : 214);

		// manager for modeless windows
		m_mngWin = classes.BBWindowManager.create(pThis, "m_mngWin", 1);
		m_mngWin.setName("windowManager");
		m_mngWin.showMaximized(_global.xmlConfig.getAttr("showMaximized") == "on");
		m_mngWin.setList(pseudo.List(m_paneLeft.getItem("pane").getItem("content").getItem("paneOpenedTopics").getItem("pane").getItem("content").getItem("listOpened")));

		// manager for modal windows
		m_mngAlert = classes.BBWindowManager.create(pThis, "m_mngAlert", 5);
		m_mngAlert.setStart("center", "middle");
		m_mngAlert.setName("alertMng");

		m_data.className = "Main";
		m_data.type = "main";
		m_nMouseOff = 0;

		m_arrItems.push(m_mngWin, m_mngAlert, m_paneTop, m_paneLeft, m_paneRight);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var nLeft:Number = m_look.getMargin("left", m_data);
			var nRight:Number = m_look.getMargin("right", m_data);
			var nTop:Number = m_look.getMargin("top", m_data);
			var nBottom:Number = m_look.getMargin("bottom", m_data);
			var nPaneH:Number = Math.max(200, m_nH - nTop - nBottom);
			m_paneLeft.setH(nPaneH);
			m_paneRight.setH(nPaneH);
			m_paneTop.setW(Math.max(150, m_nW - m_paneLeft.getW() - m_paneRight.getW() - 4 - nLeft - nRight));
			m_paneLeft._y = m_paneTop._y = m_paneRight._y = nTop;
			m_paneLeft._x = nLeft;
			m_paneTop._x = m_paneLeft._x + m_paneLeft.getW() + 2;
			m_paneRight._x = Math.max(m_paneLeft._x + m_paneLeft.getW() + 6, m_nW - m_paneRight.getW() - nRight);
			var nX:Number = m_paneLeft._x + m_paneLeft.getW();
			m_mngWin.setSize(m_nW, m_nH);
			m_mngWin.setWorkArea(
				nX,	m_paneTop._y + m_paneTop.getH(),
				m_paneRight._x - nX, nPaneH - m_paneTop.getH()
			);
			m_mngAlert.setSize(m_nW, m_nH);
			m_mngAlert.setWorkArea(0, 0, m_nW, m_nH);
		}
		super.update();
		m_data.x1 = m_paneLeft._x;
		m_data.y1 = m_paneLeft._y;
		m_data.x2 = m_paneRight._x + m_paneRight.getW() - m_paneLeft._x;
		m_data.y2 = m_paneRight.getH();
	}

	//
	// PRIVATE METHODS
	//
	private function onShowHide():Void
	{
		m_bUpdated = false;
		update();
		draw();
	}

	private function onStartResizePane(pane:pseudo.Curtain):Void
	{
		m_resizePane = pane;
		if(!m_layerResize) createEmptyMovieClip("m_layerResize", getNextHighestDepth());
		switch(pane.getAlign())
		{
			case "left": m_nMouseOff = _xmouse - pane._x - pane.getW(); break;
			case "right": m_nMouseOff = _xmouse - pane._x; break;
			case "top": m_nMouseOff = _ymouse - pane._y - pane.getH(); break;
			case "bottom": m_nMouseOff = _ymouse - pane._y + pane.getH(); break;
		}
		onMouseMove = onResizePane;
		onResizePane(pane);
	}

	private function onFinishResizePane():Void
	{
		m_resizeX = m_resizeY = m_resizeW = m_resizeH = 0;
		if(m_layerResize) m_layerResize.removeMovieClip();
		switch(m_resizePane.getAlign())
		{
			case "left":
				m_resizePane.setW(Math.min(400, Math.max(m_resizePane.getMinW(), _xmouse - m_resizePane._x - m_nMouseOff)));
				break;
			case "right":
				m_resizePane.setW(Math.min(400, Math.max(m_resizePane.getMinW(), m_resizePane._x - _xmouse + m_nMouseOff + m_resizePane.getW())));
				break;
			case "top":
				m_resizePane.setH(Math.min(300, Math.max(m_resizePane.getMinH(), _ymouse - m_resizePane._y - m_nMouseOff)));
				break;
			case "bottom":
				m_resizePane.setH(Math.min(300, Math.max(m_resizePane.getMinH(), _ymouse - m_resizePane._y - m_nMouseOff + m_resizePane.getH())));
				break;
		}
		m_bUpdated = m_resizePane.isUpdated();
		m_resizePane.show();
		update();
		draw();
		delete onMouseMove;
	}

	private function onResizePane():Void
	{
		var x, y, w, h:Number;
		if(m_layerResize)
		{
			switch(m_resizePane.getAlign())
			{
				case "left":
					x = m_resizePane._x;
					y = m_resizePane._y;
					w = Math.min(400, Math.max(m_resizePane.getMinW(), _xmouse - m_resizePane._x - m_nMouseOff));
					h = m_resizePane.getH();
					break;
				case "right":
					var nW:Number = Math.min(400, Math.max(m_resizePane.getMinW(), m_resizePane._x - _xmouse + m_nMouseOff + m_resizePane.getW()));
					x = m_resizePane._x + m_resizePane.getW() - nW;
					y = m_resizePane._y;
					w = nW;
					h = m_resizePane.getH();
					break;
				case "top":
					x = m_resizePane._x;
					y = m_resizePane._y;
					w = m_resizePane.getW();
					h = Math.min(300, Math.max(m_resizePane.getMinH(), _ymouse - m_resizePane._y - m_nMouseOff));
					break;
				case "bottom":
					var nH:Number = Math.min(400, Math.max(m_resizePane.getMinH(), m_resizePane._y - _ymouse + m_nMouseOff + m_resizePane.getH()));
					x = m_resizePane._x;
					y = m_resizePane._y + m_resizePane.getH() - nH;
					w = m_resizePane.getH();
					h = nH;
					break;
			}
			if(x != m_resizeX || y != m_resizeY || w != m_resizeW || h != m_resizeH)
			{
				m_look.drawResizeFrame(m_layerResize, x, y, w, h);
				m_resizeX = x;
				m_resizeY = y;
				m_resizeW = w;
				m_resizeH = h;
			}
		}
	}
}