﻿class classes.MembersPane extends classes.BaseContent
{
	private var m_list:pseudo.List;
	private var m_btnClose:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.MembersPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.MembersPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function MembersPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.MembersPane;

		m_list = pseudo.List.create(pThis, "m_list", 1);
		m_list.setData({border:4});
		m_list.setName("list");
		m_list.setCellClass(classes.CellText);
		m_list.addListener("changed", pThis, onWatchMember);

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 2);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		var lbl:pseudo.Label = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");

		m_arrItems.push(m_list, m_btnClose);
	}

	public function getMinW():Number
	{
		return m_btnClose.getW() + 10;
	}

	public function getMinH():Number
	{
		return 70;
	}

	public function setValue(val:Object):Void
	{
		m_list.setListData(val.members);
		m_list.setUpdated(false);
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		switch(mode)
		{
			case "noData":
				m_list._visible = false;
				break;
			case "hasData":
				m_list._visible = true;
				break;
		}
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var obj:Object = m_look.getParams({type:"resizeBtn"});
			m_btnClose._x = m_nW - m_btnClose.getW() - obj.offX;
			m_btnClose._y = m_nH - m_btnClose.getH() - obj.offY;
			m_list.setSize(m_nW, Math.max(0, m_btnClose._y - 5));
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function onWatchMember():Void
	{
		fireEvent("watchMember", m_list.getSelData());
		m_list.setSelCell(-1);
	}
}