﻿class classes.MessagePane extends classes.BaseContent
{
	private var m_lblTitle:pseudo.Label;
	private var m_editTitle:pseudo.Edit;
	private var m_lblName:pseudo.Label;
	private var m_editName:pseudo.Edit;
	private var m_btnB:pseudo.ToggleButton;
	private var m_btnI:pseudo.ToggleButton;
	private var m_btnU:pseudo.ToggleButton;
	private var m_areaMsg:pseudo.TextArea;
	private var m_editMsg:pseudo.Edit;
	private var m_btnClose:pseudo.PushButton;
	private var m_btnSubmit:pseudo.PushButton;
	private var m_nBeg:Number;
	private var m_nEnd:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.MessagePane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.MessagePane(pOwner[strName]);
		return pOwner[strName];
	}

	public function MessagePane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.MessagePane;

		m_lblTitle = pseudo.Label.create(pThis, "m_lblTitle", 1);
		m_lblTitle.setAlign("right");
		m_lblTitle.setText(_global.lng.getAttr("topicTitle") + ":");
		m_lblTitle.setName("lblTitle");

		m_editTitle = pseudo.Edit.create(pThis, "m_editTitle", 2);
		m_editTitle.setData({type:"edit"});
		m_editTitle.setMultiline(false);
		m_editTitle.setName("editTitle");

		m_lblName = pseudo.Label.create(pThis, "m_lblName", 3);
		m_lblName.setAlign("right");
		m_lblName.setText(_global.lng.getAttr("userName") + ":");
		m_lblName.setName("lblName");

		m_editName = pseudo.Edit.create(pThis, "m_editName", 4);
		m_editName.setData({type:"edit"});
		m_editName.setMultiline(false);
		m_editName.setName("editName");

		m_lblTitle._x = m_lblName._x = 5;
		m_lblTitle._y = m_editTitle._y = 5;

		m_btnB = pseudo.ToggleButton.create(pThis, "m_btnB", 5);
		m_btnB.setSize(23, 23);
		var lbl:pseudo.Label = pseudo.Label(m_btnB.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText("<b>B</b>");
		m_btnB.setName("btnBold");
		m_btnB.addListener("mouseRelease", pThis, onAddTag, m_btnB, "[b]", "[/b]");

		m_btnI = pseudo.ToggleButton.create(pThis, "m_btnI", 6);
		m_btnI.setSize(23, 23);
		lbl = pseudo.Label(m_btnI.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText("<i>I </i>");
		m_btnI.setName("btnItalic");
		m_btnI.addListener("mouseRelease", pThis, onAddTag, m_btnI, "[i]", "[/i]");

		m_btnU = pseudo.ToggleButton.create(pThis, "m_btnU", 7);
		m_btnU.setSize(23, 23);
		lbl = pseudo.Label(m_btnU.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText("<u>U</u>");
		m_btnU.setName("btnUnderline");
		m_btnU.addListener("mouseRelease", pThis, onAddTag, m_btnU, "[u]", "[/u]");

		m_areaMsg = pseudo.TextArea.create(pThis, "m_areaMsg", 8);
		m_areaMsg._x = 5;
		m_editMsg = pseudo.Edit(m_areaMsg.getItem("edit"));
		m_editMsg.addListener("mouseUp", pThis, updateButtons);
		m_editMsg.addListener("setFocus", pThis, onMsgSetFocus);
		m_editMsg.addListener("killFocus", pThis, onMsgKillFocus);
		m_areaMsg.setName("areaMessage");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 9);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		lbl = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");

		m_btnSubmit = pseudo.PushButton.create(pThis, "m_btnSubmit", 10);
		m_btnSubmit.setH(20);
		lbl = pseudo.Label(m_btnSubmit.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("submit"));
		m_btnSubmit.setName("btnSubmit");

		m_nBeg = m_nEnd = 0;

		m_arrItems.push(m_lblTitle, m_editTitle, m_lblName, m_editName,
			m_btnB, m_btnI, m_btnU, m_areaMsg, m_btnClose, m_btnSubmit);
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		var bVis:Boolean = false;
		switch(mode)
		{
			case "noData":
				m_lblName._visible = m_editName._visible = false;
				break;
			case "hasData":
				bVis = true;
				break;
		}
		m_lblTitle._visible = m_editTitle._visible = m_btnB._visible = m_btnI._visible
			= m_btnU._visible = m_areaMsg._visible = m_btnSubmit._visible = bVis;
	}

	public function setValue(val:Object):Void
	{
		m_lblName._visible = m_editName._visible = !val.logged;
		var fld:TextField = _global.testLayer["fldCellThread"];
		if(val.subj)
		{
			fld.htmlText = val.subj;
			m_editTitle.setText(fld.text);
		}
		if(val.msg)
		{
			fld.htmlText = val.msg;
			m_editMsg.setText(fld.text);
		}
		m_bUpdated = false;
	}

	public function getMessageText():String
	{
		return m_areaMsg.getText().split("\r").join("\n");
	}

	public function getMinW():Number
	{
		return 157;
	}

	public function getMinH():Number
	{
		return 155;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var nW:Number = Math.max(getMinW() - m_look.getBorder("left", m_data) - m_look.getBorder("right", m_data), m_nW);
			var nH:Number = Math.max(getMinH() - m_look.getBorder("top", m_data) - m_look.getBorder("bottom", m_data), m_nH);
			var nTextW:Number = m_lblTitle.getMinW();
			if(m_lblName._visible) nTextW = Math.max(nTextW, m_lblName.getMinW());
			m_lblTitle.setSize(nTextW, m_lblTitle.getMinH());
			m_editTitle.setSize(Math.max(3, nW - m_lblTitle._x - m_lblTitle.getW() - 8), m_lblTitle.getH());
			var nY:Number = m_lblTitle._y + m_lblTitle.getH() + 5;
			if(m_lblName._visible && m_editName._visible)
			{
				m_lblName.setSize(nTextW, m_lblTitle.getH());
				m_editName.setSize(m_editTitle.getW(), m_editTitle.getH());
				m_lblName._y = m_editName._y = m_lblTitle._y + m_lblTitle.getH() + 5;
				nY = m_lblName._y + m_lblName.getH() + 5;
			}
			m_editTitle._x = m_editName._x = nTextW + 3 + 5;
			m_btnB._y = m_btnI._y = m_btnU._y = nY;
			m_btnU._x = nW - m_btnU.getW() - 5;
			m_btnI._x = m_btnU._x - m_btnI.getW() - 3;
			m_btnB._x = m_btnI._x - m_btnB.getW() - 3;
			m_areaMsg._y = m_btnB._y + m_btnB.getH() + 5;

			var obj:Object = m_look.getParams({type:"resizeBtn"});
			m_btnClose._x = nW - m_btnClose.getW() - obj.offX;
			m_btnSubmit.setW(Math.max(70, m_btnSubmit.getMinW() + 10));
			m_btnSubmit._x = m_btnClose._x - m_btnSubmit.getW() - 5
			m_btnClose._y = m_btnSubmit._y = nH - m_btnClose.getH() - obj.offY;
			m_areaMsg.setSize(nW - m_areaMsg._x * 2, Math.max(3, m_btnClose._y - m_areaMsg._y - 5));
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function isOpen(strText:String, strOpen:String, strClose:String):Boolean
	{
		var nInd:Number = 0;
		while(true)
		{
			nInd = strText.indexOf(strOpen, nInd);
			if(nInd == -1) return false;
			nInd += strOpen.length;
			nInd = strText.indexOf(strClose, nInd);
			if(nInd == -1) return true;
			nInd += strOpen.length;
		}
		return false;
	}

	private function onAddTag(btn:pseudo.ToggleButton, strOpen:String, strClose:String):Void
	{
		Selection.setFocus(m_editMsg.getField()._target);
		if(m_nBeg == m_nEnd)
		{
			Selection.setSelection(m_nBeg, m_nBeg);
			var strNew:String = btn.isSunken() ? strOpen : strClose;
			m_editMsg.getField().replaceSel(strNew);
			//m_nBeg = m_nEnd = m_nBeg + strNew.length;
		}
		else
		{
			Selection.setSelection(m_nBeg, m_nBeg);
			var strBeg:String = btn.isSunken() ? strOpen : strClose;
			var strEnd:String = btn.isSunken() ? strClose : strOpen;
			m_editMsg.getField().replaceSel(strBeg);
			m_nEnd += strBeg.length;
			Selection.setSelection(m_nEnd, m_nEnd);
			m_editMsg.getField().replaceSel(strEnd);
			//m_nBeg = m_nEnd = m_nEnd + strEnd.length;
		}
		updateButtons();
		m_editMsg.setText(m_editMsg.getFieldText());
	}

	private function updateButtons():Void
	{
		if(Selection.getFocus() == "" + m_editMsg.getField())
		{
			var nBeg:Number = Selection.getBeginIndex();
			var nEnd:Number = Selection.getEndIndex();
			if(nBeg > -1) m_nBeg = nBeg;
			if(nEnd > -1) m_nEnd = nEnd;
			var strText:String = m_editMsg.getFieldText().toLowerCase();
			m_btnB.setState(isOpen(strText.substr(0, m_nBeg), "[b]", "[/b]") ? "sunken" : "normal");
			m_btnI.setState(isOpen(strText.substr(0, m_nBeg), "[i]", "[/i]") ? "sunken" : "normal");
			m_btnU.setState(isOpen(strText.substr(0, m_nBeg), "[u]", "[/u]") ? "sunken" : "normal");
		}
	}

	private function onMsgSetFocus():Void
	{
		m_editMsg.addListener("keyUp", this, updateButtons);
	}	

	private function onMsgKillFocus():Void
	{
		m_editMsg.removeListener("keyUp", this);
	}	
}