﻿class classes.PaneContainer extends pseudo.BaseMovie
{
	private var m_arrPanes:Array;
	private var m_arrResize:Array;
	private var m_nMsPos:Number;
	private var m_mouseOff:Number;
	private var m_scale:pseudo.ScaleArray;
	private var m_layerResize:MovieClip;
	private var m_nResizeId:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.PaneContainer
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.PaneContainer(pOwner[strName]);
		return pOwner[strName];
	}

	public function PaneContainer(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.PaneContainer;

		m_layerResize = pThis.createEmptyMovieClip("m_layerResize", 1);
		m_arrPanes = new Array();
		m_arrResize = new Array();
	}

	private function getPosFromPt(pt:Object):Object
	{
		var y:Number = 4;
		var h:Number = m_nH - 4;
		var ptLocal:Object = {x:pt.x, y:pt.y};
		globalToLocal(ptLocal);
		var objPos:Object = {paneId:0, align:"above"};

		if(m_arrPanes.length && m_arrPanes[0]._y < ptLocal.y)
		{
			for(var i:Number = 0; i < m_arrPanes.length; i++)
			{
				var pane:pseudo.Curtain = m_arrPanes[i];
				if(pane.isMouseOver(pt.x, pt.y))
				{ // in the pane
					objPos.paneId = i;
					objPos.align = (pane._y + pane.getH() / 2 > ptLocal.y) ? "top" : "bottom";
					break;
				}
				if(pane._y > ptLocal.y)
				{ // between panes
					objPos.paneId = i - 1;
					objPos.align = "below";
					break;
				}
				if(i > m_arrPanes.length - 2)
				{
					objPos.paneId = i;
					objPos.align = "below";
					break;
				}
			} // for(var i:Number = 0; i < m_arrPanes.length; i++)
		} // if(pane._y > ptLocal.y)
		return objPos;
	}

	public function getRectFromPt(pt:Object, item:pseudo.BaseMovie):Object
	{
		var objPos:Object = getPosFromPt(pt);
		var pane:pseudo.Curtain = m_arrPanes[objPos.paneId];
		var h:Number = 0;
		var y:Number = 0;
		switch(objPos.align)
		{
			case "above":
				h = Math.round((m_nH - (m_arrPanes.length + 1) * 4) / (m_arrPanes.length + 1));
				y = pane._y;
				break;
			case "top":
				h = Math.round(pane.getRealH() / 2);
				y = pane._y + Math.min(0, pane.getH() - h);
				break;
			case "bottom":
				h = Math.round(pane.getRealH() / 2);
				y = pane._y + Math.max(0, pane.getH() - h);
				break;
			case "below": // should be default option
				h = Math.round((m_nH - (m_arrPanes.length + 1) * 4) / (m_arrPanes.length + 1));
				if(objPos.paneId == m_arrPanes.length - 1)
					y = m_nH - h - 4;
				else
					y = pane._y + pane.getH() + 4 -
					Math.round(m_arrPanes[objPos.paneId].getRealH() / (m_arrPanes.length + 1));
				break;
		}
		pt = {x:4, y:y};
		localToGlobal(pt);
		return {x:pt.x, y:pt.y, w:m_nW - 8, h:h};
	}

	public function addCurtain(pContent:Function, id:String, text:String, pt:Object):pseudo.Curtain
	{
		var depth:Number = getNextHighestDepth();
		var curtain:pseudo.Curtain = pseudo.Curtain.create(this, "curtain" + depth, depth);
		var pane:pseudo.Pane = pseudo.Pane(curtain.setPane(pseudo.Pane));
		curtain.addListener("close", this, onCloseCurtain, curtain);
		curtain.setAlign("bottom");
		curtain.setName(id);
		curtain._x = 4;
		pane.setContent(pContent).getData().border = 0;
		curtain.addListener("showHide", this, onShowHide, curtain);
		curtain.setResize(classes.PaneTitle);
		var btnResize:pseudo.ToggleButton =
			pseudo.ToggleButton(curtain.getItem("layerResize"));
		var lbl:pseudo.Label = pseudo.Label(btnResize.addItem(pseudo.Label));
		lbl.setData({type:"resizeTitle"});
		lbl.setText(text ? text : "");

		var paneId:Number = m_arrPanes.length;
		if(pt)
		{
			var objPos:Object = getPosFromPt(pt);
			paneId = objPos.paneId;
			if(objPos.align == "bottom" || objPos.align == "below") paneId++;
		}
		m_arrPanes.splice(paneId, 0, curtain);
		m_arrItems.push(curtain);

		if(m_arrPanes.length > 1)
		{ // add resize line
			depth = m_layerResize.getNextHighestDepth();
			var resize:pseudo.ResizeLine = pseudo.ResizeLine.create(m_layerResize, "resize" + depth, depth);
			resize.setAlign("top");
			resize.addListener("startResize", this, onStartResize, m_arrResize.length);
			resize.addListener("finishResize", this, onFinishResize, m_arrResize.length);
			resize.setLook(m_look);
			resize._alpha = 0;
			m_arrResize.push(resize);
			m_arrItems.push(resize);
		}
		m_layerResize.swapDepths(curtain);
		delete m_scale;
		m_scale = new pseudo.ScaleArray(m_arrPanes.length);
		updateScale();
		m_bUpdated = false;
		return curtain;
	}

	public function closeCurtain(curtain:pseudo.Curtain):Void
	{
		if(m_arrPanes.length == 1) fireEvent("close");
		else
		{
			for(var i:Number = 0; i < m_arrPanes.length; i++)
			{
				if(m_arrPanes[i] == curtain)
				{
					removeItem(curtain.getName());
					m_arrPanes.splice(i, 1);
					if(m_arrPanes.length)
					{
						var ind:Number = Math.max(0, i - 1);
						var count:Number = m_arrPanes.length - 1;
						for(var j:Number = count; j < m_arrResize.length; j++)
							removeItem(m_arrResize[j].getName());
						m_arrResize.splice(count);
					}
					m_scale = new pseudo.ScaleArray(m_arrPanes.length);
					updateScale();
					m_bUpdated = false;
					break;
				}
			}
		}
	}

	public function getMinW():Number
	{
		return 100;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var w:Number = m_nW - 8;
			for(var i:Number = 0; i < m_arrPanes.length; i++)
				m_arrPanes[i].setW(w);
			var nH:Number = getScaleH();
			var curY:Number = 4;
			for(var i:Number = 0; i < m_arrResize.length; i++)
			{
				var curtain:pseudo.Curtain = m_arrPanes[i];
				if(!curtain.isHidden()) curtain.setH(Math.round(nH * m_scale.getK(i)));
				curtain._y = curY;
				curY += curtain.getH();
				var resize:pseudo.BaseMovie = m_arrResize[i];
				resize._x = 4;
				resize._y = curY;
				resize.setSize(w, 4);
				curY += 4;
			}
			var curtain:pseudo.Curtain = m_arrPanes[m_arrPanes.length - 1];
			curtain._y = curY;
			if(!curtain.isHidden()) curtain.setH(m_nH - curY - 4);
			m_bDrawn = false;
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//

	private function onCloseCurtain(curtain:pseudo.Curtain):Void
	{
		closeCurtain(curtain);
		update();
		draw();
	}

	private function getScaleH():Number
	{
		var nFixH:Number = 0;
		for(var i:Number = 0; i < m_arrPanes.length; i++)
			if(m_arrPanes[i].isHidden()) nFixH += m_arrPanes[i].getH();
		return m_nH - nFixH - (m_arrPanes.length + 1) * 4;
	}

	private function updateScale():Void
	{
		for(var i:Number = 0; i < m_arrPanes.length; i++)
			m_scale.setVisible(i, !m_arrPanes[i].isHidden());
		for(var i:Number = 0; i < m_arrResize.length; i++)
			m_arrResize[i]._visible = m_scale.canResize(i);
	}

	private function onShowHide(curtain:pseudo.Curtain):Void
	{
		m_bUpdated = false;
		var nId:Number = -1;
		for(var i:Number = 0; i < m_arrPanes.length; i++)
			if(m_arrPanes[i] == curtain)
			{
				m_scale.setVisible(i, !m_arrPanes[i].isHidden());
				break;
			}
		for(var i:Number = 0; i < m_arrResize.length; i++)
			m_arrResize[i]._visible = m_scale.canResize(i);
		update();
		draw();
	}

	private function onStartResize(nId:Number):Void
	{
		onMouseMove = onResize;
		m_nMsPos = _ymouse;
		m_nResizeId = nId;
		m_mouseOff = _ymouse - m_arrPanes[nId]._y - m_arrPanes[nId].getH();
		m_arrResize[m_nResizeId]._alpha = 100;
		onResize();
	}

	private function onFinishResize(nId:Number):Void
	{
		delete onMouseMove;
		m_scale.scale(nId, (_ymouse - m_nMsPos) / getScaleH(), true);
		m_bUpdated = false;
		m_arrResize[m_nResizeId]._alpha = 0;
		update();
		draw();
	}

	private function onResize():Void
	{
		if(m_layerResize)
		{
			var y:Number = 0;
			var h:Number = getScaleH();
			var arr:Array = m_scale.scale(m_nResizeId, (_ymouse - m_nMsPos) / h);
			for(var i:Number = 0; i <= m_nResizeId; i++)
			{
				y += 4 + (m_arrPanes[i].isHidden()
					? m_arrPanes[i].getH()
					: Math.round(h * arr[i].k));
			}
			m_arrResize[m_nResizeId]._y = y;
			// delete block
			for(var i:Number = 0; i < arr.length; i++) delete arr[i];
			delete arr;
		}
	}
}