﻿class classes.RightPane extends pseudo.BaseMovie
{
	private var m_paneLogin:pseudo.Curtain;
	private var m_paneUtilities:pseudo.Curtain;
	private var m_paneInfo:pseudo.Curtain;

	private var m_resize:pseudo.ResizeLine;
	private var m_nMsPos:Number;
	private var m_mouseOff:Number;
	private var m_scale:pseudo.ScaleArray;
	private var m_resizePane:pseudo.BaseMovie;
	private var m_layerResize:MovieClip;
	private var m_nResizeId:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.RightPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.RightPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function RightPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.RightPane;

		// login
		m_paneLogin = pseudo.Curtain.create(pThis, "m_paneLogin", 1);
		var pane:pseudo.Pane = pseudo.Pane(m_paneLogin.setPane(pseudo.Pane));
		m_paneLogin.setAlign("bottom");
		m_paneLogin.setName("paneLogin");
		m_paneLogin._x = 4;
		m_paneLogin._y = 4;
		pane.setContent(classes.LoginPane);
		m_paneLogin.addListener("showHide", pThis, onShowHide);
		m_paneLogin.setResize(classes.ResizeTitle);
		var btnResize:pseudo.ToggleButton =
			pseudo.ToggleButton(m_paneLogin.getItem("layerResize"));
		var lbl:pseudo.Label = pseudo.Label(btnResize.addItem(pseudo.Label));
		lbl.setData({type:"resizeTitle"});
		lbl.setText(_global.lng.getAttr("regUsersLogin"));

		// utilities
		m_paneUtilities = pseudo.Curtain.create(pThis, "m_paneUtilities", 2);
		pane = pseudo.Pane(m_paneUtilities.setPane(pseudo.ScrollPane));
		pseudo.ScrollBar(pane.getItem("scrollVert")).setSmallScroll(20);
		m_paneUtilities.getItem("pane").setData({type:"utilitiesPane"});
		m_paneUtilities.setAlign("bottom");
		m_paneUtilities.setName("paneUtilities");
		m_paneUtilities._x = 4;
		pane.setContent(classes.UtilitiesPane);
		m_paneUtilities.addListener("showHide", pThis, onShowHide, 0, m_paneUtilities);
		m_paneUtilities.setResize(classes.ResizeTitle);
		btnResize = pseudo.ToggleButton(m_paneUtilities.getItem("layerResize"));
		lbl = pseudo.Label(btnResize.addItem(pseudo.Label));
		lbl.setData({type:"resizeTitle"});
		lbl.setText(_global.lng.getAttr("utilities"));

		// info
		m_paneInfo = pseudo.Curtain.create(pThis, "m_paneInfo", 3);
		pane = pseudo.Pane(m_paneInfo.setPane(pseudo.Pane));
		m_paneInfo.getItem("pane").setData({type:"infoPane"});
		m_paneInfo.setAlign("bottom");
		m_paneInfo.setName("paneInfo");
		m_paneInfo._x = 4;
		pane.setContent(classes.InfoPane);
		m_paneInfo.addListener("showHide", pThis, onShowHide, 1, m_paneInfo);
		m_paneInfo.setResize(classes.ResizeTitle);
		btnResize = pseudo.ToggleButton(m_paneInfo.getItem("layerResize"));
		lbl = pseudo.Label(btnResize.addItem(pseudo.Label));
		lbl.setData({type:"resizeTitle"});
		lbl.setText(_global.lng.getAttr("info"));

		m_resize = pseudo.ResizeLine.create(pThis, "resize", 4);
		m_resize.setAlign("top");
		m_resize._alpha = 0;
		m_resize.addListener("startResize", pThis, onStartResize, 0);
		m_resize.addListener("finishResize", pThis, onFinishResize, 0);

		m_scale = new pseudo.ScaleArray(2);
		m_scale.scale();
		m_arrItems.push(m_paneLogin, m_paneUtilities, m_paneInfo, m_resize);
	}

	public function getMinW():Number
	{
		return 100;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_paneLogin.setW(m_nW - 8);
			m_paneLogin.update(); // set new size to m_paneLogin.content before calculating minH of paneLogin
			m_paneLogin.setH(m_paneLogin.getMinH());
			m_paneUtilities.setW(m_nW - 8);
			m_paneInfo.setW(m_nW - 8);
			var nH:Number = getScaleH();
			if(!m_paneUtilities.isHidden()) m_paneUtilities.setH(Math.round(nH * m_scale.getK(0)));
			m_paneUtilities._y = m_paneLogin._y + m_paneLogin.getH() + 4;
			if(!m_paneInfo.isHidden())
				m_paneInfo.setH(m_nH - m_paneUtilities._y - m_paneUtilities.getH() - 8);
			m_paneInfo._y = m_paneUtilities._y + m_paneUtilities.getH() + 4;

			m_resize._x = 4;
			m_resize._y = m_paneInfo._y - 4;
			m_resize.setSize(m_nW - 8, 4);
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function getScaleH():Number
	{
		var nFixH:Number = m_paneLogin.getH();
		if(m_paneUtilities.isHidden()) nFixH += m_paneUtilities.getH();
		if(m_paneInfo.isHidden()) nFixH += m_paneInfo.getH();
		return m_nH - nFixH - 16;
	}

	private function onShowHide(nId:Number, pane:pseudo.Curtain):Void
	{
		m_bUpdated = false;
		m_scale.setVisible(nId, !pane.isHidden());
		m_resize._visible = m_scale.canResize(0);
		update();
		draw();
	}

	private function onStartResize(nId:Number):Void
	{
		if(!m_layerResize) createEmptyMovieClip("m_layerResize", getNextHighestDepth());
		onMouseMove = onResize;
		m_nMsPos = _ymouse;
		m_nResizeId = nId;
		m_resizePane = m_paneUtilities;
		m_mouseOff = _ymouse - m_resizePane._y - m_resizePane.getH();
		onResize();
	}

	private function onFinishResize(nId:Number):Void
	{
		if(m_layerResize) m_layerResize.removeMovieClip();
		delete onMouseMove;
		m_scale.scale(nId, (_ymouse - m_nMsPos) / getScaleH(), true);
		m_bUpdated = false;
		update();
		draw();
	}

	private function onResize():Void
	{
		if(m_layerResize)
		{
			var w:Number = m_resizePane.getW();
			var x:Number = m_resizePane._x;
			var h:Number = getScaleH();
			m_layerResize.clear();
			var arr:Array = m_scale.scale(m_nResizeId, (_ymouse - m_nMsPos) / h);
			m_look.drawResizeLine(m_layerResize, x, Math.round(m_resizePane._y + h * arr[m_nResizeId].k), w, 4);
			// delete block
			for(var i:Number = 0; i < arr.length; i++) delete arr[i];
			delete arr;
		}
	}
}