﻿class classes.SearchPane extends pseudo.BaseMovie implements classes.IContent
{
	private var m_lblKey:pseudo.Label;
	private var m_editKey:pseudo.Edit;
	private var m_lblAuthor:pseudo.Label;
	private var m_editAuthor:pseudo.Edit;
	private var m_lblForum:pseudo.Label;
	private var m_cmbForum:pseudo.ComboBox;
	private var m_lblCategory:pseudo.Label;
	private var m_cmbCategory:pseudo.ComboBox;

	private var m_btnSearch:pseudo.PushButton;
	private var m_btnClose:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.SearchPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.SearchPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function SearchPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.SearchPane;

		m_lblKey = pseudo.Label.create(pThis, "m_lblKey", 1);
		m_lblKey.setText(_global.lng.getAttr("searchForKeywords") + ":");
		m_lblKey.setAlign("right");
		m_lblKey.setName("lblKey");

		m_editKey = pseudo.Edit.create(pThis, "m_editKey", 2);
		m_editKey.setMultiline(false);
		m_editKey.setName("editKey");

		m_lblAuthor = pseudo.Label.create(pThis, "m_lblAuthor", 3);
		m_lblAuthor.setText(_global.lng.getAttr("searchForAuthor") + ":");
		m_lblAuthor.setAlign("right");
		m_lblAuthor.setName("lblKey");

		m_editAuthor = pseudo.Edit.create(pThis, "m_editAuthor", 4);
		m_editAuthor.setMultiline(false);
		m_editAuthor.setName("editAuthor");

		m_lblForum = pseudo.Label.create(pThis, "m_lblForum", 5);
		m_lblForum.setText(_global.lng.getAttr("forum") + ":");
		m_lblForum.setAlign("right");
		m_lblForum.setName("lblForum");

		m_cmbForum = pseudo.ComboBox.create(pThis, "m_cmbForum", 6);
		m_cmbForum.setName("cmbForum");
		m_cmbForum.setEdit(false);

		m_lblCategory = pseudo.Label.create(pThis, "m_lblCategory", 7);
		m_lblCategory.setText(_global.lng.getAttr("category") + ":");
		m_lblCategory.setAlign("right");
		m_lblCategory.setName("lblCategory");

		m_cmbCategory = pseudo.ComboBox.create(pThis, "m_cmbCategory", 8);
		m_cmbCategory.setName("cmbCategory");
		m_cmbCategory.setEdit(false);

		m_btnSearch = pseudo.PushButton.create(pThis, "m_btnSearch", 9);
		m_btnSearch.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnSearch.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("search"));
		m_btnSearch.setName("btnSearch");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 10);
		m_btnClose.setH(20);
		lbl = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setName("btnClose");

		m_arrItems.push(m_lblKey, m_editKey, m_lblAuthor, m_editAuthor,
			m_lblForum, m_cmbForum,  m_lblCategory, m_cmbCategory, m_btnSearch, m_btnClose);
	}

	public function getMinW():Number
	{
		return 200;
	}

	public function getMinH():Number
	{
		return m_cmbCategory._y + m_cmbCategory.getH() + m_btnClose.getH() + 15;
	}

	public function setValue(val:Object):Void
	{
		m_cmbCategory.setListData(val.categories);
		m_cmbCategory.setSelId(0);
		m_cmbForum.setListData(val.forums);
		m_cmbForum.setSelId(0);
	}

	public function getValue(type:String):Object
	{
		return null;
	}

	public function setMode(mode:String):Void
	{
	}

	public function getMode():String
	{
		return "";
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_lblKey._x = m_lblAuthor._x = 5;
			m_lblKey._y = m_editKey._y = 5;
			var nW:Number = pseudo.Global.max(m_lblKey.getMinW(),
				m_lblAuthor.getMinW(), m_lblForum.getMinW(), m_lblCategory.getMinH());
			var nW2:Number = Math.max(20, m_nW - nW - 12);
			m_lblKey.setSize(nW, m_lblKey.getTextH() + 4);
			m_editKey._x = m_editAuthor._x = m_lblKey._x + m_lblKey.getW() + 2;
			m_lblAuthor._y = m_editAuthor._y = m_lblKey._y + m_lblKey.getH() + 5;
			m_lblAuthor.setSize(nW, m_lblAuthor.getTextH() + 4);
			m_editKey.setSize(nW2, m_lblKey.getH());
			m_editAuthor.setSize(nW2, m_editKey.getH());

			m_lblForum.setSize(nW, m_lblForum.getTextH() + 5);
			m_lblForum._x = m_lblCategory._x = 5;
			m_cmbForum._x = m_cmbCategory._x = m_lblForum._x + m_lblForum.getW() + 2;
			m_lblForum._y = m_cmbForum._y = m_lblAuthor._y + m_lblAuthor.getH() + 5;
			m_cmbForum.setSize(nW2, 20);

			m_lblCategory._y = m_cmbCategory._y = m_lblForum._y + m_lblForum.getH() + 5;
			m_lblCategory.setSize(nW, m_lblCategory.getTextH() + 5);
			m_cmbCategory.setSize(nW2, 20);
			m_btnClose.setW(Math.max(70, m_btnClose.getMinW() + 10));
			m_btnSearch.setW(Math.max(70, m_btnSearch.getMinW() + 10));

			var obj:Object = m_look.getParams({type:"resizeBtn"});
			m_btnClose._x = m_nW - m_btnClose.getW() - obj.offX;
			m_btnSearch._x = m_btnClose._x - m_btnSearch.getW() - 5;
			m_btnClose._y = m_btnSearch._y = m_nH - m_btnClose.getH() - obj.offY;
		}
		super.update();
	}
}