﻿class classes.SearchResPane extends classes.BaseContent
{
	private var m_list:pseudo.List;
	private var m_btnClose:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.SearchResPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.SearchResPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function SearchResPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.SearchResPane;

		m_list = pseudo.List.create(pThis, "m_list", 1);

		m_list.setCellClass(classes.CellThread);
		m_list.setData({border:4});
		m_list.setName("list");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 2);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		var lbl:pseudo.Label = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");
		m_arrItems.push(m_list, m_btnClose);
	}

	public function getMinW():Number
	{
		return 157;
	}

	public function getMinH():Number
	{
		return 155;
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		switch(mode)
		{
			case "noData":
				m_list._visible = false;
				break;
			case "hasData":
				if(m_list.getListData().length) m_list._visible = true;
				break;
		}
	}

	public function setValue(val:Object):Void
	{
		m_list.setListData(val.listData);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var nW:Number = Math.max(getMinW(), m_nW);
			var nH:Number = Math.max(getMinH(), m_nH);
			var obj:Object = m_look.getResizeBtnParams();
			m_btnClose._x = nW - m_btnClose.getW() - obj.offX;
			m_btnClose._y = nH - m_btnClose.getH() - obj.offY;
			m_list.setSize(m_nW, m_btnClose._y - 5);
		}
		super.update();
	}
}