﻿class classes.SendPassPane extends pseudo.BaseMovie
{
	private var m_lblName:pseudo.Label;
	private var m_editName:pseudo.Edit;
	private var m_lblMail:pseudo.Label;
	private var m_editMail:pseudo.Edit;
	private var m_btnClose:pseudo.PushButton;
	private var m_btnSubmit:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.SendPassPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.SendPassPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function SendPassPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.SendPassPane;

		m_lblName = pseudo.Label.create(pThis, "m_lblName", 1);
		m_lblName.setText(_global.lng.getAttr("userName") + ":");
		m_lblName.setAlign("right");
		m_lblName.setName("lblName");

		m_editName = pseudo.Edit.create(pThis, "m_editName", 2);
		m_editName.setMultiline(false);
		m_editName.setName("editName");

		m_lblMail = pseudo.Label.create(pThis, "m_lblMail", 3);
		m_lblMail.setText(_global.lng.getAttr("emailAddr") + ":");
		m_lblMail.setAlign("right");
		m_lblMail.setName("lblMail");

		m_editMail = pseudo.Edit.create(pThis, "m_editMail", 4);
		m_editMail.setMultiline(false);
		m_editMail.setName("editMail");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 5);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		var lbl:pseudo.Label = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");

		m_btnSubmit = pseudo.PushButton.create(pThis, "m_btnSubmit", 6);
		m_btnSubmit.setData({sound:"btnRelease"});
		m_btnSubmit.setH(20);
		lbl = pseudo.Label(m_btnSubmit.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("submit"));
		m_btnSubmit.setName("btnSubmit");

		m_arrItems.push(m_lblName, m_editName, m_lblMail, m_editMail, m_btnClose, m_btnSubmit);
	}

	public function getMinW():Number
	{
		return 200;
	}

	public function getMinH():Number
	{
		var obj:Object = m_look.getResizeBtnParams();
		return m_btnClose.getH() + m_lblMail._y + m_lblMail.getH() + obj.offY + 5;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var nW:Number = Math.max(getMinW(), m_nW);
			var nH:Number = Math.max(getMinH(), m_nH);

			m_lblName._x = m_lblMail._x = 5;
			m_lblName._y = m_editName._y = 5;
			var lblW:Number = Math.max(m_lblName.getMinW(), m_lblMail.getMinW());
			var lblW2:Number = nW - lblW - 12;
			m_lblName.setSize(lblW, m_lblName.getTextH() + 4);
			m_lblMail.setSize(lblW, m_lblMail.getTextH() + 4);
			m_editName._x = m_editMail._x = m_lblName._x + m_lblName.getW() + 2;
			m_editName.setSize(lblW2, m_lblName.getH());
			m_editMail.setSize(lblW2, m_lblName.getH());
			m_lblMail._y = m_editMail._y = m_lblName._y + m_lblName.getH() + 5;

			var obj:Object = m_look.getResizeBtnParams();
			m_btnClose._x = nW - m_btnClose.getW() - obj.offX;
			m_btnSubmit.setW(Math.max(70, m_btnSubmit.getMinW() + 10));
			m_btnSubmit._x = m_btnClose._x - m_btnSubmit.getW() - 5;
			m_btnClose._y = m_btnSubmit._y = nH - m_btnClose.getH() - obj.offY;
		}
		super.update();
	}
}