﻿class classes.ThemesPane extends pseudo.BaseMovie
{
	private var m_listLooks:pseudo.List;
	private var m_paneTheme:pseudo.Pane;
	private var m_btnSave:pseudo.PushButton;
	private var m_btnOK:pseudo.PushButton;
	private var m_btnCancel:pseudo.PushButton;
	private var m_oldLook:Object;
	private var m_xmlTheme:XML;
	private var m_bOK:Boolean;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.ThemesPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.ThemesPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function ThemesPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.ThemesPane;

		m_listLooks = pseudo.List.create(pThis, "m_listLooks", 1);
		m_listLooks.setData({border:12});
		m_listLooks.setName("listLooks");
		m_listLooks.setCellClass(classes.CellText);
		var strId:String = _global.look.getId();
		var arrXMLLooks:Array = _global.themesManager.getLooks();
		var arrLooks:Array = new Array();
		var nId:Number = -1;
		for(var i:Number = 0; i < arrXMLLooks.length; i++)
		{
			var strCurId:String = arrXMLLooks[i].getAttr("id");
			arrLooks.push({text:arrXMLLooks[i].getAttr("name"), id:strCurId});
			if(strCurId == strId) nId = i;
		}
		m_listLooks.setListData(arrLooks);
		m_listLooks.setSelCell(nId);
		m_listLooks.addListener("changed", pThis, onChangeLook);

		m_paneTheme = pseudo.Pane.create(pThis, "m_paneTheme", 2);
		m_paneTheme.setData({border:0});
		_global.look.fillContent(
			m_paneTheme.setContent(pseudo.BaseMovie),
			{List:pseudo.List, CellRenderer:classes.CellText}
		);
		m_paneTheme.setName("paneTheme");

		m_btnCancel = pseudo.PushButton.create(pThis, "m_btnCancel", 3);
		m_btnCancel.setData({type:"btnClose", sound:"btnRelease"});
		m_btnCancel.setSize(70, 20);
		var lbl:pseudo.Label = pseudo.Label(m_btnCancel.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("cancel"));
		m_btnCancel.addListener("mouseRelease", pThis, function(){this.m_bOK = false; this.fireBroadEvent("close");});
		m_btnCancel.setName("btnCancel");

		m_btnOK = pseudo.PushButton.create(pThis, "m_btnOK", 4);
		m_btnOK.setSize(70, 20);
		lbl = pseudo.Label(m_btnOK.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("OK"));
		m_btnOK.addListener("mouseRelease", pThis, function(){this.m_bOK = true; this.fireBroadEvent("close");});
		m_btnOK.setName("btnOK");

		m_btnSave = pseudo.PushButton.create(pThis, "m_btnSave", 5);
		m_btnSave.setH(20);
		lbl = pseudo.Label(m_btnSave.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("save"));
		m_btnSave.setName("btnSave");

		m_oldLook = _global.look;
		m_xmlTheme = m_oldLook.toXML();
		m_bOK = false;

		_global.themesManager.addListener("onLoad", pThis, onLoadLook);
		m_arrItems.push(m_btnCancel, m_btnOK, m_btnSave, m_listLooks, m_paneTheme);
	}

	public function getMinW():Number
	{
		return m_btnCancel.getW() + m_btnOK.getW() + m_btnSave.getW() + 20 +
			m_look.getMargin("left", m_data) + m_look.getMargin("right", m_data);
	}

	public function getMinH():Number
	{
		return 100;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var obj:Object = m_look.getResizeBtnParams();
			m_btnSave.setW(Math.max(70, m_btnSave.getMinW() + 10));
			m_btnCancel._x = m_nW - m_btnCancel.getW() - obj.offX;
			m_btnOK._x = m_btnCancel._x - m_btnOK.getW() - 5;
			m_btnSave._x = m_btnOK._x - m_btnSave.getW() - 5;
			m_btnCancel._y = m_btnOK._y = m_btnSave._y = m_nH - m_btnCancel.getH() - obj.offY;
			m_listLooks.setSize(Math.min(180, Math.max(80, Math.round(m_nW / 3))), m_btnCancel._y - 5);
			m_paneTheme._x = m_listLooks._x + m_listLooks.getW();
			m_paneTheme.setSize(m_nW - m_paneTheme._x, m_btnCancel._y - 5);
		}
		super.update();
	}

	public function onClose():Void
	{
		if(!m_bOK)
		{
			var xmlDoc:pseudo.XMLDocument = new pseudo.XMLDocument(m_xmlTheme);
			if(m_look != m_oldLook || !m_look.isSameTheme(m_xmlTheme))
			{
				m_oldLook.fromXML(xmlDoc);
				_global.themesManager.setLook(m_oldLook);
				_global.main.update();
				_global.main.draw();
			}
			delete m_xmlTheme;
			delete xmlDoc;
		}
	}

	public function remove():Void
	{
		_global.themesManager.removeListener("onLoad", this);
		super.remove();
	}

	//
	// PRIVATE METHODS
	//
	private function onChangeLook():Void
	{
		_global.themesManager.loadLook(m_listLooks.getSelData().id);
	}

	private function onLoadLook(look:Object):Void
	{
		look.fillContent(
			m_paneTheme.setContent(pseudo.BaseMovie),
			{List:pseudo.List, CellRenderer:classes.CellText}
		);
		_global.themesManager.setLook(look);
		_global.main.update();
		_global.main.draw();
	}
}