﻿class classes.TopPane extends pseudo.BaseMovie
{
	private var m_lblTime:pseudo.Label;
	private var m_lblUser:pseudo.Label;
	private var m_nTimer:Number;
	private var m_nOldTime:Number;
	private var m_btnLogout:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.TopPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.TopPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function TopPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.TopPane;

		m_lblTime = pseudo.Label.create(pThis, "m_lblTime", 1);
		m_lblTime.setAlign("right");
		m_lblTime.setAutoSize(true);
		m_lblTime.setName("lblTime");
		m_lblTime.setData({type:"topTime"});
		m_lblUser = pseudo.Label.create(pThis, "m_lblUser", 2);
		m_lblUser.setName("lblUser");
		m_lblUser.setData({type:"topUser"});
		m_btnLogout = pseudo.PushButton.create(pThis, "m_btnLogout", 3);
		m_btnLogout.setName("btnLogout");
		m_btnLogout.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnLogout.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("logout"));

		m_nTimer = setInterval(pThis, "onSetTime", 1000);
		m_nOldTime = 0;
		m_arrItems.push(m_lblTime, m_lblUser, m_btnLogout);
	}

	public function getMinH():Number
	{
		return m_lblTime.getMinH();
	}

	public function setSize(w:Number, h:Number):Void
	{
		super.setSize(w, h);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			onSetTime(true);
			m_btnLogout.setW(Math.max(40, m_btnLogout.getMinW() + 10));
			m_lblTime._x = Math.max(m_btnLogout.getW() + 5, m_nW - m_lblTime.getW() - 5);
			m_lblTime._y = Math.round((m_nH - m_lblTime.getH()) / 2);
			m_lblUser._x = 3;
			m_lblUser.setSize(
				Math.max(
					0,
					Math.min(m_lblTime._x - (m_btnLogout._visible ? m_btnLogout.getW() : 0) - m_lblUser._x - 4, m_lblUser.getMinW())
				),
				m_lblUser.getMinH()
			);
			m_btnLogout._x = Math.min(m_lblUser._x + m_lblUser.getW() + 2, m_lblTime._x - m_btnLogout.getW() - 2);
			m_lblUser._y = Math.round((m_nH - m_lblUser.getH()) / 2);
			m_btnLogout._y = Math.round((m_nH - m_btnLogout.getH()) / 2);
		}
		super.update();
	}

	//
	// PUBLIC METHODS
	//
	private function onSetTime(bAnyway:Boolean):Void
	{
		var date:Date = new Date();
		var nNewTime:Number = date.getSeconds();
		if(m_nOldTime != nNewTime || bAnyway)
		{
			m_nOldTime = nNewTime;
			var nHours:Number = date.getHours();
			var nMinutes:Number = date.getMinutes();
			var nSeconds:Number = date.getSeconds();
			var strHours:String = nHours == 12 ? String(nHours) : ((nHours % 12) < 10 ? "0" : "") + (nHours % 12);
			var strMinutes:String = (nMinutes < 10 ? "0" : "") + nMinutes;
			var strSeconds:String = (nSeconds < 10 ? "0" : "") + nSeconds;
			var strAMPM:String = nHours >= 12 ? "pm" : "am";
			m_lblTime.setText(
				strHours + ":" +
				strMinutes + ":" +
				strSeconds + " " +
				strAMPM);
			m_lblTime.update();
		}
	}
}