﻿class classes.TopicPane extends classes.BaseContent
{
	private var m_btnEdit:pseudo.PushButton;
	private var m_btnQuote:pseudo.PushButton;
	private var m_btnReply:pseudo.PushButton;
	private var m_list:pseudo.List;
	private var m_btnClose:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.TopicPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.TopicPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function TopicPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.TopicPane;

		m_btnEdit = pseudo.PushButton.create(pThis, "m_btnEdit", 1);
		m_btnEdit.setH(20);
		var lbl:pseudo.Label = pseudo.Label(m_btnEdit.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("edit"));
		m_btnEdit.setName("btnEdit");

		m_btnQuote = pseudo.PushButton.create(pThis, "m_btnQuote", 2);
		m_btnQuote.setH(20);
		lbl = pseudo.Label(m_btnQuote.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("quote"));
		m_btnQuote.setName("btnQuote");

		m_btnReply = pseudo.PushButton.create(pThis, "m_btnReply", 3);
		m_btnReply.setH(20);
		lbl = pseudo.Label(m_btnReply.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("reply"));
		m_btnReply.setName("btnReply");

		m_list = pseudo.List.create(pThis, "m_list", 4);
		m_list.setCellClass(classes.CellThread);
		m_list.setData({border:5});
		m_list._y = 5;
		m_list.setName("list");

		m_btnClose = pseudo.PushButton.create(pThis, "m_btnClose", 5);
		m_btnClose.setData({type:"btnClose", sound:"btnRelease"});
		m_btnClose.setSize(70, 20);
		lbl = pseudo.Label(m_btnClose.addItem(pseudo.Label));
		lbl.setAlign("center");
		lbl.setText(_global.lng.getAttr("close"));
		m_btnClose.addListener("mouseRelease", pThis, fireBroadEvent, "close");
		m_btnClose.setName("btnClose");

		m_arrItems.push(m_btnEdit, m_btnReply, m_btnQuote, m_list, m_btnClose);
	}

	public function showEditBtn(bVisible:Boolean):Void
	{
		m_btnEdit._visible = bVisible;
		m_bUpdated = false;
		update();
	}

	public function getMinW():Number
	{
		return 157;
	}

	public function getMinH():Number
	{
		return 155;
	}

	public function setValue(val:Object):Void
	{
		m_list.setListData(val.listData);
	}

	public function setMode(mode:String):Void
	{
		super.setMode(mode);
		var bVis:Boolean = false;
		switch(mode)
		{
			case "noData":
				m_btnEdit._visible = false;
				break;
			case "hasData":
				bVis = true;
				break;
		}
		m_btnQuote._visible = m_btnReply._visible = m_list._visible = bVis;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_btnEdit.setW(Math.max(70, m_btnEdit.getMinW() + 10));
			m_btnQuote.setW(Math.max(70, m_btnQuote.getMinW() + 10));
			m_btnReply.setW(Math.max(70, m_btnReply.getMinW() + 10));
			m_btnEdit._x = m_nW - m_btnEdit.getW() - 5;
			m_btnQuote._x = (m_btnEdit._visible ? m_btnEdit._x : m_nW) - m_btnQuote.getW() - 5;
			m_btnReply._x = m_btnQuote._x - m_btnReply.getW() - 5;
			m_btnEdit._y = m_btnQuote._y = m_btnReply._y = 5;
			var nW:Number = Math.max(getMinW(), m_nW);
			var nH:Number = Math.max(getMinH(), m_nH);
			var obj:Object = m_look.getResizeBtnParams();
			m_btnClose._x = nW - m_btnClose.getW() - obj.offX;
			m_btnClose._y = nH - m_btnClose.getH() - obj.offY;
			m_list._y = m_btnEdit._y + m_btnEdit.getH() + 5;
			m_list.setSize(m_nW, m_btnClose._y - m_btnEdit._y - m_btnEdit.getH() - 10);
		}
		super.update();
	}
}