﻿class classes.UtilitiesPane extends pseudo.BaseMovie
{
	private var m_gallery:pseudo.Gallery;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):classes.UtilitiesPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new classes.UtilitiesPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function UtilitiesPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = classes.UtilitiesPane;

		m_gallery = pseudo.Gallery.create(pThis, "m_gallery", 1);
		m_gallery.setName("gallery");

		var arrItems:Array = _global.xmlConfig.getAttr("utilities").split(",");
		var bAbout:Boolean = false;
		var btn:pseudo.PushButton = null;
		for(var i:Number = 0; i < arrItems.length; i++)
		{
			switch(arrItems[i])
			{
				case "search":
					btn = addGalleryItem("search", "<p align='center'>" + _global.lng.getAttr("btnSearch") + "</p>");
					break;
				case "members":
					btn = addGalleryItem("members", "<p align='center'>" + _global.lng.getAttr("btnMembers") + "</p>");
					break;
				case "groups":
					btn = addGalleryItem("groups", "<p align='center'>" + _global.lng.getAttr("btnGroups") + "</p>");
					break;
				case "profile":
					btn = addGalleryItem("profile", "<p align='center'>" + _global.lng.getAttr("btnProfile") + "</p>");
					btn._visible = false;
					break;
				//case "pm":
				//	addGalleryItem("private_messages", "<p align='center'>private<br>messages</p>");
				//	break;
				case "themes":
					btn = addGalleryItem("themes", "<p align='center'>" + _global.lng.getAttr("btnTManager") + "</p>");
					break;
				case "chat":
					btn = addGalleryItem("chat", "<p align='center'>" + _global.lng.getAttr("btnChat") + "</p>");
					btn.addListener("mouseRelease", pThis, onChat);
					break;
				case "faq":
					btn = addGalleryItem("faq", "<p align='center'>" + _global.lng.getAttr("btnFAQ") + "</p>");
					btn.addListener("mouseRelease", pThis, onFAQ);
					break;
				case "about":
					bAbout = true;
					btn = addGalleryItem("about", "<p align='center'>" + _global.lng.getAttr("btnAbout") + "</p>");
					btn.addListener("mouseRelease", pThis, onAbout);
					break;
				//case "stats":
				//	addGalleryItem("stats", "<p align='center'>stats</p>");
				//	break;
			}
		}
		if(!bAbout)
		{
			btn = addGalleryItem("about", "<p align='center'>" + _global.lng.getAttr("btnAbout") + "</p>");
			btn.addListener("mouseRelease", pThis, onAbout);
		}

		m_arrItems.push(m_gallery);
	}

	public function update():Void
	{
		if(!m_bUpdated)
			m_gallery.setSize(m_nW, m_nH);
		super.update();
		m_nW = m_gallery.getW();
		m_nH = m_gallery.getH();
	}

	public function onAbout():Void
	{
		var windowManager:classes.BBWindowManager = classes.BBWindowManager(_global.main.getItem("windowManager"));
		var wnd:pseudo.BaseWindow = windowManager.getWindow("about");
		if(wnd)
			windowManager.sendToTop(wnd);
		else
		{
			var strAbout:String = _global.lng.getAttr("about");
			wnd = windowManager.addWindow(strAbout, null, "about", true);
			var title:classes.WindowTitle = classes.WindowTitle(wnd.setTitleBar(classes.WindowTitle));
			title.setText(strAbout);
			wnd.setPane(pseudo.Pane).setContent(classes.AboutPane);
			wnd.setSize(wnd.getMinW(), wnd.getMinH());
			wnd._x = windowManager.getMaskX() + Math.round((windowManager.getMaskW() - wnd.getW()) / 2);
			wnd._y = windowManager.getMaskY() + Math.round((windowManager.getMaskH() - wnd.getH()) / 2);
			if(_global.xmlConfig.getAttr("createMaximized") == "on") wnd.invokeEvent("maximizeWindow");
		}
		windowManager.update();
		windowManager.draw();
	}

	public function addGalleryItem(strIcon:String, strText:String):pseudo.PushButton
	{
		var btn:pseudo.PushButton = pseudo.PushButton(m_gallery.addItem(pseudo.PushButton));
		btn.setData({type:"titledIconButton", sound:"btnRelease"});
		btn.setName(strIcon);
		btn.setLook(m_look);
		var titledIcon:classes.TitledIcon = classes.TitledIcon(btn.addItem(classes.TitledIcon));
		titledIcon.setData({icon:strIcon});
		titledIcon.setText(strText);
		return btn;
	}

	//
	// PRIVATE METHODS
	//
	private function onChat():Void
	{
		getURL(_global.xmlConfig.getAttr("urlChat"), "_blank");
		//classes.Global.alert("warning", "The chat is not available yet.", "iconWarning");
	}

	private function onFAQ():Void
	{
		getURL(_global.xmlConfig.getAttr("urlFAQ"), "_blank");
		//classes.Global.alert("warning", "FAQ is not available yet.", "iconWarning");
	}
}