/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.AlertContent extends pseudo.BaseMovie
{
	private var m_icon:MovieClip;
	private var m_text:TextField;
	private var m_mcContent:MovieClip;
	private var m_arrButtons:Array;
	private var m_nMinW:Number;
	private var m_nMinH:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.AlertContent
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.AlertContent(pOwner[strName]);
		return pOwner[strName];
	}

	public function AlertContent(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.AlertContent;

		m_arrButtons = new Array();
		m_text = pseudo.Global.createLabel(pThis, "m_text", 1);
		m_nMinW = m_nMinH = 0;
	}

	public function getMinW():Number
	{
		return m_nMinW;
	}

	public function getMinH():Number
	{
		return m_nMinH;
	}

	public function setText(strText:String):Void
	{
		var strBeg:String = m_look.getTextDecoration("open", {type:"label"});
		var strEnd:String = m_look.getTextDecoration("close", {type:"label"});
		m_text.htmlText = strBeg + strText + strEnd;
	}

	public function setIcon(strIcon:String):Void
	{
		var strPath:String = m_look.getIconPath(strIcon);
		if(!strPath) return;
		createEmptyMovieClip("m_icon", 2);
		var loader:MovieClipLoader = new MovieClipLoader();
		var listener:Object = new Object();
		listener.loader = loader;
		listener.owner = this;
		listener.update = function():Void
		{
			delete this.loader;
			this.owner.setUpdated(false);
			this.owner.update();
			this.owner.fireEvent("onLoadIcon");
			delete this;
		}
		listener.onLoadInit = function(target:MovieClip):Void
		{
			this.update();
		}
		listener.onLoadError = function(target:MovieClip):Void
		{
			this.update();
		}
		loader.addListener(listener);
		loader.loadClip(strPath, m_icon);
	}

	public function setButtons(strBtns:String):Void
	{
		if(!strBtns) strBtns = "ok,OK";
		for(var i = 0; i < m_arrButtons.length; i++)
			m_arrButtons[i].btn.remove();
		m_arrButtons.splice(0);
		var arrBtnsInfo:Array = strBtns.split(",");
		var nDepth:Number = 3;
		var nMaxW:Number = 50;
		for(var i = 0; i < arrBtnsInfo.length; i += 2)
		{
			var obj:Object = new Object();
			obj.type = arrBtnsInfo[i];
			var strBtnName:String = "btn" + nDepth;
			obj.btn = pseudo.PushButton.create(this, "btn" + nDepth, nDepth++);
			obj.btn.setLook(m_look);
			var lbl:pseudo.Label = pseudo.Label(obj.btn.addItem(pseudo.Label));
			lbl.setAlign("center");
			lbl.setText(arrBtnsInfo[i + 1]);
			obj.btn.setH(20);
			obj.btn.addListener("mouseRelease", this, onBtnClick, obj.type);
			m_arrButtons.push(obj);
			nMaxW = Math.max(obj.btn.getMinW(), nMaxW);
			m_arrItems.push(obj.btn);
		}
		nMaxW += 20;
		for(var i = 0; i < m_arrButtons.length; i++)
			m_arrButtons[i].btn.setW(nMaxW);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_text.wordWrap = false;
			m_text.autoSize = "left";
			var nBtnsW:Number = 0;
			var nBtnsH:Number = 0;
			for(var i = 0; i < m_arrButtons.length; i++)
			{
				var btn:pseudo.PushButton = m_arrButtons[i].btn;
				nBtnsW += btn.getW() + 3;
				nBtnsH = Math.max(nBtnsH, btn.getH());
			}
			nBtnsW += 16 - 3;
			m_icon._x = 10;
			var nIconW:Number = m_icon ? 10 + m_icon._width : 0;
			var nIconH:Number = m_icon ? m_icon._height : 0;
			var nMaxW:Number = Math.max(nBtnsW, 400 - 10 * 2 - nIconW);
			var nW:Number = m_text.textWidth + 4;
			if(m_text.textWidth + 4 > nMaxW)
				nW = Math.min(nMaxW, m_text.textWidth + 4);
			m_text._x = m_icon ? m_icon._x + nIconW : 10;
			m_nMinW = pseudo.Global.max(nBtnsW, 218, 10 * 2 + nW + nIconW);
	
			m_text.wordWrap = true;
			m_text.autoSize = "none";
			m_text._width = m_nMinW - 10 * 2 - nIconW;
			m_text._height = m_text.textHeight + 4;
	
			m_nMinH = Math.max(80, nBtnsH + 10 * 3 + Math.max(m_text._height, nIconH));
			m_text._y = 10;
			m_icon._y = 13;
			//m_icon._y = Math.round((Math.min(150, m_nMinH) - nIconH - nBtnsH - 10) / 2);
			var nCurX:Number = m_nMinW - nBtnsW + 8;//Math.round((m_nMinW - nBtnsW) / 2) + 6;
			for(var i = 0; i < m_arrButtons.length; i++)
			{
				var btn:MovieClip = m_arrButtons[i].btn;
				btn.update();
				btn._x = nCurX;
				nCurX += btn.getW() + 3;
				btn._y = m_nMinH - btn.getH() - 8;
			}
			m_nW = m_nMinW;
			m_nH = m_nMinH;
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function onBtnClick(strType:Number):Void
	{
		fireEvent("onSelect", strType);
		fireBroadEvent("close");
	}
}
