﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.ComboBox extends pseudo.PushButton
{
	private var m_edit:pseudo.Edit;
	private var m_btnDrop:pseudo.Button;
	private var m_list:pseudo.List;
	private var m_nSelId:Number;
	private var m_nListH:Number;
	private var m_arrData:Array;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.ComboBox
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.ComboBox(pOwner[strName]);
		return pOwner[strName];
	}

	public function ComboBox(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.ComboBox;

		m_edit = pseudo.Edit.create(pThis, "m_edit", 1);
		m_edit.setName("edit");
		m_edit.setData({type:"comboBoxTitle"});
		m_btnDrop = pseudo.Button.create(pThis, "m_btnDrop", 2);
		m_btnDrop.setName("btnDrop");
		m_btnDrop.setData({type:"comboBoxBtn"});
		m_btnDrop.addListener("dragOver", this, dropDragOver);

		m_data.className = "ComboBox";
		m_data.type = "comboBox";
		m_nSelId = -1;
		m_nListH = 7;

		m_arrItems.push(m_edit, m_btnDrop);
	}

	public function setListData(arrData:Array):Void
	{
		m_arrData = arrData;
		if(m_list) m_list.setListData(m_arrData);
	}

	public function getListData():Array
	{
		return m_arrData;
	}

	public function setSelId(nId:Number):Void
	{
		m_edit.setText(m_arrData[nId].text);
		if(m_list._visible) m_list.setSelCell(nId, "over");
		m_edit.update();
		m_edit.draw();
		m_nSelId = nId;
	}

	public function getSelId():Number
	{
		return m_nSelId;
	}

	public function getSelData():Object
	{
		return m_arrData[m_nSelId];
	}

	public function setEdit(bEdit:Boolean):Void
	{
		m_edit.setEdit(bEdit);
		m_edit.setSelectable(bEdit);
		m_edit.setHtml(!bEdit);
		if(bEdit) m_btnDrop.addListener("dragOver", this, dropDragOver);
		else m_btnDrop.removeListener("dragOver", this);
	}

	public function setListH(nH:Number):Void
	{
		m_nListH = nH;
	}

	public function showLayer(strLayer:String):Void
	{
		super.showLayer(strLayer);
		if(strLayer != "press" || !m_edit.isEditable() || m_btnDrop.isMouseOver())
			m_btnDrop.showLayer(strLayer);
	}

	public function getUserW():Number
	{
		return super.getUserW() - m_btnDrop.getW();
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_btnDrop.setSize(Math.min(15, m_nH), m_nH);
			m_btnDrop._x = m_nW - m_btnDrop.getW();
			m_edit._x = m_look.getMargin("left", m_data);
			m_edit._y = m_look.getMargin("right", m_data);
			m_edit.setSize(getUserW(), getUserH());
		}
		if(m_list) m_list.setSize(m_nW, calcListH());
		super.update();
	}

	//
	// PRIVATE METHODS
	//

	private function setListVisibility(bShow:Boolean):Void
	{
		m_list._visible = bShow;
		if(bShow)
		{
			var pt:Object = new Object({x:0, y:0});
			localToGlobal(pt);
			_global.popup.globalToLocal(pt);
			m_list._x = pt.x;
			if(pt.y + m_list.getH() > Stage.height)
				m_list._y = pt.y - m_list.getH();
			else
				m_list._y = pt.y + m_nH;
			m_list.setSelCell(-1, "press");
			m_list.setSelCell(-1, "over");
			m_list.setSelCell(m_nSelId, "over");
			m_list.setSize(m_nW, calcListH());
			m_list.update();
			m_list.draw();
		}
	}

	private function movieMouseRelease(bSkipParent:Boolean, bSkip:Boolean):Void
	{
		if(!bSkip && isMouseOver())
		{
			if(!m_edit.isEditable() || m_btnDrop.isMouseOver())
			{
				if(!m_list)
				{
					var nDepth:Number = _global.popup.getNextHighestDepth();
					m_list = pseudo.List.create(_global.popup, "m_list" + nDepth, nDepth);
					m_list.setData({type:"comboBoxPane"});
					m_list.setName("list");
					m_list.setType("scroll");
					m_list.setCellClass(classes.CellText);
					m_list.setCellsDrawData({type:"comboBoxCell"});
					m_list.addListener("changed", this, onChangeVal);
					m_list.setLook(m_look);
					m_list.setListData(m_arrData);
					// this 2 lines are needed to draw selected item when the list is shown at the first time
					m_list.setSize(m_nW, calcListH());
					m_list.update();
					m_list._visible = false;
					m_arrItems.push(m_list);
				}
				setListVisibility(!m_list._visible);
			}
		}
		super.movieMouseRelease(false, true);
	}

	private function onChangeVal():Void
	{
		setSelId(m_list.getSelId());
		setListVisibility(false);
		fireEvent("changed");
	}

	private function movieRollOver(bSkipParent:Boolean, bSkip:Boolean):Void
	{
		if(!bSkip) Mouse.removeListener(this);
		super.movieRollOver(false, true);
	}

	private function movieRollOut(bSkipParent:Boolean, bSkip:Boolean):Void
	{
		if(!bSkip && m_list._visible) Mouse.addListener(this);
		super.movieRollOut(false, true);
	}

	private function onMouseDown():Void
	{
		if(onRollOver && !m_list.isMouseOver())
		{
			setListVisibility(false);
			Mouse.removeListener(this);
		}
	}

	private function dropDragOver():Void
	{
		m_btnDrop.showLayer(m_data.mode);
	}

	private function calcListH():Number
	{
		return Math.min(m_list.getMaxH(), m_look.getMargin("top", m_list.getData()) +
			m_list.getCellsH(m_nListH) + m_look.getMargin("bottom", m_list.getData()));
	}
}