﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.Curtain extends pseudo.BaseComponent
{
	private var m_pane:pseudo.BaseMovie;
	private var m_layerResize:pseudo.BaseMovie;
	private var m_strAlign:String;
	private var m_bAutoSize:Boolean;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.Curtain
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.Curtain(pOwner[strName]);
		return pOwner[strName];
	}

	public function Curtain(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.Curtain;

		setAlign("left");
		m_bAutoSize = false;
	}

	public function getMinW():Number
	{
		var minW:Number = m_pane.getMinW();
		return (minW ? minW : 0) +
			((m_layerResize && m_strAlign == "left" || m_strAlign == "right") ? m_layerResize.getW() : 0);
	}

	public function getMinH():Number
	{
		var minH:Number = m_pane.getMinH();
		return (minH ? minH : 0) +
			((m_layerResize && m_strAlign == "top" || m_strAlign == "bottom") ? m_layerResize.getH() : 0);
	}

	public function getMaxW():Number
	{
		var maxW:Number = m_pane.getMaxW();
		return (maxW ? maxW : 0) +
			((m_layerResize && m_strAlign == "left" || m_strAlign == "right") ? m_layerResize.getW() : 0);
	}

	public function getMaxH():Number
	{
		var maxH:Number = m_pane.getMaxH();
		return (maxH ? maxH : 0) +
			((m_layerResize && m_strAlign == "top" || m_strAlign == "bottom") ? m_layerResize.getH() : 0);
	}

	public function getPrefW():Number
	{
		var prefW:Number = m_pane.getPrefW();
		return (prefW ? prefW : 0) +
			((m_layerResize && m_strAlign == "left" || m_strAlign == "right") ? m_layerResize.getW() : 0);
	}

	public function getPrefH():Number
	{
		var prefH:Number = m_pane.getPrefH();
		return (prefH ? prefH : 0) +
			((m_layerResize && m_strAlign == "top" || m_strAlign == "bottom") ? m_layerResize.getH() : 0);
	}

	public function setAutoSize(bAutoSize:Boolean):Void
	{
		m_bAutoSize = bAutoSize;
	}

	public function setResize(pClass:Function):pseudo.BaseMovie
	{
		m_layerResize = addItem(pClass, "layerResize", 4);
		m_layerResize.addListener("showHide", this, onShowHide);
		m_layerResize.addListener("startMovePane", this, fireEvent, "startMovePane");
		m_layerResize.addListener("finishMovePane", this, fireEvent, "finishMovePane");
		m_layerResize.addListener("movePane", this, fireEvent, "movePane");
		m_layerResize.setLook(m_look);
		m_bUpdated = false;
		return pseudo.BaseMovie(m_layerResize);
	}

	public function setPane(pClass:Function):pseudo.BaseMovie
	{
		m_pane = addItem(pClass, "pane", 2);
		m_pane.setLook(m_look);
		setAlign(m_strAlign);
		return m_pane;
	}

	public function getW():Number
	{
		return m_pane._visible ? super.getW() : m_layerResize.getW();
	}

	public function getH():Number
	{
		return m_pane._visible ? super.getH() : m_layerResize.getH();
	}

	public function getRealW():Number
	{
		return super.getW();
	}

	public function getRealH():Number
	{
		return super.getH();
	}

	public function isHidden():Boolean
	{
		return !m_pane._visible;
	}

	public function setAlign(strAlign:String):Void
	{
		m_strAlign = strAlign;
		pseudo.IAlignable(m_layerResize).setAlign(m_strAlign);
		var fullBorder:Number = 15; // all border lines
		var border:Number = m_data.border;
		if(isNaN(border)) border = fullBorder;
		switch(m_strAlign)
		{
			case "bottom": border &= fullBorder - 1; break;
			case "right": border &= fullBorder - 2; break;
			case "top": border &= fullBorder - 4; break;
			case "left": border &= fullBorder - 8; break;
		}
		m_pane.setData({border:border});
		m_bUpdated = false;
	}

	public function getAlign():String
	{
		return m_strAlign;
	}

	public function isMouseOver(x:Number, y:Number):Boolean
	{
		return m_pane._visible ?
			super.isMouseOver(x, y) : m_layerResize.isMouseOver(x, y);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			//0 1 2 4 8(CCW, 1 - top, 2 - left, 4 - bottom, 8 - right)
			switch(m_strAlign)
			{
				case "right":
					m_layerResize.setH(m_nH);
					m_layerResize._x = 0;
					m_layerResize._y = 0;
					m_pane._x = m_layerResize.getW();
					m_pane._y = 0;
					m_pane.setSize(m_nW - m_layerResize.getW(), m_nH);
					break;
				case "bottom":
					m_layerResize.setW(m_nW);
					m_layerResize._x = 0;
					m_layerResize._y = 0;
					m_pane._y = m_layerResize.getH();
					m_pane._x = 0;
					m_pane.setSize(m_nW, m_nH - m_layerResize.getH());
					break;
				case "top":
					m_layerResize.setW(m_nW);
					m_layerResize._x = 0;
					m_layerResize._y = m_pane._visible ? m_nH - m_layerResize.getH() : 0;
					m_pane._y = 0;
					m_pane._x = 0;
					m_pane.setSize(m_nW, m_nH - m_layerResize.getH());
					break;
				default: // left
					m_layerResize.setH(m_nH);
					m_layerResize._x = m_pane._visible ? m_nW - m_layerResize.getW() : 0;
					m_layerResize._y = 0;
					m_pane._y = 0;
					m_pane._x = 0;
					m_pane.setSize(m_nW - m_layerResize.getW(), m_nH);
					break;
			}
		}
		if(m_bAutoSize)
		{
			m_nW = m_pane._x + m_pane.getW();
			m_nH = m_pane._y + m_pane.getH();
		}
		super.update();
	}

	public function showHide():Void
	{
		m_pane._visible
			? pseudo.IHideable(m_layerResize).hide()
			: pseudo.IHideable(m_layerResize).show();
		showHideHelper();
	}

	public function show():Void
	{
		if(!m_pane._visible)
		{
			m_pane._visible = true;
			m_bUpdated = false;
			pseudo.IHideable(m_layerResize).show();
		}
	}

	public function hide():Void
	{
		if(m_pane._visible)
		{
			m_pane._visible = false;
			m_bUpdated = false;
			pseudo.IHideable(m_layerResize).hide();
		}
	}

	//
	// PRIVATE METHODS
	//

	private function showHideHelper():Void
	{
		m_pane._visible = !m_pane._visible;
		m_bUpdated = false;
		pseudo.SoundManager.getInstance().playSound(m_pane._visible ? "curtainShow" : "curtainHide");
	}

	public function onShowHide():Void
	{
		showHideHelper();
		fireEvent("showHide");
	}
}