﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.Gallery extends pseudo.BaseComponent
{
	private var m_nItemW:Number;
	private var m_nItemH:Number;
	private var m_nOffW:Number;
	private var m_nOffH:Number;
	private var m_strFillType:String;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.Gallery
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.Gallery(pOwner[strName]);
		return pOwner[strName];
	}

	public function Gallery(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.Gallery;

		m_nItemW = 55;
		m_nItemH = 66;
		m_nOffW = m_nOffH = 5;
		m_data.className = "Gallery";
		m_data.type = "gallery";
		m_strFillType = "vert";
	}

	public function setFillType(strFillType:String):Void
	{
		if(m_strFillType != strFillType) m_bUpdated = false;
		m_strFillType = strFillType;
	}

	public function addItem(pClass:Function):pseudo.BaseMovie
	{
		var nDepth:Number = getNextHighestDepth();
		var item:pseudo.BaseMovie = pClass.create(this, "item_" + nDepth, nDepth);
		item.setSize(m_nItemW, m_nItemH);
		item.setLook(m_look);
		m_arrItems.push(item);
		m_bUpdated = false;
		return item;
	}

	public function getItemFromId(nId:Number):pseudo.BaseMovie
	{
		return (nId > -1 && nId < m_arrItems.length) ? m_arrItems[nId] : null;
	}

	public function setOffX(nOffX:Number):Void
	{
		m_nOffW = nOffX;
	}

	public function setOffY(nOffY:Number):Void
	{
		m_nOffH = nOffY;
	}

	public function setItemSize(nW:Number, nH:Number):Void
	{
		m_nItemW = nW;
		m_nItemH = nH;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var mLeft:Number = m_look.getMargin("left", m_data);
			var mTop:Number = m_look.getMargin("top", m_data);
			var mRight:Number = m_look.getMargin("right", m_data);
			var mBottom:Number = m_look.getMargin("bottom", m_data);
			var curX:Number = mLeft;
			var curY:Number = mTop;
			var maxW:Number = 0;
			var maxH:Number = 0;
			for(var i:Number = 0; i < m_arrItems.length; i++)
				if(m_arrItems[i]._visible)
				{
					m_arrItems[i]._x = curX;
					m_arrItems[i]._y = curY;
					maxW = Math.max(maxW, m_arrItems[i]._x + m_arrItems[i].getW());
					maxH = Math.max(maxH, m_arrItems[i]._y + m_arrItems[i].getH());
					if(i >= m_arrItems.length - 1) break;
					if(m_strFillType == "horz")
					{
						curY += m_nOffH + m_arrItems[i].getH();
						if(curY > m_nH - m_arrItems[i + 1].getH() - mBottom)
						{
							curY = mTop;
							curX += m_nOffW + m_arrItems[i].getW();
						}
					}
					else
					{
						curX += m_nOffW + m_arrItems[i].getW();
						if(curX > m_nW - m_arrItems[i + 1].getW() - mRight)
						{
							curX = mLeft;
							curY += m_nOffH + m_arrItems[i].getH();
						}
					}
				}
			m_nW = maxW + mRight;
			m_nH = maxH + mBottom;
		}
		super.update();
	}
}