﻿class pseudo.LayoutManager extends pseudo.BaseMovie
{
	static private var m_instance:pseudo.LayoutManager;
	private var m_layer:MovieClip;
	private var m_nOffX:Number;
	private var m_nOffY:Number;
	private var m_mngWnd:pseudo.WindowManager;
	private var m_arrPanels:Array; // {pos:"leftpanel" / "rightpanel" / "toppanel" / "bottompanel", panel:panel}
	private var m_layerResize:MovieClip;
	private var m_nMouseOff:Number; // mouse offset from pane border
	private var m_resizePane:pseudo.Curtain;
	private var m_resizeX:Number;
	private var m_resizeY:Number;
	private var m_resizeW:Number;
	private var m_resizeH:Number;
	private var m_workX:Number; // work area x
	private var m_workY:Number; // work area y
	private var m_workW:Number; // work area w
	private var m_workH:Number; // work area h
	private var m_posType:String; // last calculated pos type

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.LayoutManager
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.LayoutManager(pOwner[strName]);
		return pOwner[strName];
	}

	public function setWndMng(mngWnd:pseudo.WindowManager):Void
	{
		if(m_mngWnd)
			for(var i:Number = 0; i < m_arrItems.length; i++)
				if(m_arrItems[i] == m_mngWnd)
				{
					m_arrItems.splice(i, 1);
					break;
				}
		m_mngWnd = mngWnd;
		mngWnd.setLook(m_look);
		m_arrItems.push(mngWnd);
	}

	public function addWindow(strTitle:String, pClass:Function, bMyPos:Boolean):pseudo.BaseWindow
	{
		var wnd:pseudo.BaseWindow = m_mngWnd.addWindow(strTitle, pClass, null, bMyPos);
		wnd.addListener("startMovePane", this, onStartMovePane, wnd);
		wnd.addListener("finishMovePane", this, onFinishMovePane, wnd);
		return wnd;
	}

	public function addPane(panelPos:String, pContent:Function, id:String, titleText:String):pseudo.BaseMovie
	{
		return addPaneTo(panelPos, pContent, id, titleText);
	}

	private function addPaneTo(panelPos:String, pContent:Function, id:String, titleText:String, pt:Object):pseudo.BaseMovie
	{
		var cont:classes.PaneContainer =
			classes.PaneContainer(addPanel(panelPos).getItem("pane").getItem("content"));
		var curtain:pseudo.BaseMovie = cont.addCurtain(pContent, id, titleText, pt);
		curtain.addListener("startMovePane", this, onStartMovePane, curtain);
		curtain.addListener("finishMovePane", this, onFinishMovePane, curtain);
		curtain.setLook(m_look);
		cont.setUpdated(false);
		return curtain;
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_workX = 0;
			m_workY = 0;
			m_workW = m_nW;
			m_workH = m_nH;
			for(var i:Number = 0; i < m_arrPanels.length; i++)
			{
				var panel:pseudo.Curtain = m_arrPanels[i].panel;
				switch(m_arrPanels[i].pos)
				{
					case "leftpanel":
						panel._y = m_workY;
						panel.setH(m_workH);
						m_workX = panel.getW();
						m_workW -= panel.getW();
						break;
					case "rightpanel":
						panel._x = m_workX + m_workW - panel.getW();
						panel._y = m_workY;
						panel.setH(m_workH);
						m_workW -= panel.getW();
						break;
					case "toppanel":
						panel._x = m_workX;
						panel.setW(m_workW);
						m_workY = panel.getH();
						m_workH -= panel.getH();
						break;
					case "bottompanel":
						panel._x = m_workX;
						panel._y = m_workY + m_workH - panel.getH();
						panel.setW(m_workW);
						m_workH -= panel.getH();
						break;
				}
			}
			m_mngWnd.setWorkArea(m_workX, m_workY, m_workW, m_workH);
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function LayoutManager(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.LayoutManager;

		m_arrPanels = new Array();
	}

	private function getPanel(pos:String):pseudo.Curtain
	{
		for(var i:Number = 0; i < m_arrPanels.length; i++)
			if(m_arrPanels[i].pos == pos) return m_arrPanels[i].panel;
		return null;
	}

	private function addPanel(pos:String):pseudo.Curtain
	{
		switch(pos)
		{
			case "leftborder": pos = "leftpanel"; break;
			case "rightborder": pos = "rightpanel"; break;
			case "topborder": pos = "toppanel"; break;
			case "bottomborder": pos = "bottompanel"; break;
		}
		for(var i:Number = 0; i < m_arrPanels.length; i++)
			if(m_arrPanels[i].pos == pos) return m_arrPanels[i].panel;

		// add panel
		var depth:Number = getNextHighestDepth();
		var panel:pseudo.Curtain = pseudo.Curtain.create(this, "panel" + depth, depth);
		var resize:pseudo.BaseMovie = panel.setResize(pseudo.ResizeHideLine);
		resize.addListener("startResize", this, onStartResizePane, panel);
		resize.addListener("finishResize", this, onFinishResizePane, panel);
		panel.addListener("showHide", this, onShowHide, panel);
		panel.setData({border:0});
		panel.setName(pos);
		pseudo.Pane(panel.setPane(pseudo.Pane)).setContent(classes.PaneContainer);
		panel.setLook(m_look);
		m_arrItems.push(panel);

		switch(pos)
		{
			case "leftpanel":
				panel.setAlign("left");
				var w:Number = parseInt(_global.xmlConfig.getAttr("paneLeftW"));
				panel.setSize(w ? w : 214, m_nH);
				break;
			case "rightpanel":
				panel.setAlign("right");
				var w:Number = parseInt(_global.xmlConfig.getAttr("paneRightW"));
				panel.setSize(w ? w : 214, m_nH);
				break;
			case "toppanel":
				panel.setAlign("top");
				var h:Number = parseInt(_global.xmlConfig.getAttr("paneTopH"));
				panel.setSize(m_nW, h ? h : 214);
				break;
			case "bottompanel":
				panel.setAlign("bottom");
				var h:Number = parseInt(_global.xmlConfig.getAttr("paneBottomH"));
				panel.setSize(m_nW, h ? h : 214);
				break;
		}
		var obj:Object = {pos:pos, panel:panel};
		m_arrPanels.push(obj);
		panel.addListener("close", this, onClosePanel, obj);
		m_bUpdated = false;
		return panel;
	}

	private function onClosePanel(obj:Object):Void
	{
		for(var i:Number = 0; i < m_arrPanels.length; i++)
			if(obj.pos == m_arrPanels[i].pos)
			{
				removeItem(m_arrPanels[i].panel.getName());
				m_arrPanels.splice(i, 1);
				m_bUpdated = false;
				update();
				draw();
				break;
			}
	}

	private function getPosTypeFromPt(pt:Object):String
	{
		for(var i:Number = 0; i < m_arrPanels.length; i++)
			if(m_arrPanels[i].panel.isMouseOver(pt.x, pt.y))
				return m_arrPanels[i].pos;
		if(!getPanel("leftpanel") && pt.x < m_workX + 5) return "leftborder";
		else if(!getPanel("rightpanel") && pt.x > m_workX + m_workW - 5) return "rightborder";
		else if(!getPanel("toppanel") && pt.y < m_workY + 5) return "topborder";
		else if(!getPanel("bottompanel") && pt.y > m_workY + m_workH - 5) return "bottomborder";
		return "pane";
	}

	private function getRectFromPt(pt:Object, item:pseudo.BaseMovie):Object
	{
		m_posType = getPosTypeFromPt(pt);
		var rect:Object = new Object();
		switch(m_posType)
		{
			case "leftpanel":
			case "rightpanel":
			case "toppanel":
			case "bottompanel":
				return classes.PaneContainer(
						getPanel(m_posType).getItem("pane").getItem("content")
					).getRectFromPt(pt, item);
			case "leftborder":
				rect.x = pt.x < 5 ? 0 : m_workX;
				rect.y = m_workY;
				rect.w = 214;
				rect.h = m_workH;
				break;
			case "rightborder":
				rect.x = (pt.x > m_nW - 5 ? m_nW : m_workX + m_workW) - 214;
				rect.y = m_workY;
				rect.w = 214;
				rect.h = m_workH;
				break;
			case "topborder":
				rect.x = m_workX;
				rect.y = pt.y < 5 ? 0 : m_workY;
				rect.w = m_workW;
				rect.h = 214;
				break;
			case "bottomborder":
				rect.x = m_workX;
				rect.y = (pt.x > m_nW - 5 ? m_nH : m_workY + m_workH) - 214;
				rect.w = m_workW;
				rect.h = 214;
				break;
			default:
				rect.x = _xmouse - m_nOffX;
				rect.y = _ymouse - m_nOffY;
				if(pseudo.BaseWindow(item))
				{
					rect.w = item.getW();
					rect.h = item.getH();
				}
				else
				{
					rect.w = item.getPrefW();
					rect.h = item.getPrefH();
				}
				break;
		}
		return rect;
	}

	private function getMouseX():Number
	{
		return Math.max(0, Math.min(m_nW, _xmouse));
	}

	private function getMouseY():Number
	{
		return Math.max(0, Math.min(m_nH, _ymouse));
	}

	private function getMousePt():Object
	{
		return {x:getMouseX(), y:getMouseY()};
	}

	private function onMovePane(pane:pseudo.BaseMovie):Void
	{
		var rect:Object = getRectFromPt(getMousePt(), pane);
		m_look.drawResizeFrame(m_layer, rect.x, rect.y, rect.w, rect.h);
	}

	private function onStartMovePane(pane:pseudo.BaseMovie):Void
	{
		pane.addListener("movePane", this, onMovePane, pane);
		if(!m_layer) m_layer = createEmptyMovieClip("m_layer", getNextHighestDepth());
		var pt:Object = ({x:pane._x, y:pane._y});
		pane._parent.localToGlobal(pt);
		m_nOffX = _xmouse - pt.x;
		m_nOffY = _ymouse - pt.y;
		onMovePane(pane);
	}

	private function onFinishMovePane(item:pseudo.BaseMovie):Void
	{
		item.removeListener("movePane");
		if(m_layer)
		{
			m_layer.removeMovieClip();
			delete m_layer;
		}
		var wnd:pseudo.BaseWindow = pseudo.BaseWindow(item);
		switch(m_posType)
		{
			case "leftpanel":
			case "rightpanel":
			case "toppanel":
			case "bottompanel":
			case "leftborder":
			case "rightborder":
			case "topborder":
			case "bottomborder":
				var newItem:pseudo.BaseMovie = addPaneTo(m_posType
					, item.getItem("pane").getItem("content").getClass()
					, item.getName(), "text"
					, getMousePt()
				);
				//newItem.initFrom(item);
				item.fireBroadEvent("close");
				update();
				draw();
				break;
			default:
				var x:Number = _xmouse - m_nOffX;
				var y:Number = _ymouse - m_nOffY;
				if(wnd && !wnd.isMaximized())
				{
					if(x != item._x || y != item._y)
					{
						item._x = x;
						item._y = y;
					}
				}
				else
				{
					wnd = addWindow("text", null, true);
					var pane:pseudo.BaseMovie = item.getItem("pane").getItem("content");
					classes.WindowTitle(wnd.setTitleBar(classes.WindowPaneTitle)).setText("test window");
					var newItem:pseudo.BaseMovie = wnd.setPane(pseudo.Pane).setContent(pane.getClass());
					//newItem.initFrom(pane);
					wnd.setSize(wnd.getPrefW(), wnd.getPrefH());
					wnd._x = x;
					wnd._y = y;
					item.fireBroadEvent("close");
					m_mngWnd.update();
					m_mngWnd.draw();
				}
				break;
		}
	}

	// panes routines
	private function onShowHide():Void
	{
		m_bUpdated = false;
		update();
		draw();
	}

	private function onStartResizePane(pane:pseudo.Curtain):Void
	{
		m_resizePane = pane;
		if(!m_layerResize) createEmptyMovieClip("m_layerResize", getNextHighestDepth());
		switch(pane.getAlign())
		{
			case "left": m_nMouseOff = _xmouse - pane._x - pane.getW(); break;
			case "right": m_nMouseOff = _xmouse - pane._x; break;
			case "top": m_nMouseOff = _ymouse - pane._y - pane.getH(); break;
			case "bottom": m_nMouseOff = _ymouse - pane._y; break;
		}
		onMouseMove = onResizePane;
		onResizePane(pane);
	}

	private function onFinishResizePane():Void
	{
		m_resizeX = m_resizeY = m_resizeW = m_resizeH = 0;
		if(m_layerResize) m_layerResize.removeMovieClip();
		switch(m_resizePane.getAlign())
		{
			case "left":
				m_resizePane.setW(Math.min(400, Math.max(m_resizePane.getMinW(), _xmouse - m_resizePane._x - m_nMouseOff)));
				break;
			case "right":
				m_resizePane.setW(Math.min(400, Math.max(m_resizePane.getMinW(), m_resizePane._x - _xmouse + m_nMouseOff + m_resizePane.getW())));
				break;
			case "top":
				m_resizePane.setH(Math.min(300, Math.max(m_resizePane.getMinH(), _ymouse - m_resizePane._y - m_nMouseOff)));
				break;
			case "bottom":
				m_resizePane.setH(Math.min(300, Math.max(m_resizePane.getMinH(), m_resizePane._y - _ymouse + m_nMouseOff + m_resizePane.getH())));
				break;
		}
		m_bUpdated = m_resizePane.isUpdated();
		m_resizePane.show();
		update();
		draw();
		delete onMouseMove;
	}

	private function onResizePane():Void
	{
		var x, y, w, h:Number;
		if(m_layerResize)
		{
			switch(m_resizePane.getAlign())
			{
				case "left":
					x = m_resizePane._x;
					y = m_resizePane._y;
					w = Math.min(400, Math.max(m_resizePane.getMinW(), _xmouse - m_resizePane._x - m_nMouseOff));
					h = m_resizePane.getH();
					break;
				case "right":
					var nW:Number = Math.min(400, Math.max(m_resizePane.getMinW(), m_resizePane._x - _xmouse + m_nMouseOff + m_resizePane.getW()));
					x = m_resizePane._x + m_resizePane.getW() - nW;
					y = m_resizePane._y;
					w = nW;
					h = m_resizePane.getH();
					break;
				case "top":
					x = m_resizePane._x;
					y = m_resizePane._y;
					w = m_resizePane.getW();
					h = Math.min(300, Math.max(m_resizePane.getMinH(), _ymouse - m_resizePane._y - m_nMouseOff));
					break;
				case "bottom":
					var nH:Number = Math.min(300, Math.max(m_resizePane.getMinH(), m_resizePane._y - _ymouse + m_nMouseOff + m_resizePane.getH()));
					x = m_resizePane._x;
					y = m_resizePane._y + m_resizePane.getH() - nH;
					w = m_resizePane.getW();
					h = nH;
					break;
			}
			if(x != m_resizeX || y != m_resizeY || w != m_resizeW || h != m_resizeH)
			{
				m_look.drawResizeFrame(m_layerResize, x, y, w, h);
				m_resizeX = x;
				m_resizeY = y;
				m_resizeW = w;
				m_resizeH = h;
			}
		}
	}
}