﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.Pane extends pseudo.BaseComponent
{
	private var m_content:pseudo.BaseMovie;
	private var m_layerMask:MovieClip;
	private var m_nMCLeft:Number;
	private var m_nMCTop:Number;
	private var m_nMCRight:Number;
	private var m_nMCBottom:Number;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.Pane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.Pane(pOwner[strName]);
		return pOwner[strName];
	}

	public function Pane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.Pane;

		m_content = null;
		pThis.createEmptyMovieClip("m_layerMask", 1);
		pThis["m_layerMask"]._visible = false;
		m_nMCLeft = m_nMCTop = m_nMCRight = m_nMCBottom = 0;
		m_data.className = "Pane";
	}

	public function getMinW():Number
	{
		return getBorderW() + (m_content ? m_content.getMinW() : 0);
	}

	public function getMinH():Number
	{
		return getBorderH() + (m_content ? m_content.getMinH() : 0);
	}

	public function getMaxW():Number
	{
		return getBorderW() + (m_content ? m_content.getMaxW() : 0);
	}

	public function getMaxH():Number
	{
		return getBorderH() + (m_content ? m_content.getMaxH() : 0);
	}

	public function getPrefW():Number
	{
		return getBorderW() + (m_content ? m_content.getPrefW() : 0);
	}

	public function getPrefH():Number
	{
		return getBorderH() + (m_content ? m_content.getPrefH() : 0);
	}

	public function setContent(pClass:Function):pseudo.BaseMovie
	{
		var arrParams:Array = new Array(pClass, "content", 3);
		arrParams = arrParams.concat(arguments.slice(1));
		m_content = pseudo.BaseMovie(this.addItem.apply(this, arrParams));
		m_content.setMask(m_layerMask);
		m_bUpdated = false;
		return m_content;
	}

	public function setContentMargins(nLeft:Number, nTop:Number, nRight:Number, nBottom:Number):Void
	{
		m_nMCLeft = nLeft;
		m_nMCTop = nTop;
		m_nMCRight = nRight;
		m_nMCBottom = nBottom;
		m_content._x = m_look.getMargin("left", m_data) + nLeft;
		m_content._y = m_look.getMargin("top", m_data) + nTop;
	}

	public function getContentMargin(strName:String):Number
	{
		switch(strName)
		{
			case "left": return m_nMCLeft;
			case "top": return m_nMCTop;
			case "right": return m_nMCRight;
			case "bottom": return m_nMCBottom;
		}
		return null;
	}

	public function setContentMargin(strName:String, nVal:Number):Void
	{
		switch(strName)
		{
			case "left": m_nMCLeft = nVal; break;
			case "top": m_nMCTop = nVal; break;
			case "right": m_nMCRight = nVal; break;
			case "bottom": m_nMCBottom = nVal; break;
		}
	}

	public function update():Void
	{
		if(_visible)
		{
			if(!m_bUpdated)
			{
				m_content._x = m_layerMask._x = m_look.getMargin("left", m_data);
				m_content._y = m_layerMask._y = m_look.getMargin("top", m_data);
				m_content.setSize(getUserW(), getUserH());
			}
			super.update();
		}
	}

	public function draw():Void
	{
		if(!m_bDrawn)
			m_look.updateMask(m_layerMask, getUserW(), getUserH(), m_data);
		super.draw();
	}

	//
	// PRIVATE METHODS
	//
	/*private function movieMouseUp(bSkip:Boolean):Void
	{
		if(!bSkip)
		{
			if(!m_layerMask.hitTest(_root._xmouse, _root._ymouse, true))
				pseudo.BaseComponent.removeActiveItem(this);//m_content);
		}
		super.movieMouseUp(true);
	}

	private function movieMouseMove(bSkip:Boolean):Void
	{
		if(!bSkip)
		{
			if(!m_layerMask.hitTest(_root._xmouse, _root._ymouse, true))
				pseudo.BaseComponent.removeActiveItem(this);//m_content);
		}
		super.movieMouseMove(true);
	}*/
}