﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.ResizeHideLine extends pseudo.ResizeLine implements pseudo.IAlignable, pseudo.IHideable
{
	private var m_btnResize:pseudo.ToggleButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.ResizeHideLine
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.ResizeHideLine(pOwner[strName]);
		return pOwner[strName];
	}

	public function ResizeHideLine(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.ResizeHideLine;

		m_btnResize = pseudo.ToggleButton.create(pThis, "m_btnResize", 2);
		m_btnResize.addListener("mouseRelease", pThis, onToggleClick);
		m_btnResize.setName("btnResize");
		m_data.className = "ResizeHideLine";
		m_arrItems.push(m_btnResize);
	}

	public function hide():Void
	{
		m_btnResize.setState("sunken");
	}

	public function show():Void
	{
		m_btnResize.setState("normal");
	}

	public function showHide():Void
	{
		m_btnResize.isSunken() ? show() : hide();
	}

	public function setAlign(strAlign:String):Void
	{
		super.setAlign(strAlign);
		switch(strAlign)
		{
			case "right":
				m_btnResize.setData({type:"resizeRight"});
				break;
			case "top":
				m_btnResize.setData({type:"resizeTop"});
				break;
			case "bottom":
				m_btnResize.setData({type:"resizeBottom"});
				break;
			default:
				m_btnResize.setData({type:"resizeLeft"});
				break;
		}
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			var obj:Object = m_look.getParams({type:"resizeLine", align:m_strAlign, data:m_data});
			m_btnResize.setSize(obj.btnW, obj.btnH);
			delete obj;
			switch(m_strAlign)
			{
				case "right":
					m_btnResize._x = Math.round((3 - m_btnResize.getW() - 0.5) / 2);
					m_btnResize._y = Math.round((m_nH - m_btnResize.getH()) / 2);
					break;
				case "bottom":
					m_btnResize._y = Math.round((3 - m_btnResize.getH() - 0.5) / 2);
					m_btnResize._x = Math.round((m_nW - m_btnResize.getW()) / 2);
					break;
				case "top":
					m_btnResize._y = m_nH - Math.round((3 + m_btnResize.getH() + 1) / 2) + 1;
					m_btnResize._x = Math.round((m_nW - m_btnResize.getW()) / 2);
					break;
				default: // left
					m_btnResize._x = m_nW - Math.round((3 + m_btnResize.getW() + 1) / 2) + 1;
					m_btnResize._y = Math.round((m_nH - m_btnResize.getH()) / 2);
					break;
			}
		}
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function onToggleClick():Void
	{
		fireEvent("showHide");
		m_btnResize.invokeEvent("showLayer"); // redraw after possible moving
	}
}