﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.ResizeLine extends pseudo.BaseMovie implements pseudo.IAlignable
{
	private var m_strAlign:String;
	private var m_line:pseudo.BaseComponent;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.ResizeLine
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.ResizeLine(pOwner[strName]);
		return pOwner[strName];
	}

	public function ResizeLine(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.ResizeLine;
		
		m_line = pseudo.BaseComponent.create(pThis, "m_line", 1);
		m_line.setData({type:"resizeLine"});
		m_line.addListener("rollOver", pThis, lineRollOver);
		m_line.addListener("rollOut", pThis, lineRollOut);
		m_line.addListener("mouseDown", pThis, fireEvent, "startResize");
		m_line.addListener("mouseUp", pThis, fireEvent, "finishResize");
		m_strAlign = "left";
		m_data.className = "ResizeLine";
		m_arrItems.push(m_line);
	}

	public function setAlign(align:String):Void
	{
		m_strAlign = align;
		switch(align)
		{
			case "top":
			case "bottom":
				m_nH = 3;
				break;
			default:
				m_nW = 3;
				break;
		}
	}

	public function getAlign():String
	{
		return m_strAlign;
	}

	public function update():Void
	{
		if(!m_bUpdated) m_line.setSize(m_nW, m_nH);
		super.update();
	}

	//
	// PRIVATE METHODS
	//
	private function lineRollOver():Void
	{
		pseudo.CursorManager.getInstance().setCursor(
			(m_strAlign == "top" || m_strAlign == "bottom") ? "vertResize" : "horzResize"
		);
	}

	private function lineRollOut():Void
	{
		pseudo.CursorManager.getInstance().setCursor();
	}
}