﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.ScrollPane extends pseudo.Pane
{
	private var m_scrollVert:pseudo.ScrollBar;
	private var m_scrollHorz:pseudo.ScrollBar;
	private var m_mcResize:pseudo.PushButton;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.ScrollPane
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.ScrollPane(pOwner[strName]);
		return pOwner[strName];
	}

	public function ScrollPane(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.ScrollPane;

		m_scrollVert = pseudo.ScrollBar.create(pThis, "m_scrollVert", 4);
		m_scrollVert.setW(15);
		m_scrollVert.setName("scrollVert");
		m_scrollHorz = pseudo.ScrollBar.create(pThis, "m_scrollHorz", 5);
		m_scrollHorz.setH(15);
		m_scrollHorz.setName("scrollHorz");
		m_mcResize = pseudo.PushButton.create(pThis, "m_mcResize", 6);
		m_mcResize.setSize(15, 15);
		m_mcResize.setData({type:"scrollBack"});
		m_mcResize.setName("mcResize");
		m_scrollHorz.setAlign("horz");
		m_scrollVert.addListener("changePos", pThis, onScrollContent);
		m_scrollHorz.addListener("changePos", pThis, onScrollContent);
		m_arrItems.push(m_scrollVert, m_scrollHorz, m_mcResize);
	}

	public function getUserW():Number
	{
		return super.getUserW() - (m_scrollVert._visible ? m_scrollVert.getW() : 0);
	}

	public function getUserH():Number
	{
		return super.getUserH() - (m_scrollHorz._visible ? m_scrollHorz.getH() : 0);
	}

	public function update():Void
	{
		if(!m_bUpdated)
		{
			m_scrollHorz._visible = false;
			m_scrollVert._visible = false;
			m_mcResize._visible = false;
			var nVisibleW:Number = getUserW();
			var nVisibleH:Number = getUserH();
			m_content.setSize(nVisibleW, nVisibleH);
			m_content.update();

			var nW:Number = m_content.getW() - m_nMCLeft + m_nMCRight;
			var nH:Number = m_content.getH() - m_nMCTop + m_nMCBottom;
			if(nVisibleW < nW)
			{ // content width is larger than visible width
				m_scrollHorz._visible = true;
				nVisibleH -= 15;
				m_content.setSize(nVisibleW, nVisibleH);
				m_content.update();
				nW = m_content.getW() + m_nMCLeft + m_nMCRight;
				nH = m_content.getH() + m_nMCTop + m_nMCBottom;
			}
			if(nVisibleH < nH)
			{ // content height is larger than visible width
				m_scrollVert._visible = true;
				nVisibleW -= 15;
				m_content.setSize(nVisibleW, nVisibleH);
				m_content.update();
				nW = m_content.getW() + m_nMCLeft + m_nMCRight;
				nH = m_content.getH() + m_nMCTop + m_nMCBottom;
				if(nVisibleW < nW && !m_scrollHorz._visible)
				{ // now we already has vert scrollbar and need horz scrollbar
					m_scrollHorz._visible = true;
					nVisibleH -= 15;
					m_content.setSize(nVisibleW, nVisibleH);
					m_content.update();
					nW = m_content.getW() + m_nMCLeft + m_nMCRight;
					nH = m_content.getH() + m_nMCTop + m_nMCBottom;
				}
			}
			if(m_scrollHorz._visible)
			{ // change scroll range and size of scrollButton
				m_scrollHorz.setRange(-m_nMCLeft, Math.max(0, nW) + m_nMCRight);
				m_scrollHorz.setScrollSize(nVisibleW);
				m_scrollHorz.setSize(getVisibleW(), 15);
				m_scrollHorz._x = m_look.getBorder("left", m_data);
				m_scrollHorz._y = m_nH - 15 - m_look.getBorder("bottom", m_data);
			}
			else
			{
				var nPos:Number = m_scrollHorz.getMinPos();
				m_scrollHorz.setPos(nPos);
				m_scrollHorz.setRange(nPos, nPos);
			}
			if(m_scrollVert._visible)
			{ // change scroll range and size of scrollButton
				m_scrollVert.setRange(-m_nMCTop, Math.max(0, nH) + m_nMCBottom);
				m_scrollVert.setScrollSize(nVisibleH);
				m_scrollVert.setSize(15, getVisibleH());
				m_scrollVert._y = m_look.getBorder("top", m_data);
				m_scrollVert._x = m_nW - 15 - m_look.getBorder("right", m_data);
			}
			else
			{
				var nPos:Number = m_scrollVert.getMinPos();
				m_scrollVert.setPos(nPos);
				m_scrollVert.setRange(nPos, nPos);
			}
			if(m_scrollHorz._visible && m_scrollVert._visible)
			{ // if both vert and horz scrolls are visible than show rectangle at the right-bottom corner
				m_mcResize._x = m_nW - 15 - m_look.getBorder("right", m_data);
				m_mcResize._y = m_nH - 15 - m_look.getBorder("bottom", m_data);
				m_mcResize._visible = true;
			}
			else m_mcResize._visible = false;
			onScrollContent();
			// note that m_bUpdated is true and super.update function doesn't change mask and content position
			m_layerMask._x = m_look.getMargin("left", m_data);
			m_layerMask._y = m_look.getMargin("top", m_data);
			m_bDrawn = false;
			m_bUpdated = true;
		}
		super.update();
	}

	public function setContentMargins(nLeft:Number, nTop:Number, nRight:Number, nBottom:Number):Void
	{
		super.setContentMargins(nLeft, nTop, nRight, nBottom);
		m_bUpdated = false;
		//m_scrollVert.setRange(-m_nMCTop, m_content.getW() + m_nMCBottom);
		//m_scrollHorz.setRange(-m_nMCLeft, m_content.getH() + m_nMCRight);
	}

	public function setContentMargin(strName:String, nVal:Number):Void
	{
		super.setContentMargin(strName, nVal);
		m_bUpdated = false;
		//m_scrollVert.setRange(-m_nMCTop, m_content.getW() + m_nMCBottom);
		//m_scrollHorz.setRange(-m_nMCLeft, m_content.getH() + m_nMCRight);
	}

	public function setContent(pClass:Function):pseudo.BaseMovie
	{
		super.setContent(pClass);
		pseudo.BaseComponent(m_content).addListener("resize", this, onResize);
		onScrollContent();
		return m_content;
	}

	public function setContentPos(nX:Number, nY:Number):Void
	{
		m_scrollHorz.setPos(nX);
		m_scrollVert.setPos(nY);
		onScrollContent();
	}

	//
	// PRIVATE METHODS
	//
	private function onScrollContent():Void
	{
		m_content._x = m_look.getMargin("left", m_data) - m_scrollHorz.getPos();
		m_content._y = m_look.getMargin("top", m_data) - m_scrollVert.getPos();
	}

	private function getVisibleW():Number
	{
		return m_nW - (m_scrollVert._visible ? m_scrollVert.getW() : 0) -
			m_look.getBorder("left", m_data) -
			m_look.getBorder("right", m_data);
	}

	private function getVisibleH():Number
	{
		return m_nH - (m_scrollHorz._visible ? m_scrollHorz.getH() : 0) -
			m_look.getBorder("top", m_data) -
			m_look.getBorder("bottom", m_data);
	}

	private function onResize():Void
	{
		m_bUpdated = false;
		update();
		draw();
	}
}