﻿/**
 * Copyright (C) 2004 Serguei Pisarev & Maksim Galkin (goldman_alex@mail.ru)
 * You can use this source code in your freeware applications. You cannot change
 * this source code without the express written consent of Serguei Pisarev & Maksim Galkin.
 */
class pseudo.WindowManager extends pseudo.BaseMovie
{
	private var m_arrWindows:Array;
	private var m_mask:MovieClip;
	private var m_nMaskW:Number;
	private var m_nMaskH:Number;
	private var m_nPosX:Number;
	private var m_nPosY:Number;
	private var m_layerResize:MovieClip;
	private var m_nOffX:Number; // xmouse offset from wnd._x + wnd.getW()
	private var m_nOffY:Number; // ymouse offset from wnd._y + wnd.getH()
	private var m_arrNewWindows:Array; // contains newly created (and not placed) windows
	private var m_alignV:String; // vertical align (m/b top middle)
	private var m_alignH:String; // horizontal align (m/b left center)
	private var m_nMyPos:Number; // number of not updated windows that sholdn't be placed by using manager place mechanism
	private var m_bMaximized:Boolean;

	//
	// PUBLIC METHODS
	//
	static public function create(pOwner:MovieClip, strName:String, nDepth:Number):pseudo.WindowManager
	{
		pOwner.createEmptyMovieClip(strName, nDepth);
		pOwner[strName].__proto__ = new pseudo.WindowManager(pOwner[strName]);
		return pOwner[strName];
	}

	public function WindowManager(pThis:MovieClip)
	{
		super(pThis);
		if(!pThis) pThis = this;
		m_pClass = pseudo.WindowManager;

		m_arrWindows = new Array();
		pThis.createEmptyMovieClip("m_mask", 1);
		pThis["m_mask"]._visible = false;
		pThis.setMask(pThis["m_mask"]);
		m_nMaskW = m_nMaskH = 0;
		pThis.onMouseDown = managerMouseDown;
		m_layerResize = null;
		m_alignH = "left";
		m_alignV = "top";
		m_arrNewWindows = new Array();
		m_nMyPos = 0;
		m_bMaximized = false;
	}

	public function showMaximized(bMaximized:Boolean):Void
	{
		m_bMaximized = bMaximized;
	}

	public function setStart(horz:String, vert:String):Void
	{
		m_alignH = horz;
		m_alignV = vert;
	}

	public function placeWnd(wnd:pseudo.BaseWindow, offX:Number, offY:Number):Boolean
	{
		if(wnd._visible)
		{
			if(m_nPosX + wnd.getW() > m_mask._x + m_nMaskW) m_nPosX = m_mask._x;
			if(m_nPosY + wnd.getH() > m_mask._y + m_nMaskH) m_nPosY = m_mask._y;
			wnd._x = m_nPosX;
			wnd._y = m_nPosY;
			m_nPosX += offX;
			m_nPosY += offY;
			return true;
		}
		return false;
	}

	public function getMaskX():Number
	{
		return m_mask._x;
	}

	public function getMaskY():Number
	{
		return m_mask._y;
	}

	public function getMaskW():Number
	{
		return m_nMaskW;
	}

	public function getMaskH():Number
	{
		return m_nMaskH;
	}

	public function setLook(look:Object):Void
	{
		if(m_look) m_nPosY += look.getParams({type:"wndTitle"}).h - m_look.getParams({type:"wndTitle"}).h;
		super.setLook(look);
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			m_arrWindows[i].setLook(look);
	}

	public function addWindow(strTitle:String, pClass:Function, strName:String, bMyPos:Boolean):pseudo.BaseWindow
	{
		if(!pClass) pClass = pseudo.BaseWindow;
		var nDepth:Number = getNextHighestDepth();
		m_arrWindows[0].setData({mode:"out"});
		var wnd:pseudo.BaseWindow = pClass.create(this, "window_" + pseudo.BaseWindow.getNewId(), nDepth);
		m_arrWindows.unshift(wnd);
		wnd.addListener("close", this, onCloseWindow, wnd);
		wnd.addListener("moveWindow", this, onMoveWindow, wnd);
		wnd.addListener("maximizeWindow", this, onMaximizeWindow, wnd);
		wnd.addListener("minimizeWindow", this, onMinimizeWindow, wnd);
		wnd.addListener("hideWindow", this, onHideWindow, wnd);
		wnd.addListener("startResize", this, onStartResize, wnd);
		wnd.addListener("finishResize", this, onFinishResize, wnd);
		wnd.addListener("resize", this, onResize, wnd);
		wnd.setData({mode:"over"});
		wnd.setName(strName ? strName : String(wnd.getId()));
		wnd.setLook(m_look);
		if(bMyPos) m_nMyPos++;
		else m_arrNewWindows.unshift(wnd);
		return wnd;
	}

	public function getWindow(strName:String):pseudo.BaseWindow
	{
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			if(m_arrWindows[i].getName() == strName) return m_arrWindows[i];
		return null;
	}

	public function getWndFromId(id:Number):pseudo.BaseWindow
	{
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			if(m_arrWindows[i].getId() == id) return m_arrWindows[i];
		return null;
	}

	public function setWorkArea(nX:Number, nY:Number, nW:Number, nH:Number):Void
	{
		m_mask._x = nX;
		m_mask._y = nY;
		if(m_nMaskW != nW || m_nMaskH != nH)
		{
			m_bUpdated = false;
			m_bDrawn = false;
			m_nMaskW = nW;
			m_nMaskH = nH;
		}
	}

	public function closeWindow(wnd:pseudo.BaseWindow):Number
	{
		pseudo.SoundManager.getInstance().playSound("wndClose");
		var nId:Number = -1;
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			if(m_arrWindows[i] == wnd)
			{
				nId = i;
				m_arrWindows[i].remove();
				m_arrWindows.splice(i, 1);
				m_arrWindows[0].setFocused(true);
				break;
			}
		return nId;
	}

	public function closeAllWindows():Void
	{
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			m_arrWindows[i].remove();
		m_arrWindows.splice(0);
	}

	public function maximizeWindow(wnd:pseudo.BaseWindow):Void
	{
		pseudo.SoundManager.getInstance().playSound("wndMaximize");
		if(!wnd) wnd = m_arrWindows[0];
		wnd.invokeEvent("maximizeWindow");
		wnd.setSize(m_nMaskW, m_nMaskH);
		wnd._x = m_mask._x;
		wnd._y = m_mask._y;
	}

	public function minimizeWindow(wnd:pseudo.BaseWindow):Void
	{
		pseudo.SoundManager.getInstance().playSound("wndMinimize");
		if(!wnd) wnd = m_arrWindows[0];
		wnd.invokeEvent("minimizeWindow");
	}

	public function hideWindow(wnd:pseudo.BaseWindow):Void
	{
		if(wnd.isVisible()) pseudo.SoundManager.getInstance().playSound("wndHide");
		wnd.setVisible(false);
	}

	public function showWindow(wnd:pseudo.BaseWindow):Void
	{
		if(!wnd.isVisible()) pseudo.SoundManager.getInstance().playSound("wndShow");
		wnd.setVisible(true);
	}

	public function update():Void
	{
		if(m_arrWindows.length > 0)
		{
			if(m_arrWindows.length == m_arrNewWindows.length + m_nMyPos)
			{
				m_nPosX = m_mask._x + (m_alignH == "center" ? Math.round((m_nMaskW - m_arrNewWindows[0].getW()) / 2) : 10);
				m_nPosY = m_mask._y + (m_alignV == "middle" ? Math.round((m_nMaskH - m_arrNewWindows[0].getH()) / 2) : 10);
			}
			m_nMyPos = 0;
			var titleH:Number = m_look.getParams({type:"wndTitle"}).h;
			for(var i:Number = m_arrNewWindows.length - 1; i >= 0; i--)
				if(placeWnd(m_arrNewWindows[i], 3, titleH))
				{
					if(m_bMaximized)
						m_arrNewWindows[i].invokeEvent("maximizeWindow");
					m_arrNewWindows.splice(i, 1);
				}
			for(var i:Number = 0; i < m_arrWindows.length; i++)
			{
				var wnd:pseudo.BaseWindow = m_arrWindows[i];
				if(wnd.isMaximized())
				{
					wnd.setSize(m_nMaskW, m_nMaskH);
					wnd._x = m_mask._x;
					wnd._y = m_mask._y;
					wnd.update();
					break;
				}
				wnd.update();
			}
		}
		super.update();
	}

	public function draw():Void
	{
		if(!m_bDrawn)
		{
			super.draw();
			m_look.updateMask(m_mask, m_nMaskW, m_nMaskH, m_data);
		}
		for(var i:Number = 0; i < m_arrWindows.length; i++)
		{
			m_arrWindows[i].draw();
			if(m_arrWindows[i].isMaximized()) break;
		}
	}

	public function remove():Void
	{
		for(var i:Number = 0; i < m_arrWindows.length; i++)
			m_arrWindows[i].remove();
		super.remove();
	}

	public function moveWindow(x:Number, y:Number, wnd:pseudo.BaseWindow, bSnap:Boolean):Void
	{
		wnd._x = x;
		wnd._y = y;
	}

	public function sendToTop(wnd:pseudo.BaseWindow):Void
	{
		for(var i:Number = 1; i < m_arrWindows.length; i++)
		{
			if(wnd == m_arrWindows[i])
			{
				for(var j:Number = i - 1; j >= 0; j--)
					m_arrWindows[j].swapDepths(wnd);
				m_arrWindows[0].setFocused(false);
				wnd.setFocused(true);
				m_arrWindows.splice(i, 1);
				m_arrWindows.unshift(wnd);
				break;
			}
		}
		showWindow(wnd);
	}

	//
	// PRIVATE METHODS
	//
	private function getFocusedWindow():pseudo.BaseWindow
	{
		return m_arrWindows[0];
	}

	private function getWindowFromCursor():pseudo.BaseWindow
	{
		for(var i:Number = 0; i < m_arrWindows.length; i++)
		{
			var wnd:pseudo.BaseWindow = m_arrWindows[i];
			if(wnd.isMouseOver())
			{
				//wnd.invokeEvent("componentRollOver");
				return wnd.getLock() ? null : wnd;
			}
		}
		return null;
	}

	private function managerMouseDown():Void
	{
		if(m_mask.hitTest(_root._xmouse, _root._ymouse))
		{
			var wnd:pseudo.BaseWindow = getWindowFromCursor();
			if(wnd && m_arrWindows[0] != wnd)
			{
				sendToTop(wnd);
				update();
				draw();
			}
		}
	}

	private function onCloseWindow(wnd:pseudo.BaseWindow):Void
	{
		closeWindow(wnd);
		update();
		m_arrWindows[0].draw();
	}

	private function onMoveWindow(x:Number, y:Number, wnd:pseudo.BaseWindow):Void
	{
		moveWindow(x, y, wnd, true);
		if(m_arrWindows[0] != wnd)
		{
			sendToTop(wnd);
			update();
			draw();
		}
	}

	private function onMaximizeWindow(wnd:pseudo.BaseWindow):Void
	{
		maximizeWindow(wnd);
		wnd.update();
		wnd.draw();
	}

	private function onMinimizeWindow(wnd:pseudo.BaseWindow):Void
	{
		minimizeWindow(wnd);
		wnd.update();
		wnd.draw();
	}

	private function onHideWindow(wnd:pseudo.BaseWindow):Void
	{
		hideWindow(wnd);
		m_arrWindows[0].update();
		m_arrWindows[0].draw();
	}

	private function getWndW(wnd:pseudo.BaseWindow, nW:Number):Number
	{
		return Math.min(m_mask._width, Math.max(nW, wnd.getMinW()));
	}

	private function getWndH(wnd:pseudo.BaseWindow, nH:Number):Number
	{
		return Math.min(m_mask._height, Math.max(nH, wnd.getMinH()));
	}

	private function onStartResize(wnd:pseudo.BaseWindow):Void
	{
		// xxx potentially here may be an error when the new window is created when we are in resize mode
		if(!m_layerResize) createEmptyMovieClip("m_layerResize", getNextHighestDepth());
		m_nOffX = _xmouse - wnd._x - wnd.getW();
		m_nOffY = _ymouse - wnd._y - wnd.getH();
		onResize(wnd);
	}

	private function onFinishResize(wnd:pseudo.BaseWindow):Void
	{
		if(m_layerResize) m_layerResize.removeMovieClip();
		var nNewW:Number = getWndW(wnd, _xmouse - wnd._x - m_nOffX);
		var nNewH:Number = getWndH(wnd, _ymouse - wnd._y - m_nOffY);
		if(nNewW != wnd.getW() || nNewH != wnd.getH())
		{
			wnd.setSize(nNewW, nNewH);
			wnd.update();
			wnd.draw();
		}
	}

	private function onResize(wnd:pseudo.BaseWindow):Void
	{
		if(m_layerResize)
			m_look.drawResizeFrame(
				m_layerResize, wnd._x, wnd._y,
				getWndW(wnd, _xmouse - wnd._x - m_nOffX),
				getWndH(wnd, _ymouse - wnd._y - m_nOffY)
			);
	}
}